GNU troff
*********

This manual documents GNU `troff' version 1.18.

   Copyright (C) 1994-2000, 2001, 2002 Free Software Foundation, Inc.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with no Invariant Sections, with the Front-Cover texts
     being `A GNU Manual," and with the Back-Cover Texts as in (a)
     below.  A copy of the license is included in the section entitled
     `GNU Free Documentation License."

     (a) The FSF's Back-Cover Text is: `You have freedom to copy and
     modify this GNU Manual, like GNU software.  Copies published by
     the Free Software Foundation raise funds for GNU development."

Introduction
************

   GNU `troff' (or `groff') is a system for typesetting documents.
`troff' is very flexible and has been in existence (and use) for about
3 decades.  It is quite widespread and firmly entrenched in the UNIX
community.

What Is `groff'?
================

   `groff' belongs to an older generation of document preparation
systems, which operate more like compilers than the more recent
interactive WYSIWYG(1) (1) systems.
`groff' and its contemporary counterpart, TeX, both work using a
"batch" paradigm: The input (or "source") files are normal text files
with embedded formatting commands.  These files can then be processed
by `groff' to produce a typeset document on a variety of devices.

   Likewise, `groff' should not be confused with a "word processor",
since that term connotes an integrated system that includes an editor
and a text formatter.  Also, many word processors follow the WYSIWYG
paradigm discussed earlier.

   Although WYSIWYG systems may be easier to use, they have a number of
disadvantages compared to `troff':

   * They must be used on a graphics display to work on a document.

   * Most of the WYSIWYG systems are either non-free or are not very
     portable.

   * `troff' is firmly entrenched in all UNIX systems.

   * It is difficult to have a wide range of capabilities available
     within the confines of a GUI/window system.

   * It is more difficult to make global changes to a document.

     "GUIs normally make it simple to accomplish simple actions and
     impossible to accomplish complex actions."  -Doug Gwyn (22/Jun/91
     in `comp.unix.wizards')

   (1) What You See Is What You Get

History
=======

   `troff' can trace its origins back to a formatting program called
`runoff', written by J. E. Saltzer, which ran on MIT's CTSS operating
system in the mid-sixties.  This name came from the common phrase of
the time "I'll run off a document."  Bob Morris ported it to the 635
architecture and called the program `roff' (an abbreviation of
`runoff').  It was rewritten as `rf' for the PDP-7 (before having
UNIX), and at the same time (1969), Doug McIllroy rewrote an extended
and simplified version of `roff' in the BCPL programming language.

   The first version of UNIX was developed on a PDP-7 which was sitting
around Bell Labs.  In 1971 the developers wanted to get a PDP-11 for
further work on the operating system.  In order to justify the cost for
this system, they proposed that they would implement a document
formatting system for the AT&T patents division.  This first formatting
program was a reimplementation of McIllroy's `roff', written by
J. F. Ossanna.

   When they needed a more flexible language, a new version of `roff'
called `nroff' ("Newer `roff'") was written.  It had a much more
complicated syntax, but provided the basis for all future versions.
When they got a Graphic Systems CAT Phototypesetter, Ossanna wrote a
version of `nroff' that would drive it.  It was dubbed `troff', for
"typesetter `roff'", although many people have speculated that it
actually means "Times `roff'" because of the use of the Times font
family in `troff' by default.  As such, the name `troff' is pronounced
`t-roff' rather than `trough'.

   With `troff' came `nroff' (they were actually the same program
except for some `#ifdef's), which was for producing output for line
printers and character terminals.  It understood everything `troff'
did, and ignored the commands which were not applicable (e.g. font
changes).

   Since there are several things which cannot be done easily in
`troff', work on several preprocessors began.  These programs would
transform certain parts of a document into `troff', which made a very
natural use of pipes in UNIX.

   The `eqn' preprocessor allowed mathematical formulae to be specified
in a much simpler and more intuitive manner.  `tbl' is a preprocessor
for formatting tables.  The `refer' preprocessor (and the similar
program, `bib') processes citations in a document according to a
bibliographic database.

   Unfortunately, Ossanna's `troff' was written in PDP-11 assembly
language and produced output specifically for the CAT phototypesetter.
He rewrote it in C, although it was now 7000 lines of uncommented code
and still dependent on the CAT.  As the CAT became less common, and was
no longer supported by the manufacturer, the need to make it support
other devices became a priority.  However, before this could be done,
Ossanna was killed in a car accident.

   So, Brian Kernighan took on the task of rewriting `troff'.  The
newly rewritten version produced device independent code which was very
easy for postprocessors to read and translate to the appropriate
printer codes.  Also, this new version of `troff' (called `ditroff' for
"device independent `troff'") had several extensions, which included
drawing functions.

   Due to the additional abilities of the new version of `troff',
several new preprocessors appeared.  The `pic' preprocessor provides a
wide range of drawing functions.  Likewise the `ideal' preprocessor did
the same, although via a much different paradigm.  The `grap'
preprocessor took specifications for graphs, but, unlike other
preprocessors, produced `pic' code.

   James Clark began work on a GNU implementation of `ditroff' in
early 1989.  The first version, `groff' 0.3.1, was released June 1990.
`groff' included:

   * A replacement for `ditroff' with many extensions.

   * The `soelim', `pic', `tbl', and `eqn' preprocessors.

   * Postprocessors for character devices, POSTSCRIPT, TeX DVI, and
     X Windows.  GNU `troff' also eliminated the need for a separate
     `nroff' program with a postprocessor which would produce ASCII
     output.

   * A version of the `me' macros and an implementation of the `man'
     macros.

   Also, a front-end was included which could construct the, sometimes
painfully long, pipelines required for all the post- and preprocessors.

   Development of GNU `troff' progressed rapidly, and saw the additions
of a replacement for `refer', an implementation of the `ms' and `mm'
macros, and a program to deduce how to format a document (`grog').

   It was declared a stable (i.e. non-beta) package with the release of
version 1.04 around November 1991.

   Beginning in 1999, `groff' has new maintainers (the package was an
orphan for a few years).  As a result, new features and programs like
`grn', a preprocessor for gremlin images, and an output device to
produce HTML output have been added.

`groff' Capabilities
====================

   So what exactly is `groff' capable of doing?  `groff' provides a
wide range of low-level text formatting operations.  Using these, it is
possible to perform a wide range of formatting tasks, such as
footnotes, table of contents, multiple columns, etc.  Here's a list of
the most important operations supported by `groff':

   * text filling, adjusting, and centering

   * hyphenation

   * page control

   * font and glyph size control

   * vertical spacing (e.g. double-spacing)

   * line length and indenting

   * macros, strings, diversions, and traps

   * number registers

   * tabs, leaders, and fields

   * input and output conventions and character translation

   * overstrike, bracket, line drawing, and zero-width functions

   * local horizontal and vertical motions and the width function

   * three-part titles

   * output line numbering

   * conditional acceptance of input

   * environment switching

   * insertions from the standard input

   * input/output file switching

   * output and error messages

Macro Packages
==============

   Since `groff' provides such low-level facilities, it can be quite
difficult to use by itself.  However, `groff' provides a "macro"
facility to specify how certain routine operations (e.g. starting
paragraphs, printing headers and footers, etc.) should be done.  These
macros can be collected together into a "macro package".  There are a
number of macro packages available; the most common (and the ones
described in this manual) are `man', `mdoc', `me', `ms', and `mm'.

Preprocessors
=============

   Although `groff' provides most functions needed to format a
document, some operations would be unwieldy (e.g. to draw pictures).
Therefore, programs called "preprocessors" were written which
understand their own language and produce the necessary `groff'
operations.  These preprocessors are able to differentiate their own
input from the rest of the document via markers.

   To use a preprocessor, UNIX pipes are used to feed the output from
the preprocessor into `groff'.  Any number of preprocessors may be used
on a given document; in this case, the preprocessors are linked
together into one pipeline.  However, with `groff', the user does not
need to construct the pipe, but only tell `groff' what preprocessors to
use.

   `groff' currently has preprocessors for producing tables (`tbl'),
typesetting equations (`eqn'), drawing pictures (`pic' and `grn'), and
for processing bibliographies (`refer').  An associated program which
is useful when dealing with preprocessors is `soelim'.

   A free implementation of `grap', a preprocessor for drawing graphs,
can be obtained as an extra package; `groff' can use `grap' also.

   There are other preprocessors in existence, but, unfortunately, no
free implementations are available.  Among them are preprocessors for
drawing mathematical pictures (`ideal') and chemical structures
(`chem').

Output Devices
==============

   `groff' actually produces device independent code which may be fed
into a postprocessor to produce output for a particular device.
Currently, `groff' has postprocessors for POSTSCRIPT devices, character
terminals, X Windows (for previewing), TeX DVI format, HP LaserJet 4
and Canon LBP printers (which use CAPSL), and HTML.

Credits
=======

   Large portions of this manual were taken from existing documents,
most notably, the manual pages for the `groff' package by James Clark,
and Eric Allman's papers on the `me' macro package.

   The section on the `man' macro package is partly based on Susan G.
Kleinmann's `groff_man' manual page written for the Debian GNU/Linux
system.

   Larry Kollar contributed the section in the `ms' macro package.

Invoking `groff'
****************

   This section focuses on how to invoke the `groff' front end.  This
front end takes care of the details of constructing the pipeline among
the preprocessors, `gtroff' and the postprocessor.

   It has become a tradition that GNU programs get the prefix `g' to
distinguish it from its original counterparts provided by the host (see
Environment, for more details).  Thus, for example, `geqn' is
GNU `eqn'.  On operating systems like GNU/Linux or the Hurd, which
don't contain proprietary versions of `troff', and on
MS-DOS/MS-Windows, where `troff' and associated programs are not
available at all, this prefix is omitted since GNU `troff' is the only
used incarnation of `troff'.  Exception: `groff' is never replaced by
`roff'.

   In this document, we consequently say `gtroff' when talking about
the GNU `troff' program.  All other implementations of `troff' are
called AT&T `troff' which is the common origin of all `troff' derivates
(with more or less compatible changes).  Similarly, we say `gpic',
`geqn', etc.

Options
=======

   `groff' normally runs the `gtroff' program and a postprocessor
appropriate for the selected device.  The default device is `ps' (but
it can be changed when `groff' is configured and built).  It can
optionally preprocess with any of `gpic', `geqn', `gtbl', `ggrn',
`grap', `grefer', or `gsoelim'.

   This section only documents options to the `groff' front end.  Many
of the arguments to `groff' are passed on to `gtroff', therefore those
are also included.  Arguments to pre- or postprocessors can be found in
Invoking gpic, Invoking geqn, Invoking gtbl,
Invoking ggrn, Invoking grefer, Invoking gsoelim,
see Invoking grotty, Invoking grops,
Invoking grohtml, Invoking grodvi, Invoking grolj4,
Invoking grolbp, and Invoking gxditview.

   The command line format for `groff' is:

     groff [ -abceghilpstvzCEGNRSUVXZ ] [ -FDIR ] [ -mNAME ]
           [ -TDEF ] [ -fFAM ] [ -wNAME ] [ -WNAME ]
           [ -MDIR ] [ -dCS ] [ -rCN ] [ -nNUM ]
           [ -oLIST ] [ -PARG ] [ -LARG ] [ -IDIR ]
           [ FILES... ]

   The command line format for `gtroff' is as follows.

     gtroff [ -abcivzCERU ] [ -wNAME ] [ -WNAME ] [ -dCS ]
            [ -fFAM ] [ -mNAME ] [ -nNUM ]
            [ -oLIST ] [ -rCN ] [ -TNAME ]
            [ -FDIR ] [ -MDIR ] [ FILES... ]

Obviously, many of the options to `groff' are actually passed on to
`gtroff'.

   Options without an argument can be grouped behind a single `-'.  A
filename of `-' denotes the standard input.  It is possible to have
whitespace between an option and its parameter.

   The `grog' command can be used to guess the correct `groff' command
to format a file.

   Here's the description of the command-line options:

`-h'
     Print a help message.

`-e'
     Preprocess with `geqn'.

`-t'
     Preprocess with `gtbl'.

`-g'
     Preprocess with `ggrn'.

`-G'
     Preprocess with `grap'.

`-p'
     Preprocess with `gpic'.

`-s'
     Preprocess with `gsoelim'.

`-c'
     Suppress color output.

`-R'
     Preprocess with `grefer'.  No mechanism is provided for passing
     arguments to `grefer' because most `grefer' options have
     equivalent commands which can be included in the file.  See
     grefer, for more details.

     Note that `gtroff' also accepts a `-R' option, which is not
     accessible via `groff'.  This option prevents the loading of the
     `troffrc' and `troffrc-end' files.

`-v'
     Make programs run by `groff' print out their version number.

`-V'
     Print the pipeline on `stdout' instead of executing it.

`-z'
     Suppress output from `gtroff'.  Only error messages are printed.

`-Z'
     Do not postprocess the output of `gtroff'.  Normally `groff'
     automatically runs the appropriate postprocessor.

`-PARG'
     Pass ARG to the postprocessor.  Each argument should be passed
     with a separate `-P' option.  Note that `groff' does not prepend
     `-' to ARG before passing it to the postprocessor.

`-l'
     Send the output to a spooler for printing.  The command used for
     this is specified by the `print' command in the device description
     file (see Font Files, for more info).  If not present,
     `-l' is ignored.

`-LARG'
     Pass ARG to the spooler.  Each argument should be passed with a
     separate `-L' option.  Note that `groff' does not prepend a `-' to
     ARG before passing it to the postprocessor.  If the `print'
     keyword in the device description file is missing, `-L' is ignored.

`-TDEV'
     Prepare output for device DEV.  The default device is `ps', unless
     changed when `groff' was configured and built.  The following are
     the output devices currently available:

    `ps'
          For POSTSCRIPT printers and previewers.

    `dvi'
          For TeX DVI format.

    `X75'
          For a 75dpi X11 previewer.

    `X75-12'
          For a 75dpi X11 previewer with a 12pt base font in the
          document.

    `X100'
          For a 100dpi X11 previewer.

    `X100-12'
          For a 100dpi X11 previewer with a 12pt base font in the
          document.

    `ascii'
          For typewriter-like devices using the (7-bit) ASCII character
          set.

    `latin1'
          For typewriter-like devices that support the Latin-1
          (ISO 8859-1) character set.

    `utf8'
          For typewriter-like devices which use the Unicode (ISO 10646)
          character set with UTF-8 encoding.

    `cp1047'
          For typewriter-like devices which use the EBCDIC encoding IBM
          cp1047.

    `lj4'
          For HP LaserJet4-compatible (or other PCL5-compatible)
          printers.

    `lbp'
          For Canon CAPSL printers (LBP-4 and LBP-8 series laser
          printers).

    `html'
          To produce HTML output.  Note that the HTML driver consists
          of two parts, a preprocessor (`pre-grohtml') and a
          postprocessor (`post-grohtml').

     The predefined `gtroff' string register `.T' contains the current
     output device; the read-only number register `.T' is set to 1 if
     this option is used (which is always true if `groff' is used to
     call `gtroff').  See Built-in Registers.

     The postprocessor to be used for a device is specified by the
     `postpro' command in the device description file.  (see Font Files,
     for more info.)  This can be overridden with the `-X'
     option.

`-X'
     Preview with `gxditview' instead of using the usual postprocessor.
     This is unlikely to produce good results except with `-Tps'.

     Note that this is not the same as using `-TX75' or `-TX100' to
     view a document with `gxditview': The former uses the metrics of
     the specified device, whereas the latter uses X-specific fonts and
     metrics.

`-N'
     Don't allow newlines with `eqn' delimiters.  This is the same as
     the `-N' option in `geqn'.

`-S'
     Safer mode.  Pass the `-S' option to `gpic' and disable the
     `open', `opena', `pso', `sy', and `pi' requests.  For security
     reasons, this is enabled by default.

`-U'
     Unsafe mode.  This enables the `open', `opena', `pso', `sy', and
     `pi' requests.

`-a'
     Generate an ASCII approximation of the typeset output.  The
     read-only register `.A' is then set to 1.  See Built-in Registers.
     A typical example is

          groff -a -man -Tdvi troff.man | less

     which shows how lines are broken for the DVI device.  Note that
     this option is rather useless today since graphic output devices
     are available virtually everywhere.

`-b'
     Print a backtrace with each warning or error message.  This
     backtrace should help track down the cause of the error.  The line
     numbers given in the backtrace may not always be correct: `gtroff'
     can get confused by `as' or `am' requests while counting line
     numbers.

`-i'
     Read the standard input after all the named input files have been
     processed.

`-wNAME'
     Enable warning NAME.  Available warnings are described in
     Debugging.  Multiple `-w' options are allowed.

`-WNAME'
     Inhibit warning NAME.  Multiple `-W' options are allowed.

`-E'
     Inhibit all error messages.

`-C'
     Enable compatibility mode.  See Implementation Differences,
     for the list of incompatibilities between `groff' and AT&T `troff'.

`-dCS'
`-dNAME=S'
     Define C or NAME to be a string S.  C must be a one-letter name;
     NAME can be of arbitrary length.  All string assignments happen
     before loading any macro file (including the start-up file).

`-fFAM'
     Use FAM as the default font family.  See Font Families.

`-mNAME'
     Read in the file `NAME.tmac'.  Normally `groff' searches for this
     in its macro directories.  If it isn't found, it tries `tmac.NAME'
     (searching in the same directories).

`-nNUM'
     Number the first page NUM.

`-oLIST'
     Output only pages in LIST, which is a comma-separated list of page
     ranges; `N' means print page N, `M-N' means print every page
     between M and N, `-N' means print every page up to N, `N-' means
     print every page beginning with N.  `gtroff' exits after printing
     the last page in the list.  All the ranges are inclusive on both
     ends.

     Within `gtroff', this information can be extracted with the `.P'
     register.  See Built-in Registers.

     If your document restarts page numbering at the beginning of each
     chapter, then `gtroff' prints the specified page range for each
     chapter.

`-rCN'
`-rNAME=N'
     Set number register C or NAME to the value N.  C must be a
     one-letter name; NAME can be of arbitrary length.  N can be any
     `gtroff' numeric expression.  All register  assignments happen
     before loading any macro file (including the start-up file).

`-FDIR'
     Search `DIR' for subdirectories `devNAME' (NAME is the name of the
     device), for the `DESC' file, and for font files before looking in
     the standard directories (see Font Directories).  This option
     is passed to all pre- and postprocessors using the
     `GROFF_FONT_PATH' environment variable.

`-MDIR'
     Search directory `DIR' for macro files before the standard
     directories (see Macro Directories).

`-IDIR'
     This option is as described in gsoelim.  It implies the
     `-s' option.

Environment
===========

   There are also several environment variables (of the operating
system, not within `gtroff') which can modify the behavior of `groff'.

`GROFF_COMMAND_PREFIX'
     If this is set to X, then `groff' runs `Xtroff' instead of
     `gtroff'.  This also applies to `tbl', `pic', `eqn', `grn',
     `refer', and `soelim'.  It does not apply to `grops', `grodvi',
     `grotty', `pre-grohtml', `post-grohtml', `grolj4', and `gxditview'.

     The default command prefix is determined during the installation
     process.  If a non-GNU troff system is found, prefix `g' is used,
     none otherwise.

`GROFF_TMAC_PATH'
     A colon-separated list of directories in which to search for macro
     files (before the default directories are tried).  See Macro Directories.

`GROFF_TYPESETTER'
     The default output device.

`GROFF_FONT_PATH'
     A colon-separated list of directories in which to search for the
     `dev'NAME directory (before the default directories are tried).
     See Font Directories.

`GROFF_BIN_PATH'
     This search path, followed by `PATH', is used for commands executed
     by `groff'.

`GROFF_TMPDIR'
     The directory in which `groff' creates temporary files.  If this is
     not set and `TMPDIR' is set, temporary files are created in that
     directory.  Otherwise temporary files are created in a
     system-dependent default directory (on Unix and GNU/Linux systems,
     this is usually `/tmp').  `grops', `grefer', `pre-grohtml', and
     `post-grohtml' can create temporary files in this directory.

   Note that MS-DOS and MS-Windows ports of `groff' use semi-colons,
rather than colons, to separate the directories in the lists described
above.

Macro Directories
=================

   All macro file names must be named `NAME.tmac' or `tmac.NAME' to
make the `-mNAME' command line option work.  The `mso' request doesn't
have this restriction; any file name can be used, and `gtroff' won't
try to append or prepend the `tmac' string.

   Macro files are kept in the "tmac directories", all of which
constitute the "tmac path".  The elements of the search path for macro
files are (in that order):

   * The directories specified with `gtroff''s or `groff''s `-M'
     command line option.

   * The directories given in the `GROFF_TMAC_PATH' environment
     variable.

   * The current directory (only if in unsafe mode using the `-U'
     command line switch).

   * The home directory.

   * A platform-dependent directory, a site-specific
     (platform-independent) directory, and the main tmac directory; the
     default locations are

          /usr/local/lib/groff/site-tmac
          /usr/local/share/groff/site-tmac
          /usr/local/share/groff/1.18/tmac

     assuming that the version of `groff' is 1.18, and the installation
     prefix was `/usr/local'.  It is possible to fine-tune those
     directories during the installation process.

Font Directories
================

   Basically, there is no restriction how font files for `groff' are
named and how long font names are; however, to make the font family
mechanism work (see Font Families), fonts within a family should
start with the family name, followed by the shape.  For example, the
Times family uses `T' for the family name and `R', `B', `I', and `BI'
to indicate the shapes `roman', `bold', `italic', and `bold italic',
respectively.  Thus the final font names are `TR', `TB', `TI', and
`TBI'.

   All font files are kept in the "font directories" which constitute
the "font path".  The file search functions will always append the
directory `dev'NAME, where NAME is the name of the output device.
Assuming, say, DVI output, and `/foo/bar' as a font directory, the font
files for `grodvi' must be in `/foo/bar/devdvi'.

   The elements of the search path for font files are (in that order):

   * The directories specified with `gtroff''s or `groff''s `-F'
     command line option.  All device drivers and some preprocessors
     also have this option.

   * The directories given in the `GROFF_FONT_PATH' environment
     variable.

   * A site-specific directory and the main font directory; the default
     locations are

          /usr/local/share/groff/site-font
          /usr/local/share/groff/1.18/font

     assuming that the version of `groff' is 1.18, and the installation
     prefix was `/usr/local'.  It is possible to fine-tune those
     directories during the installation process.

Invocation Examples
===================

   This section lists several common uses of `groff' and the
corresponding command lines.

     groff file

This command processes `file' without a macro package or a
preprocessor.  The output device is the default, `ps', and the output
is sent to `stdout'.

     groff -t -mandoc -Tascii file | less

This is basically what a call to the `man' program does.  `gtroff'
processes the manual page `file' with the `mandoc' macro file (which in
turn either calls the `man' or the `mdoc' macro package), using the
`tbl' preprocessor and the ASCII output device.  Finally, the `less'
pager displays the result.

     groff -X -m me file

Preview `file' with `gxditview', using the `me' macro package.  Since
no `-T' option is specified, use the default device (`ps').  Note that
you can either say `-m me' or `-me'; the latter is an anachronism from
the early days of UNIX.(1) (1)

     groff -man -rD1 -z file

Check `file' with the `man' macro package, forcing double-sided
printing - don't produce any output.

   (1) The same is true for the other main macro packages that come
with `groff': `man', `mdoc', `ms', `mm', and `mandoc'.  This won't work
in general; for example, to load `trace.tmac', either `-mtrace' or
`-m trace' must be used.

`grog'
------

   `grog' reads files, guesses which of the `groff' preprocessors
and/or macro packages are required for formatting them, and prints the
`groff' command including those options on the standard output.  It
generates one or more of the options `-e', `-man', `-me', `-mm',
`-mom', `-ms', `-mdoc', `-mdoc-old', `-p', `-R', `-g', `-G', `-s', and
`-t'.

   A special file name `-' refers to the standard input.  Specifying no
files also means to read the standard input.  Any specified options are
included in the printed command.  No space is allowed between options
and their arguments.  The only options recognized are `-C' (which is
also passed on) to enable compatibility mode, and `-v' to print the
version number and exit.

   For example,

     grog -Tdvi paper.ms

guesses the appropriate command to print `paper.ms' and then prints it
to the command line after adding the `-Tdvi' option.  For direct
execution, enclose the call to `grog' in backquotes at the UNIX shell
prompt:

     `grog -Tdvi paper.ms` > paper.dvi

As seen in the example, it is still necessary to redirect the output to
something meaningful (i.e. either a file or a pager program like
`less').

Tutorial for Macro Users
************************

   Most users tend to use a macro package to format their papers.  This
means that the whole breadth of `groff' is not necessary for most
people.  This chapter covers the material needed to efficiently use a
macro package.

Basics
======

   This section covers some of the basic concepts necessary to
understand how to use a macro package.(1) (1)
References are made throughout to more detailed information, if desired.

   `gtroff' reads an input file prepared by the user and outputs a
formatted document suitable for publication or framing.  The input
consists of text, or words to be printed, and embedded commands
("requests" and "escapes"), which tell `gtroff' how to format the
output.  For more detail on this, see Embedded Commands.

   The word "argument" is used in this chapter to mean a word or number
which appears on the same line as a request, and which modifies the
meaning of that request.  For example, the request

     .sp

spaces one line, but

     .sp 4

spaces four lines.  The number 4 is an argument to the `sp' request
which says to space four lines instead of one.  Arguments are separated
from the request and from each other by spaces (_no_ tabs).  More
details on this can be found in Request Arguments.

   The primary function of `gtroff' is to collect words from input
lines, fill output lines with those words, justify the right-hand margin
by inserting extra spaces in the line, and output the result.  For
example, the input:

     Now is the time
     for all good men
     to come to the aid
     of their party.
     Four score and seven
     years ago, etc.

is read, packed onto output lines, and justified to produce:

     Now is the time for all good men to come to the aid of their party.
     Four score and seven years ago, etc.

   Sometimes a new output line should be started even though the current
line is not yet full; for example, at the end of a paragraph.  To do
this it is possible to cause a "break", which starts a new output line.
Some requests cause a break automatically, as normally do blank input
lines and input lines beginning with a space.

   Not all input lines are text to be formatted.  Some input lines are
requests which describe how to format the text.  Requests always have a
period (`.') or an apostrophe (`'') as the first character of the input
line.

   The text formatter also does more complex things, such as
automatically numbering pages, skipping over page boundaries, putting
footnotes in the correct place, and so forth.

   Here are a few hints for preparing text for input to `gtroff'.

   * First, keep the input lines short.  Short input lines are easier to
     edit, and `gtroff' packs words onto longer lines anyhow.

   * In keeping with this, it is helpful to begin a new line after every
     comma or phrase, since common corrections are to add or delete
     sentences or phrases.

   * End each sentence with two spaces - or better, start each sentence
     on a new line.  `gtroff' recognizes characters that usually end a
     sentence, and inserts sentence space accordingly.

   * Do not hyphenate words at the end of lines - `gtroff' is smart
     enough to hyphenate words as needed, but is not smart enough to
     take hyphens out and join a word back together.  Also, words such
     as "mother-in-law" should not be broken over a line, since then a
     space can occur where not wanted, such as "mother- in-law".

   `gtroff' double-spaces output text automatically if you use the
request `.ls 2'.  Reactivate single-spaced mode by typing `.ls 1'.(2)
(2)

   A number of requests allow to change the way the output looks,
sometimes called the "layout" of the output page.  Most of these
requests adjust the placing of "whitespace" (blank lines or spaces).

   The `bp' request starts a new page, causing a line break.

   The request `.sp N' leaves N lines of blank space.  N can be omitted
(meaning skip a single line) or can be of the form Ni (for N inches) or
Nc (for N centimeters).  For example, the input:

     .sp 1.5i
     My thoughts on the subject
     .sp

leaves one and a half inches of space, followed by the line "My
thoughts on the subject", followed by a single blank line (more
measurement units are available, see Measurements).

   Text lines can be centered by using the `ce' request.  The line
after `ce' is centered (horizontally) on the page.  To center more than
one line, use `.ce N' (where N is the number of lines to center),
followed by the N lines.  To center many lines without counting them,
type:

     .ce 1000
     lines to center
     .ce 0

The `.ce 0' request tells `groff' to center zero more lines, in other
words, stop centering.

   All of these requests cause a break; that is, they always start a new
line.  To start a new line without performing any other action, use
`br'.

   (1) This section is derived from `Writing Papers with nroff using
-me' by Eric P. Allman.

   (2) If you need finer granularity of the vertical space, use the
`pvs' request (see Changing Type Sizes).

Common Features
===============

   `gtroff' provides very low-level operations for formatting a
document.  There are many common routine operations which are done in
all documents.  These common operations are written into "macros" and
collected into a "macro package".

   All macro packages provide certain common capabilities which fall
into the following categories.

Paragraphs
----------

   One of the most common and most used capability is starting a
paragraph.  There are a number of different types of paragraphs, any of
which can be initiated with macros supplied by the macro package.
Normally, paragraphs start with a blank line and the first line
indented, like the text in this manual.  There are also block style
paragraphs, which omit the indentation:

     Some   men  look   at  constitutions   with  sanctimonious
     reverence, and deem them like the ark of the covenant, too
     sacred to be touched.

And there are also indented paragraphs which begin with a tag or label
at the margin and the remaining text indented.

     one   This is  the first paragraph.  Notice  how the first
           line of  the resulting  paragraph lines up  with the
           other lines in the paragraph.

     longlabel
           This  paragraph   had  a  long   label.   The  first
           character of text on the first line does not line up
           with  the  text  on  second  and  subsequent  lines,
           although they line up with each other.

   A variation of this is a bulleted list.

     .     Bulleted lists start with a bullet.   It is possible
           to use other glyphs instead of the bullet.  In nroff
           mode using the ASCII character set for output, a dot
           is used instead of a real bullet.

Sections and Chapters
---------------------

   Most macro packages supply some form of section headers.  The
simplest kind is simply the heading on a line by itself in bold type.
Others supply automatically numbered section heading or different
heading styles at different levels.  Some, more sophisticated, macro
packages supply macros for starting chapters and appendices.

Headers and Footers
-------------------

   Every macro package gives some way to manipulate the "headers" and
"footers" (also called "titles") on each page.  This is text put at the
top and bottom of each page, respectively, which contain data like the
current page number, the current chapter title, and so on.  Its
appearance is not affected by the running text.  Some packages allow
for different ones on the even and odd pages (for material printed in a
book form).

   The titles are called "three-part titles", that is, there is a
left-justified part, a centered part, and a right-justified part.  An
automatically generated page number may be put in any of these fields
with the `%' character (see Page Layout, for more details).

Page Layout
-----------

   Most macro packages let the user specify top and bottom margins and
other details about the appearance of the printed pages.

Displays
--------

   "Displays" are sections of text to be set off from the body of the
paper.  Major quotes, tables, and figures are types of displays, as are
all the examples used in this document.

   "Major quotes" are quotes which are several lines long, and hence
are set in from the rest of the text without quote marks around them.

   A "list" is an indented, single-spaced, unfilled display.  Lists
should be used when the material to be printed should not be filled and
justified like normal text, such as columns of figures or the examples
used in this paper.

   A "keep" is a display of lines which are kept on a single page if
possible.  An example for a keep might be a diagram.  Keeps differ from
lists in that lists may be broken over a page boundary whereas keeps are
not.

   "Floating keeps" move relative to the text.  Hence, they are good for
things which are referred to by name, such as "See figure 3".  A
floating keep appears at the bottom of the current page if it fits;
otherwise, it appears at the top of the next page.  Meanwhile, the
surrounding text `flows' around the keep, thus leaving no blank areas.

Footnotes and Annotations
-------------------------

   There are a number of requests to save text for later printing.

   "Footnotes" are printed at the bottom of the current page.

   "Delayed text" is very similar to a footnote except that it is
printed when called for explicitly.  This allows a list of references to
appear (for example) at the end of each chapter, as is the convention in
some disciplines.

   Most macro packages which supply this functionality also supply a
means of automatically numbering either type of annotation.

Table of Contents
-----------------

   "Tables of contents" are a type of delayed text having a tag
(usually the page number) attached to each entry after a row of dots.
The table accumulates throughout the paper until printed, usually after
the paper has ended.  Many macro packages provide the ability to have
several tables of contents (e.g. a standard table of contents, a list
of tables, etc).

Indices
-------

   While some macro packages use the term "index", none actually
provide that functionality.  The facilities they call indices are
actually more appropriate for tables of contents.

   To produce a real index in a document, external tools like the
`makeindex' program are necessary.

Paper Formats
-------------

   Some macro packages provide stock formats for various kinds of
documents.  Many of them provide a common format for the title and
opening pages of a technical paper.  The `mm' macros in particular
provide formats for letters and memoranda.

Multiple Columns
----------------

   Some macro packages (but not `man') provide the ability to have two
or more columns on a page.

Font and Size Changes
---------------------

   The built-in font and size functions are not always intuitive, so all
macro packages provide macros to make these operations simpler.

Predefined Strings
------------------

   Most macro packages provide various predefined strings for a variety
of uses; examples are sub- and superscripts, printable dates, quotes and
various special characters.

Preprocessor Support
--------------------

   All macro packages provide support for various preprocessors and may
extend their functionality.

   For example, all macro packages mark tables (which are processed with
`gtbl') by placing them between `TS' and `TE' macros.  The `ms' macro
package has an option, `.TS H', that prints a caption at the top of a
new page (when the table is too long to fit on a single page).

Configuration and Customization
-------------------------------

   Some macro packages provide means of customizing many of the details
of how the package behaves.  This ranges from setting the default type
size to changing the appearance of section headers.

Macro Packages
**************

   This chapter documents the main macro packages that come with
`groff'.

`man'
=====

   This is the most popular and probably the most important macro
package of `groff'.  It is easy to use, and a vast majority of manual
pages are based on it.

Options
-------

   The command line format for using the `man' macros with `groff' is:

     groff -m man [ -rLL=LENGTH ] [ -rLT=LENGTH ]
           [ -rcR=1 ] [ -rC1 ] [ -rD1 ] [ -rPNNN ]
           [ -rSXX ] [ -rXNNN ] [ FILES... ]

It is possible to use `-man' instead of `-m man'.

`-rLL=LENGTH'
     Set line length to LENGTH.  If not specified, the line length
     defaults to 78 en in nroff mode (this is 78 characters per line)
     and 6.5 inch otherwise.

`-rLT=LENGTH'
     Set title length to LENGTH.  If not specified, the title length
     defaults to 78 en in nroff mode (this is 78 characters per line)
     and 6.5 inch otherwise.

`-rcR=1'
     This option (the default if a TTY output device is used) creates a
     single, very long page instead of multiple pages.  Use `-rcR=0' to
     disable it.

`-rC1'
     If more than one manual page is given on the command line, number
     the pages continuously, rather than starting each at 1.

`-rD1'
     Double-sided printing.  Footers for even and odd pages are
     formatted differently.

`-rPNNN'
     Page numbering starts with NNN rather than with 1.

`-rSXX'
     Use XX (which can be 10, 11, or 12pt) as the base document font
     size instead of the default value of 10pt.

`-rXNNN'
     After page NNN, number pages as NNNa, NNNb, NNNc, etc.  For
     example, the option `-rX2' produces the following page numbers: 1,
     2, 2a, 2b, 2c, etc.

Usage
-----

   This section describes the available macros for manual pages.  For
further customization, put additional macros and requests into the file
`man.local' which is loaded immediately after the `man' package.

 - Macro: .TH title section [extra1 [extra2 [extra3]]]
     Set the title of the man page to TITLE and the section to SECTION,
     which must have a value between 1 and 8.  The value of SECTION may
     also have a string appended, e.g. `.pm', to indicate a specific
     subsection of the man pages.

     Both TITLE and SECTION are positioned at the left and right in the
     header line (with SECTION in parentheses immediately appended to
     TITLE.  EXTRA1 is positioned in the middle of the footer line.
     EXTRA2 is positioned at the left in the footer line (or at the
     left on even pages and at the right on odd pages if double-sided
     printing is active).  EXTRA3 is centered in the header line.

     For HTML output, headers and footers are completely suppressed.

     Additionally, this macro starts a new page; the new line number
     is 1 again (except if the `-rC1' option is given on the command
     line) - this feature is intended only for formatting multiple man
     pages; a single man page should contain exactly one `TH' macro at
     the beginning of the file.

 - Macro: .SH [heading]
     Set up an unnumbered section heading sticking out to the left.
     Prints out all the text following `SH' up to the end of the line
     (or the text in the next line if there is no argument to `SH') in
     bold face, one size larger than the base document size.
     Additionally, the left margin for the following text is reset to
     its default value.

 - Macro: .SS [heading]
     Set up an unnumbered (sub)section heading.  Prints out all the text
     following `SS' up to the end of the line (or the text in the next
     line if there is no argument to `SS') in bold face, at the same
     size as the base document size.  Additionally, the left margin for
     the following text is reset to its default value.

 - Macro: .TP [nnn]
     Set up an indented paragraph with label.  The indentation is set to
     NNN if that argument is supplied (the default unit is `n' if
     omitted), otherwise it is set to the default indentation value.

     The first line of text following this macro is interpreted as a
     string to be printed flush-left, as it is appropriate for a label.
     It is not interpreted as part of a paragraph, so there is no
     attempt to fill the first line with text from the following input
     lines.  Nevertheless, if the label is not as wide as the
     indentation, then the paragraph starts at the same line (but
     indented), continuing on the following lines.  If the label is
     wider than the indentation, then the descriptive part of the
     paragraph begins on the line following the label, entirely
     indented.  Note that neither font shape nor font size of the label
     is set to a default value; on the other hand, the rest of the text
     has default font settings.

 - Macro: .LP
 - Macro: .PP
 - Macro: .P
     These macros are mutual aliases.  Any of them causes a line break
     at the current position, followed by a vertical space downwards by
     the amount specified by the `PD' macro.  The font size and shape
     are reset to the default value (10pt roman if no `-rS' option is
     given on the command line).  Finally, the current left margin is
     restored.

 - Macro: .IP [designator [nnn]]
     Set up an indented paragraph, using DESIGNATOR as a tag to mark
     its beginning.  The indentation is set to NNN if that argument is
     supplied (default unit is `n'), otherwise the default indentation
     value is used.  Font size and face of the paragraph (but not the
     designator) are reset to their default values.  To start an
     indented paragraph with a particular indentation but without a
     designator, use `""' (two double quotes) as the first argument of
     `IP'.

     For example, to start a paragraph with bullets as the designator
     and 4 en indentation, write

          .IP \(bu 4

 - Macro: .HP [nnn]
     Set up a paragraph with hanging left indentation.  The indentation
     is set to NNN if that argument is supplied (default unit is `n'),
     otherwise the default indentation value is used.  Font size and
     face are reset to their default values.

 - Macro: .RS [nnn]
     Move the left margin to the right by the value NNN if specified
     (default unit is `n'); otherwise the default indentation value is
     used.  Calls to the `RS' macro can be nested.

 - Macro: .RE [nnn]
     Move the left margin back to level NNN; if no argument is given,
     it moves one level back.  The first level (i.e., no call to `RS'
     yet) has number 1, and each call to `RS' increases the level by 1.

   To summarize, the following macros cause a line break with the
insertion of vertical space (which amount can be changed with the `PD'
macro): `SH', `SS', `TP', `LP' (`PP', `P'), `IP', and `HP'.

   The macros `RS' and `RE' also cause a break but do not insert
vertical space.

   Finally, the macros `SH', `SS', `LP' (`PP', `P'), and `RS' reset the
indentation to its default value.

Macros to set fonts
-------------------

   The standard font is roman; the default text size is 10 point.  If
command line option `-rS=N' is given, use Npt as the default text size.

 - Macro: .SM [text]
     Set the text on the same line or the text on the next line in a
     font that is one point size smaller than the default font.

 - Macro: .SB [text]
     Set the text on the same line or the text on the next line in bold
     face font, one point size smaller than the default font.

 - Macro: .BI text
     Set its arguments alternately in bold face and italic.  Thus,

          .BI this "word and" that

     would set "this" and "that" in bold face, and "word and" in
     italics.

 - Macro: .IB text
     Set its arguments alternately in italic and bold face.

 - Macro: .RI text
     Set its arguments alternately in roman and italic.

 - Macro: .IR text
     Set its arguments alternately in italic and roman.

 - Macro: .BR text
     Set its arguments alternately in bold face and roman.

 - Macro: .RB text
     Set its arguments alternately in roman and bold face.

 - Macro: .B [text]
     Set TEXT in bold face.  If no text is present on the line where
     the macro is called, then the text of the next line appears in bold
     face.

 - Macro: .I [text]
     Set TEXT in italic.  If no text is present on the line where the
     macro is called, then the text of the next line appears in italic.

Miscellaneous macros
--------------------

   The default indentation is 7.2 en for all output devices except for
`grohtml' which ignores indentation.

 - Macro: .DT
     Set tabs every 0.5 inches.  Since this macro is always executed
     during a call to the `TH' macro, it makes sense to call it only if
     the tab positions have been changed.

 - Macro: .PD [nnn]
     Adjust the empty space before a new paragraph (or section).  The
     optional argument gives the amount of space (default unit is `v');
     without parameter, the value is reset to its default value (1 line
     for TTY devices, 0.4v otherwise).

   This affects the macros `SH', `SS', `TP', `LP' (as well as `PP' and
`P'), `IP', and `HP'.

Predefined strings
------------------

   The following strings are defined:

 - String: \*[S]
     Switch back to the default font size.

 - String: \*[R]
     The `registered' sign.

 - String: \*[Tm]
     The `trademark' sign.

 - String: \*[lq]
 - String: \*[rq]
     Left and right quote.  This is equal to `\(lq' and `\(rq',
     respectively.

Preprocessors in `man' pages
----------------------------

   If a preprocessor like `gtbl' or `geqn' is needed, it has become
common usage to make the first line of the man page look like this:

     '\" WORD

Note the single space character after the double quote.  WORD consists
of letters for the needed preprocessors: `e' for `geqn', `r' for
`grefer', `t' for `gtbl'.  Modern implementations of the `man' program
read this first line and automatically call the right preprocessor(s).

`mdoc'
======

   See the `groff_mdoc(7)' man page (type `man groff_mdoc' at the
command line).

`ms'
====

   The `-ms' macros are suitable for reports, letters, books, user
manuals, and so forth.  The package provides macros for cover pages,
section headings, paragraphs, lists, footnotes, pagination, and a table
of contents.

Introduction to `ms'
--------------------

   The original `-ms' macros were included with AT&T `troff' as well as
the `man' macros.  While the `man' package is intended for brief
documents that can be read on-line as well as printed, the `ms' macros
are suitable for longer documents that are meant to be printed rather
than read on-line.

   The `ms' macro package included with `groff' is a complete,
bottom-up re-implementation.  Several macros (specific to AT&T or
Berkeley) are not included, while several new commands are.  See
Differences from AT&T ms, for more information.

General structure of an `ms' document
-------------------------------------

   The `ms' macro package expects a certain amount of structure, but
not as much as packages such as `man' or `mdoc'.

   The simplest documents can begin with a paragraph macro (such as
`LP' or `PP'), and consist of text separated by paragraph macros or
even blank lines.  Longer documents have a structure as follows:

*Document type*
     If you invoke the `RP' (report) macro on the first line of the
     document, `groff' prints the cover page information on its own
     page; otherwise it prints the information on the first page with
     your document text immediately following.  Other document formats
     found in AT&T `troff' are specific to AT&T or Berkeley, and are
     not supported in `groff'.

*Format and layout*
     By setting number registers, you can change your document's type
     (font and size), margins, spacing, headers and footers, and
     footnotes.  See ms Document Control Registers, for more
     details.

*Cover page*
     A cover page consists of a title, the author's name and
     institution, an abstract, and the date.  (1) (1)
     See ms Cover Page Macros, for more
     details.

*Body*
     Following the cover page is your document.  You can use the `ms'
     macros to write reports, letters, books, and so forth.  The
     package is designed for structured documents, consisting of
     paragraphs interspersed with headings and augmented by lists,
     footnotes, tables, and other common constructs.  See ms Body Text,
     for more details.

*Table of contents*
     Longer documents usually include a table of contents, which you
     can invoke by placing the `TC' macro at the end of your document.
     The `ms' macros have minimal indexing facilities, consisting of the
     `IX' macro, which prints an entry on standard error.  Printing the
     table of contents at the end is necessary since `groff' is a
     single-pass text formatter, thus it cannot determine the page
     number of each section until that section has actually been set
     and printed.  Since `ms' output is intended for hardcopy, you can
     manually relocate the pages containing the table of contents
     between the cover page and the body text after printing.

   (1) Actually, only the title is required.

Document control registers
--------------------------

   The following is a list of document control number registers.  For
the sake of consistency, set registers related to margins at the
beginning of your document, or just after the `RP' macro.  You can set
other registers later in your document, but you should keep them
together at the beginning to make them easy to find and edit as
necessary.

Margin Settings
...............

 - Register: \n[PO]
     Defines the page offset (i.e. the left margin).  There is no
     explicit right margin setting; the combination of the `PO' and
     `LL' registers implicitly define the right margin width.

     Effective: next page.

     Default value: 1i.

 - Register: \n[LL]
     Defines the line length (i.e. the width of the body text).

     Effective: next paragraph.

     Default: 6i.

 - Register: \n[LT]
     Defines the title length (i.e. the header and footer width).  This
     is usually the same as `LL', but not necessarily.

     Effective: next paragraph.

     Default: 6i.

 - Register: \n[HM]
     Defines the header margin height at the top of the page.

     Effective: next page.

     Default: 1i.

 - Register: \n[FM]
     Defines the footer margin height at the bottom of the page.

     Effective: next page.

     Default: 1i.

Text Settings
.............

 - Register: \n[PS]
     Defines the point size of the body text.

     Effective: next paragraph.

     Default: 10p.

 - Register: \n[VS]
     Defines the space between lines (line height plus leading).

     Effective: next paragraph.

     Default: 12p.

Paragraph Settings
..................

 - Register: \n[PI]
     Defines the initial indent of a `.PP' paragraph.

     Effective: next paragraph.

     Default: 5n.

 - Register: \n[PD]
     Defines the space between paragraphs.

     Effective: next paragraph.

     Default: 0.3v.

 - Register: \n[QI]
     Defines the indent on both sides of a quoted (`.QP') paragraph.

     Effective: next paragraph.

     Default: 5n.

Footnote Settings
.................

 - Register: \n[FL]
     Defines the length of a footnote.

     Effective: next footnote.

     Default: `\n[LL]' * 5 / 6.

 - Register: \n[FI]
     Defines the footnote indent.

     Effective: next footnote.

     Default: 2n.

 - Register: \n[FF]
     The footnote format:
    `0'
          Prints the footnote number as a superscript; indents the
          footnote (default).

    `1'
          Prints the number followed by a period (like 1.)  and indents
          the footnote.

    `2'
          Like 1, without an indent.

    `3'
          Like 1, but prints the footnote number as a hanging paragraph.

     Effective: next footnote.

     Default: 0.

Miscellaneous Number Registers
..............................

 - Register: \n[MINGW]
     Defines the minimum width between columns in a multi-column
     document.

     Effective: next page.

     Default: 2n.

Cover page macros
-----------------

   Use the following macros to create a cover page for your document in
the order shown.

 - Macro: .RP [`no']
     Specifies the report format for your document.  The report format
     creates a separate cover page.  The default action (no `.RP'
     macro) is to print a subset of the cover page on page 1 of your
     document.

     If you use the word `no' as an optional argument, `groff' prints a
     title page but does not repeat any of the title page information
     (title, author, abstract, etc.)  on page 1 of the document.

 - Macro: .DA [...]
     (optional) Print the current date, or the arguments to the macro
     if any, on the title page (if specified) and in the footers.  This
     is the default for `nroff'.

 - Macro: .ND [...]
     (optional) Print the current date, or the arguments to the macro
     if any, on the title page (if specified) but not in the footers.
     This is the default for `troff'.

 - Macro: .TL
     Specifies the document title.  `groff' collects text following the
     `.TL' macro into the title, until reaching the author name or
     abstract.

 - Macro: .AU
     Specifies the author's name, which appears on the line (or lines)
     immediately following.  You can specify multiple authors as
     follows:

          .AU
          John Doe
          .AI
          University of West Bumblefuzz
          .AU
          Martha Buck
          .AI
          Monolithic Corporation

          ...

 - Macro: .AI
     Specifies the author's institution.  You can specify multiple
     institutions in the same way that you specify multiple authors.

 - Macro: .AB [`no']
     Begins the abstract.  The default is to print the word ABSTRACT,
     centered and in italics, above the text of the abstract.  The word
     `no' as an optional argument suppresses this heading.

 - Macro: .AE
     End the abstract.

   The following is example mark-up for a title page.

     .RP
     .TL
     The Inevitability of Code Bloat
     in Commercial and Free Software
     .AU
     J. Random Luser
     .AI
     University of West Bumblefuzz
     .AB
     This report examines the long-term growth
     of the code bases in two large, popular software
     packages; the free Emacs and the commercial
     Microsoft Word.
     While differences appear in the type or order
     of features added, due to the different
     methodologies used, the results are the same
     in the end.
     .PP
     The free software approach is shown to be
     superior in that while free software can
     become as bloated as commercial offerings,
     free software tends to have fewer serious
     bugs and the added features are in line with
     user demand.
     .AE

     ... the rest of the paper follows ...

Body text
---------

   This section describes macros used to mark up the body of your
document.  Examples include paragraphs, sections, and other groups.

Paragraphs
..........

   The following paragraph types are available.

 - Macro: .PP
     Sets a paragraph with an initial indent.

 - Macro: .LP
     Sets a paragraph with no initial indent.

 - Macro: .QP
     Sets a paragraph that is indented at both left and right margins.
     The effect is identical to the HTML `<BLOCKQUOTE>' element.  The
     next paragraph or heading returns margins to normal.

 - Macro: .XP
     Sets a paragraph whose lines are indented, except for the first
     line.  This is a Berkeley extension.

   The following markup uses all four paragraph macros.

     .NH 2
     Cases used in the study
     .LP
     The following software and versions were
     considered for this report.
     .PP
     For commercial software, we chose
     .B "Microsoft Word for Windows" ,
     starting with version 1.0 through the
     current version (Word 2000).
     .PP
     For free software, we chose
     .B Emacs ,
     from its first appearance as a standalone
     editor through the current version (v20).
     See [Bloggs 2002] for details.
     .QP
     Franklin's Law applied to software:
     software expands to outgrow both
     RAM and disk space over time.
     .LP
     Bibliography:
     .XP
     Bloggs, Joseph R.,
     .I "Everyone's a Critic" ,
     Underground Press, March 2002.
     A definitive work that answers all questions
     and criticisms about the quality and usability of
     free software.

Headings
........

   Use headings to create a hierarchical structure for your document.
The `ms' macros print headings in *bold*, using the same font family
and point size as the body text.

   The following describes the heading macros:

 - Macro: .NH curr-level
 - Macro: .NH S level0 ...
     Numbered heading.  The argument is either a numeric argument to
     indicate the level of the heading, or the letter `S' followed by
     numeric arguments to set the heading level explicitly.

     If you specify heading levels out of sequence, such as invoking
     `.NH 3' after `.NH 1', `groff' prints a warning on standard error.

 - Macro: .SH
     Unnumbered subheading.

Highlighting
............

   The `ms' macros provide a variety of methods to highlight or
emphasize text:

 - Macro: .B [txt [post [pre]]]
     Sets its first argument in *bold type*.  If you specify a second
     argument, `groff' prints it in the previous font after the bold
     text, with no intervening space (this allows you to set
     punctuation after the highlighted text without highlighting the
     punctuation).  Similarly, it prints the third argument (if any) in
     the previous font *before* the first argument.  For example,

          .B foo ) (

     prints (*foo*).

     If you give this macro no arguments, `groff' prints all text
     following in bold until the next highlighting, paragraph, or
     heading macro.

 - Macro: .R [txt [post [pre]]]
     Sets its first argument in roman (or regular) type.  It operates
     similarly to the `B' macro otherwise.

 - Macro: .I [txt [post [pre]]]
     Sets its first argument in _italic type_.  It operates similarly
     to the `B' macro otherwise.

 - Macro: .CW [txt [post [pre]]]
     Sets its first argument in a `constant width face'.  It operates
     similarly to the `B' macro otherwise.

 - Macro: .BI [txt [post [pre]]]
     Sets its first argument in bold italic type.  It operates
     similarly to the `B' macro otherwise.

 - Macro: .BX [txt]
     Prints its argument and draws a box around it.  If you want to box
     a string that contains spaces, use a digit-width space (`\0').

 - Macro: .UL [txt [post]]
     Prints its first argument with an underline.  If you specify a
     second argument, `groff' prints it in the previous font after the
     underlined text, with no intervening space.

 - Macro: .LG
     Prints all text following in larger type (two points larger than
     the current point size) until the next font size, highlighting,
     paragraph, or heading macro.  You can specify this macro multiple
     times to enlarge the point size as needed.

 - Macro: .SM
     Prints all text following in smaller type (two points smaller than
     the current point size) until the next type size, highlighting,
     paragraph, or heading macro.  You can specify this macro multiple
     times to reduce the point size as needed.

 - Macro: .NL
     Prints all text following in the normal point size (that is, the
     value of the `PS' register).

Lists
.....

   The `.IP' macro handles duties for all lists.

 - Macro: .IP [marker [width]]
     The MARKER is usually a bullet glyph (`\[bu]') for unordered
     lists, a number (or auto-incrementing number register) for
     numbered lists, or a word or phrase for indented (glossary-style)
     lists.

     The WIDTH specifies the indent for the body of each list item; its
     default unit is `n'.  Once specified, the indent remains the same
     for all list items in the document until specified again.

   The following is an example of a bulleted list.

     A bulleted list:
     .IP \[bu] 2
     lawyers
     .IP \[bu]
     guns
     .IP \[bu]
     money

   Produces:

     A bulleted list:

     o lawyers

     o guns

     o money

   The following is an example of a numbered list.

     .nr step 1 1
     A numbered list:
     .IP \n[step] 3
     lawyers
     .IP \n+[step]
     guns
     .IP \n+[step]
     money

   Produces:

     A numbered list:

     1. lawyers

     2. guns

     3. money

   Note the use of the auto-incrementing number register in this
example.

   The following is an example of a glossary-style list.

     A glossary-style list:
     .IP lawyers 0.4i
     Two or more attorneys.
     .IP guns
     Firearms, preferably
     large-caliber.
     .IP money
     Gotta pay for those
     lawyers and guns!

   Produces:

     A glossary-style list:

     lawyers
           Two or more attorneys.

     guns  Firearms, preferably large-caliber.

     money
           Gotta pay for those lawyers and guns!

   In the last example, the `IP' macro places the definition on the
same line as the term if it has enough space; otherwise, it breaks to
the next line and starts the definition below the term.  This may or
may not be the effect you want, especially if some of the definitions
break and some do not.  The following examples show two possible ways
to force a break.

   The first workaround uses the `br' request to force a break after
printing the term or label.

     A glossary-style list:
     .IP lawyers 0.4i
     Two or more attorneys.
     .IP guns
     .br
     Firearms, preferably large-caliber.
     .IP money
     Gotta pay for those lawyers and guns!

   The second workaround uses the `\p' escape to force the break.  Note
the space following the escape; this is important.  If you omit the
space, `groff' prints the first word on the same line as the term or
label (if it fits) *then* breaks the line.

     A glossary-style list:
     .IP lawyers 0.4i
     Two or more attorneys.
     .IP guns
     \p Firearms, preferably large-caliber.
     .IP money
     Gotta pay for those lawyers and guns!

   To set nested lists, use the `RS' and `RE' macros.  See Indents in ms,
for more information.

   For example:

     .IP \[bu] 2
     Lawyers:
     .RS
     .IP \[bu]
     Dewey,
     .IP \[bu]
     Cheatham,
     .IP \[bu]
     and Howe.
     .RE
     .IP \[bu]
     Guns

   Produces:

     o Lawyers:

       o  Dewey,

       o  Cheatham,

       o  and Howe.

     o Guns

Indents
.......

   In many situations, you may need to indent a section of text while
still wrapping and filling.  See Lists in ms, for an example of
nested lists.

 - Macro: .RS
 - Macro: .RE
     These macros begin and end an indented section.  The `PI' register
     controls the amount of indent, allowing the indented text to line
     up under hanging and indented paragraphs.

   See ms Displays and Keeps, for macros to indent and turn off
filling.

Tab Stops
.........

   Use the `ta' request to define tab stops as needed.  See Tabs and Fields.

 - Macro: .TA
     Use this macro to reset the tab stops to the default for `ms'
     (every 5n).  You can redefine the `TA' macro to create a different
     set of default tab stops.

Displays and keeps
..................

   Use displays to show text-based examples or figures (such as code
listings).

   Displays turn off filling, so lines of code are displayed as-is
without inserting `br' requests in between each line.  Displays can be
"kept" on a single page, or allowed to break across pages.

 - Macro: .DS L
 - Macro: .LD
 - Macro: .DE
     Left-justified display.  The `.DS L' call generates a page break,
     if necessary, to keep the entire display on one page.  The `LD'
     macro allows the display to break across pages.  The `DE' macro
     ends the display.

 - Macro: .DS I
 - Macro: .ID
 - Macro: .DE
     Indents the display as defined by the `DI' register.  The `.DS I'
     call generates a page break, if necessary, to keep the entire
     display on one page.  The `ID' macro allows the display to break
     across pages.  The `DE' macro ends the display.

 - Macro: .DS B
 - Macro: .BD
 - Macro: .DE
     Sets a block-centered display: the entire display is
     left-justified, but indented so that the longest line in the
     display is centered on the page.  The `.DS B' call generates a
     page break, if necessary, to keep the entire display on one page.
     The `BD' macro allows the display to break across pages.  The `DE'
     macro ends the display.

 - Macro: .DS C
 - Macro: .CD
 - Macro: .DE
     Sets a centered display: each line in the display is centered.
     The `.DS C' call generates a page break, if necessary, to keep the
     entire display on one page.  The `CD' macro allows the display to
     break across pages.  The `DE' macro ends the display.

 - Macro: .DS R
 - Macro: .RD
 - Macro: .DE
     Right-justifies each line in the display.  The `.DS R' call
     generates a page break, if necessary, to keep the entire display
     on one page.  The `RD' macro allows the display to break across
     pages.  The `DE' macro ends the display.

   On occasion, you may want to "keep" other text together on a page.
For example, you may want to keep two paragraphs together, or a
paragraph that refers to a table (or list, or other item) immediately
following.  The `ms' macros provide the `KS' and `KE' macros for this
purpose.

 - Macro: .KS
 - Macro: .KE
     The `KS' macro begins a block of text to be kept on a single page,
     and the `KE' macro ends the block.

 - Macro: .KF
 - Macro: .KE
     Specifies a "floating keep"; if the keep cannot fit on the current
     page, `groff' holds the contents of the keep and allows text
     following the keep (in the source file) to fill in the remainder of
     the current page.  When the page breaks, whether by an explicit
     `bp' request or by reaching the end of the page, `groff' prints
     the floating keep at the top of the new page.  This is useful for
     printing large graphics or tables that do not need to appear
     exactly where specified.

   You can also use the `ne' request to force a page break if there is
not enough vertical space remaining on the page.

   Use the following macros to draw a box around a section of text
(such as a display).

 - Macro: .B1
 - Macro: .B2
     Marks the beginning and ending of text that is to have a box drawn
     around it.  The `B1' macro begins the box; the `B2' macro ends it.
     Text in the box is automatically placed in a diversion (keep).

Tables, figures, equations, and references
..........................................

   The `ms' macros support the standard `groff' preprocessors: `tbl',
`pic', `eqn', and `refer'.  You mark text meant for preprocessors by
enclosing it in pairs of tags as follows.

 - Macro: .TS [`H']
 - Macro: .TE
     Denotes a table, to be processed by the `tbl' preprocessor.  The
     optional argument `H' to `TS' instructs `groff' to create a
     running header with the information up to the `TH' macro.  `groff'
     prints the header at the beginning of the table; if the table runs
     onto another page, `groff' prints the header on the next page as
     well.

 - Macro: .PS
 - Macro: .PE
     Denotes a graphic, to be processed by the `pic' preprocessor.  You
     can create a `pic' file by hand, using the AT&T `pic' manual
     available on the Web as a reference, or by using a graphics
     program such as `xfig'.

 - Macro: .EQ [align]
 - Macro: .EN
     Denotes an equation, to be processed by the `eqn' preprocessor.
     The optional ALIGN argument can be `C', `L', or `I' to center (the
     default), left-justify, or indent the equation.

 - Macro: .[
 - Macro: .]
     Denotes a reference, to be processed by the `refer' preprocessor.
     The GNU `refer(1)' man page provides a comprehensive reference to
     the preprocessor and the format of the bibliographic database.

An example multi-page table
...........................

   The following is an example of how to set up a table that may print
across two or more pages.

     .TS H
     allbox expand;
     cb | cb .
     Text      ...of heading...
     _
     .TH
     .T&
     l | l .
     ... the rest of the table follows...
     .CW
     .TE

Footnotes
.........

   The `ms' macro package has a flexible footnote system.  You can
specify either numbered footnotes or symbolic footnotes (that is, using
a marker such as a dagger symbol).

 - String: \*[*]
     Specifies the location of a numbered footnote marker in the text.

 - Macro: .FS
 - Macro: .FE
     Specifies the text of the footnote.  The default action is to
     create a numbered footnote; you can create a symbolic footnote by
     specifying a "mark" glyph (such as `\[dg]' for the dagger glyph)
     in the body text and as an argument to the `FS' macro, followed by
     the text of the footnote and the `FE' macro.

   You can control how `groff' prints footnote numbers by changing the
value of the `FF' register.  See ms Document Control Registers.

Page layout
-----------

   The default output from the `ms' macros provides a minimalist page
layout: it prints a single column, with the page number centered at the
top of each page.  It prints no footers.

   You can change the layout by setting the proper number registers and
strings.

Headers and footers
...................

   For documents that do not distinguish between odd and even pages,
set the following strings:

 - String: \*[LH]
 - String: \*[CH]
 - String: \*[RH]
     Sets the left, center, and right headers.

 - String: \*[LF]
 - String: \*[CF]
 - String: \*[RF]
     Sets the left, center, and right footers.

   For documents that need different information printed in the even
and odd pages, use the following macros:

 - Macro: .OH 'left'center'right'
 - Macro: .EH 'left'center'right'
 - Macro: .OF 'left'center'right'
 - Macro: .EF 'left'center'right'
     The `OH' and `EH' macros define headers for the odd and even pages;
     the `OF' and `EF' macros define footers for the odd and even pages.
     This is more flexible than defining the individual strings.

     You can replace the quote (`'') marks with any character not
     appearing in the header or footer text.

Margins
.......

   You control margins using a set of number registers.  See ms Document Control Registers,
for details.

Multiple columns
................

   The `ms' macros can set text in as many columns as will reasonably
fit on the page.  The following macros are available; all of them force
a page break if a multi-column mode is already set.  However, if the
current mode is single-column, starting a multi-column mode does *not*
force a page break.

 - Macro: .1C
     Single-column mode.

 - Macro: .2C
     Two-column mode.

 - Macro: .MC [width [gutter]]
     Multi-column mode.  If you specify no arguments, it is equivalent
     to the `2C' macro.  Otherwise, WIDTH is the width of each column
     and GUTTER is the space between columns.  The `MINGW' number
     register controls the default gutter width.

Creating a table of contents
............................

   The facilities in the `ms' macro package for creating a table of
contents are semi-automated at best.  Assuming that you want the table
of contents to consist of the document's headings, you need to repeat
those headings wrapped in `XS' and `XE' macros.

 - Macro: .XS [page]
 - Macro: .XA [page]
 - Macro: .XE
     These macros define a table of contents or an individual entry in
     the table of contents, depending on their use.  The macros are
     very simple; they cannot indent a heading based on its level.  The
     easiest way to work around this is to add tabs to the table of
     contents string.  The following is an example:

          .NH 1
          Introduction
          .XS
          Introduction
          .XE
          .LP
          ...
          .CW
          .NH 2
          Methodology
          .XS
          	Methodology
          .XE
          .LP
          ...

     You can manually create a table of contents by beginning with the
     `XS' macro for the first entry, specifying the page number for
     that entry as the argument to `XS'.  Add subsequent entries using
     the `XA' macro, specifying the page number for that entry as the
     argument to `XA'.  The following is an example:

          .XS 1
          Introduction
          .XA 2
          A Brief History of the Universe
          .XA 729
          Details of Galactic Formation
          ...
          .XE

 - Macro: .TC [`no']
     Prints the table of contents on a new page, setting the page
     number to *i* (Roman numeral one).  You should usually place this
     macro at the end of the file, since `groff' is a single-pass
     formatter and can only print what has been collected up to the
     point that the `TC' macro appears.

     The optional argument `no' suppresses printing the title specified
     by the string register `TOC'.

 - Macro: .PX [`no']
     Prints the table of contents on a new page, using the current page
     numbering sequence.  Use this macro to print a manually-generated
     table of contents at the beginning of your document.

     The optional argument `no' suppresses printing the title specified
     by the string register `TOC'.

   The `Groff and Friends HOWTO' includes a `sed' script that
automatically inserts `XS' and `XE' macro entries after each heading in
a document.

   Altering the `NH' macro to automatically build the table of contents
is perhaps initially more difficult, but would save a great deal of
time in the long run if you use `ms' regularly.

Strings and Special Characters
..............................

   The `ms' macros provide the following predefined strings.  You can
change the string definitions to help in creating documents in
languages other than English.

 - String: \*[REFERENCES]
     Contains the string printed at the beginning of the references
     (bibliography) page.  The default is `References'.

 - String: \*[ABSTRACT]
     Contains the string printed at the beginning of the abstract.  The
     default is `ABSTRACT'.

 - String: \*[TOC]
     Contains the string printed at the beginning of the table of
     contents.

 - String: \*[MONTH1]
 - String: \*[MONTH2]
 - String: \*[MONTH3]
 - String: \*[MONTH4]
 - String: \*[MONTH5]
 - String: \*[MONTH6]
 - String: \*[MONTH7]
 - String: \*[MONTH8]
 - String: \*[MONTH9]
 - String: \*[MONTH10]
 - String: \*[MONTH11]
 - String: \*[MONTH12]
     Prints the full name of the month in dates.  The default is
     `January', `February', etc.

   The following special characters are available(1) (1):

 - String: \*[-]
     Prints an em dash.

 - String: \*[*Q]
 - String: \*[*U]
     Prints typographer's quotes in troff, plain quotes in nroff.  `*Q'
     is the left quote and `*U' is the right quote.

   Improved accent marks are available in the `ms' macros.

 - Macro: .AM
     Specify this macro at the beginning of your document to enable
     extended accent marks and special characters.  This is a Berkeley
     extension.

     To use the accent marks, place them *after* the character being
     accented.

   The following accent marks are available after invoking the `AM'
macro:

 - String: \*[']
     Acute accent.

 - String: \*[`]
     Grave accent.

 - String: \*[^]
     Circumflex.

 - String: \*[,]
     Cedilla.

 - String: \*[~]
     Tilde.

 - String: \*[:]
     Umlaut.

 - String: \*[v]
     Hacek.

 - String: \*[_]
     Macron (overbar).

 - String: \*[.]
     Underdot.

 - String: \*[o]
     Ring above.

   The following are standalone characters available after invoking the
`AM' macro:

 - String: \*[?]
     Upside-down question mark.

 - String: \*[!]
     Upside-down exclamation point.

 - String: \*[8]
     German ss ligature.

 - String: \*[3]
     Yogh.

 - String: \*[Th]
     Uppercase thorn.

 - String: \*[th]
     Lowercase thorn.

 - String: \*[D-]
     Uppercase eth.

 - String: \*[d-]
     Lowercase eth.

 - String: \*[q]
     Hooked o.

 - String: \*[ae]
     Lowercase ae ligature.

 - String: \*[Ae]
     Uppercase AE ligature.

   (1) For an explanation what special characters are see Special Characters.

Differences from AT&T `ms'
--------------------------

   This section lists the (minor) differences between the `groff -ms'
macros and AT&T `troff -ms' macros.

`troff' macros not appearing in `groff'
.......................................

   Macros missing from `groff -ms' are cover page macros specific to
Bell Labs.  The macros known to be missing are:

`.TM'
     Technical memorandum; a cover sheet style

`.IM'
     Internal memorandum; a cover sheet style

`.MR'
     Memo for record; a cover sheet style

`.MF'
     Memo for file; a cover sheet style

`.EG'
     Engineer's notes; a cover sheet style

`.TR'
     Computing Science Tech Report; a cover sheet style

`.OK'
     Other keywords

`.CS'
     Cover sheet information

`.MH'
     A cover sheet macro

`groff' macros not appearing in AT&T `troff'
............................................

   The `groff -ms' macros have a few minor extensions compared to the
AT&T `troff -ms' macros.

 - Macro: .AM
     Improved accent marks.  See ms Strings and Special Characters,
     for details.

 - Macro: .DS I
     Indented display.  The default behavior of AT&T `troff -ms' was to
     indent; the `groff' default prints displays flush left with the
     body text.

 - Macro: .CW
     Print text in `constant width' (Courier) font.

 - Macro: .IX
     Indexing term (printed on standard error).  You can write a script
     to capture and process an index generated in this manner.

   The following additional number registers appear in `groff -ms':

 - Register: \n[MINGW]
     Specifies a minimum space between columns (for multi-column
     output); this takes the place of the `GW' register that was
     documented but apparently not implemented in AT&T `troff'.

   Several new string registers are available as well.  You can change
these to handle (for example) the local language.  See ms Strings and Special Characters,
for details.

`me'
====

   See the `meintro.me' and `meref.me' documents in groff's `doc'
directory.

`mm'
====

   See the `groff_mm(7)' man page (type `man groff_mm' at the command
line).

`gtroff' Reference
******************

   This chapter covers *all* of the facilities of `gtroff'.  Users of
macro packages may skip it if not interested in details.

Text
====

   `gtroff' input files contain text with control commands interspersed
throughout.  But, even without control codes, `gtroff' still does
several things with the input text:

   * filling and adjusting

   * adding additional space after sentences

   * hyphenating

   * inserting implicit line breaks

Filling and Adjusting
---------------------

   When `gtroff' reads text, it collects words from the input and fits
as many of them together on one output line as it can.  This is known as
"filling".

   Once `gtroff' has a "filled" line, it tries to "adjust" it.  This
means it widens the spacing between words until the text reaches the
right margin (in the default adjustment mode).  Extra spaces between
words are preserved, but spaces at the end of lines are ignored.
Spaces at the front of a line cause a "break" (breaks are explained in
Implicit Line Breaks).

   See Manipulating Filling and Adjusting.

Hyphenation
-----------

   Since the odds are not great for finding a set of words, for every
output line, which fit nicely on a line without inserting excessive
amounts of space between words, `gtroff' hyphenates words so that it
can justify lines without inserting too much space between words.  It
uses an internal hyphenation algorithm (a simplified version of the
algorithm used within TeX) to indicate which words can be hyphenated
and how to do so.  When a word is hyphenated, the first part of the
word is added to the current filled line being output (with an attached
hyphen), and the other portion is added to the next line to be filled.

   See Manipulating Hyphenation.

Sentences
---------

   Although it is often debated, some typesetting rules say there
should be different amounts of space after various punctuation marks.
For example, the `Chicago typsetting manual' says that a period at the
end of a sentence should have twice as much space following it as would
a comma or a period as part of an abbreviation.

   `gtroff' does this by flagging certain characters (normally `!',
`?', and `.') as "end-of-sentence" characters.  When `gtroff'
encounters one of these characters at the end of a line, it appends a
normal space followed by a "sentence space" in the formatted output.
(This justifies one of the conventions mentioned in Input Conventions.)

   In addition, the following characters and symbols are treated
transparently while handling end-of-sentence characters: `"', `'', `)',
`]', `*', `\[dg]', and `\[rq]'.

   See the `cflags' request in Using Symbols, for more details.

   To prevent the insertion of extra space after an end-of-sentence
character (at the end of a line), append `\&'.

Tab Stops
---------

   `gtroff' translates "tabulator characters", also called "tabs"
(normally code point ASCII `0x09' or EBCDIC `0x05'), in the input into
movements to the next tabulator stop.  These tab stops are initially
located every half inch across the page.  Using this, simple tables can
be made easily.  However, it can often be deceptive as the appearance
(and width) of the text on a terminal and the results from `gtroff' can
vary greatly.

   Also, a possible sticking point is that lines beginning with tab
characters are still filled, again producing unexpected results.  For
example, the following input

           1          2          3
                      4          5

produces

           1          2          3                     4          5

   See Tabs and Fields.

Implicit Line Breaks
--------------------

   An important concept in `gtroff' is the "break".  When a break
occurs, `gtroff' outputs the partially filled line (unjustified), and
resumes collecting and filling text on the next output line.

   There are several ways to cause a break in `gtroff'.  A blank line
not only causes a break, but it also outputs a one-line vertical space
(effectively a blank line).  Note that this behaviour can be modified
with the blank line macro request `blm'.  See Blank Line Traps.

   A line that begins with a space causes a break and the space is
output at the beginning of the next line.  Note that this space isn't
adjusted, even in fill mode.

   The end of file also causes a break - otherwise the last line of the
document may vanish!

   Certain requests also cause breaks, implicitly or explicitly.  This
is discussed in Manipulating Filling and Adjusting.

Input Conventions
=================

   Since `gtroff' does filling automatically, it is traditional in
`groff' not to try and type things in as nicely formatted paragraphs.
These are some conventions commonly used when typing `gtroff' text:

   * Break lines after punctuation, particularly at the end of a
     sentence and in other logical places.  Keep separate phrases on
     lines by themselves, as entire phrases are often added or deleted
     when editing.

   * Try to keep lines less than 40-60 characters, to allow space for
     inserting more text.

   * Do not try to do any formatting in a WYSIWYG manner (i.e., don't
     try using spaces to get proper indentation).

Measurements
============

   `gtroff' (like many other programs) requires numeric parameters to
specify various measurements.  Most numeric parameters(1) (
1) may have a "measurement unit" attached.
These units are specified as a single character which immediately
follows the number or expression.  Each of these units are understood,
by `gtroff', to be a multiple of its "basic unit".  So, whenever a
different measurement unit is specified `gtroff' converts this into its
"basic units".  This basic unit, represented by a `u', is a device
dependent measurement which is quite small, ranging from 1/75th to
1/72000th of an inch.  The values may be given as fractional numbers;
however, fractional basic units are always rounded to integers.

   Some of the measurement units are completely independent of any of
the current settings (e.g. type size) of `gtroff'.

`i'
     Inches.  An antiquated measurement unit still in use in certain
     backwards countries with incredibly low-cost computer equipment.
     One inch is equal to 2.54cm.

`c'
     Centimeters.  One centimeter is equal to 0.3937in.

`p'
     Points.  This is a typesetter's measurement used for measure type
     size.  It is 72 points to an inch.

`P'
     Pica.  Another typesetting measurement.  6 Picas to an inch (and
     12 points to a pica).

`s'
`z'
     See Fractional Type Sizes, for a discussion of these units.

`f'
     Fractions. Value is 65536.  See Colors, for usage.

   The other measurements understood by `gtroff' depend on settings
currently in effect in `gtroff'.  These are very useful for specifying
measurements which should look proper with any size of text.

`m'
     Ems.  This unit is equal to the current font size in points.  So
     called because it is _approximately_ the width of the letter `m'
     in the current font.

`n'
     Ens.  In `groff', this is half of an em.

`v'
     Vertical space.  This is equivalent to the current line spacing.
     See Sizes, for more information about this.

`M'
     100ths of an em.

   (1) those that specify vertical or horizontal motion or a type size

Default Units
-------------

   Many requests take a default unit.  While this can be helpful at
times, it can cause strange errors in some expressions.  For example,
the line length request expects em units.  Here are several attempts to
get a line length of 3.5 inches and their results:

     3.5i      =>   3.5i
     7/2       =>   0i
     7/2i      =>   0i
     (7 / 2)u  =>   0i
     7i/2      =>   0.1i
     7i/2u     =>   3.5i

Everything is converted to basic units first.  In the above example it
is assumed that 1i equals 240u, and 1m equals 10p (thus 1m equals 33u).
The value 7i/2 is first handled as 7i/2m, then converted to 1680u/66u
which is 25u, and this is approximately 0.1i.  As can be seen, a
scaling indicator after a closing parenthesis is simply ignored.

   Thus, the safest way to specify measurements is to always attach a
scaling indicator.  If you want to multiply or divide by a certain
scalar value, use `u' as the unit for that value.

Expressions
===========

   `gtroff' has most arithmetic operators common to other languages:

   * Arithmetic: `+' (addition), `-' (subtraction), `/' (division), `*'
     (multiplication), `%' (modulo).

     `gtroff' only provides integer arithmetic.  The internal type used
     for computing results is `int', which is usually a 32bit signed
     integer.

   * Comparison: `<' (less than), `>' (greater than), `<=' (less than
     or equal), `>=' (greater than or equal), `=' (equal), `==' (the
     same as `=').

   * Logical: `&' (logical and), `:' (logical or).

   * Unary operators: `-' (negating, i.e. changing the sign), `+' (just
     for completeness; does nothing in expressions), `!' (logical not;
     this works only within `if' and `while' requests).  See below for
     the use of unary operators in motion requests.

   * Extrema: `>?' (maximum), `<?' (minimum).

     Example:

          .nr x 5
          .nr y 3
          .nr z (\n[x] >? \n[y])

     The register `z' now contains 5.

   * Scaling: `(C;E)'.  Evaluate E using C as the default scaling
     indicator.  If C is missing, ignore scaling indicators in the
     evaluation of E.

   Parentheses may be used as in any other language.  However, in
`gtroff' they are necessary to ensure order of evaluation.  `gtroff'
has no operator precedence; expressions are evaluated left to right.
This means that `gtroff' evaluates `3+5*4' as if it were parenthesized
like `(3+5)*4', not as `3+(5*4)', as might be expected.

   For many requests which cause a motion on the page, the unary
operators `+' and `-' work differently if leading an expression.  They
then indicate a motion relative to the current position (down or up,
respectively).

   Similarly, a leading `|' operator indicates an absolute position.
For vertical movements, it specifies the distance from the top of the
page; for horizontal movements, it gives the distance from the beginning
of the _input_ line.

   `+' and `-' are also treated differently by the following requests
and escapes: `bp', `in', `ll', `lt', `nm', `nr', `pl', `pn', `po', `ps',
`pvs', `rt', `ti', `\H', `\R', and `\s'.  Here, leading plus and minus
signs indicate increments and decrements.

   See Setting Registers, for some examples.

 - Escape: \B'ANYTHING'
     Return 1 if ANYTHING is a valid numeric expression; or 0 if
     ANYTHING is empty or not a valid numeric expression.

   Due to the way arguments are parsed, spaces are not allowed in
expressions, unless the entire expression is surrounded by parentheses.

   See Request Arguments, and Conditionals and Loops.

Identifiers
===========

   Like any other language, `gtroff' has rules for properly formed
"identifiers".  In `gtroff', an identifier can be made up of almost any
printable character, with the exception of the following characters:

   * Whitespace characters (spaces, tabs, and newlines).

   * Backspace (ASCII `0x08' or EBCDIC `0x16') and character code
     `0x01'.

   * The following input characters are invalid and are ignored if
     `groff' runs on a machine based on ASCII, causing a warning
     message of type `input' (see Debugging, for more details):
     `0x00', `0x0B', `0x0D'-`0x1F', `0x80'-`0x9F'.

     And here are the invalid input characters if `groff' runs on an
     EBCDIC host: `0x00', `0x08', `0x09', `0x0B', `0x0D'-`0x14',
     `0x17'-`0x1F', `0x30'-`0x3F'.

     Currently, some of these reserved codepoints are used internally,
     thus making it non-trivial to extend `gtroff' to cover Unicode or
     other character sets and encodings which use characters of these
     ranges.

     Note that invalid characters are removed before parsing; an
     identifier `foo', followed by an invalid character, followed by
     `bar' is treated as `foobar'.

   For example, any of the following is valid.

     br
     PP
     (l
     end-list
     @_

Note that identifiers longer than two characters with a closing bracket
(`]') in its name can't be accessed with escape sequences which expect
an identifier as a parameter.  For example, `\[foo]]' accesses the
glyph `foo', followed by `]', whereas `\C'foo]'' really asks for glyph
`foo]'.

   To avoid problems with the `refer' preprocessor, macro names should
not start with `[' or `]'.  Due to backwards compatibility, everything
after `.[' and `.]' is handled as a special argument to `refer'.  For
example, `.[foo' makes `refer' to start a reference, using `foo' as a
parameter.

 - Escape: \A'IDENT'
     Test whether an identifier IDENT is valid in `gtroff'.  It expands
     to the character 1 or 0 according to whether its argument (usually
     delimited by quotes) is or is not acceptable as the name of a
     string, macro, diversion, number register, environment, or font.
     It returns 0 if no argument is given.  This is useful for looking
     up user input in some sort of associative table.

          \A'end-list'
              => 1

   See Escapes, for details on parameter delimiting characters.

   Identifiers in `gtroff' can be any length, but, in some contexts,
`gtroff' needs to be told where identifiers end and text begins (and in
different ways depending on their length):

   * Single character.

   * Two characters.  Must be prefixed with `(' in some situations.

   * Arbitrary length (`gtroff' only).  Must be bracketed with `['
     and `]' in some situations.  Any length identifier can be put in
     brackets.

   Unlike many other programming languages, undefined identifiers are
silently ignored or expanded to nothing.  When `gtroff' finds an
undefined identifier, it emits a warning, doing the following:

   * If the identifier is a string, macro, or diversion, `gtroff'
     defines it as empty.

   * If the identifier is a number register, `gtroff' defines it with a
     value of 0.

   See Warnings., see Interpolating Registers, and
Strings.

   Note that macros, strings, and diversions share the same name space.

     .de xxx
     .  nop foo
     ..
     .
     .di xxx
     bar
     .br
     .di
     .
     .xxx
         => bar

As can be seen in the previous example, `gtroff' reuses the identifier
`xxx', changing it from a macro to a diversion.  No warning is emitted!
The contents of the first macro definition is lost.

   See Interpolating Registers, and Strings.

Embedded Commands
=================

   Most documents need more functionality beyond filling, adjusting and
implicit line breaking.  In order to gain further functionality,
`gtroff' allows commands to be embedded into the text, in two ways.

   The first is a "request" which takes up an entire line, and does
some large-scale operation (e.g. break lines, start new pages).

   The other is an "escape" which can be usually embedded anywhere in
the text; most requests can accept it even as an argument.  Escapes
generally do more minor operations like sub- and superscripts, print a
symbol, etc.

Requests
--------

   A request line begins with a control character, which is either a
single quote (`'', the "no-break control character") or a period (`.',
the normal "control character").  These can be changed; see
Character Translations, for details.  After this there may be
optional tabs or spaces followed by an identifier which is the name of
the request.  This may be followed by any number of space-separated
arguments (_no_ tabs here).

   Since a control character followed by whitespace only is ignored, it
is common practice to use this feature for structuring the source code
of documents or macro packages.

     .de foo
     .  tm This is foo.
     ..
     .
     .
     .de bar
     .  tm This is bar.
     ..

   Another possibility is to use the blank line macro request `blm' by
assigning an empty macro to it.

     .de do-nothing
     ..
     .blm do-nothing  \" activate blank line macro

     .de foo
     .  tm This is foo.
     ..

     .de bar
     .  tm This is bar.
     ..

     .blm             \" deactivate blank line macro

   See Blank Line Traps.

   To begin a line with a control character without it being
interpreted, precede it with `\&'.  This represents a zero width space,
which means it does not affect the output.

   In most cases the period is used as a control character.  Several
requests cause a break implicitly; using the single quote control
character prevents this.

Request Arguments
.................

   Arguments to requests (and macros) are processed much like the shell:
The line is split into arguments according to spaces.(1) (1)
An argument which is intended to contain
spaces can either be enclosed in double quotes, or have the spaces
"escaped" with backslashes.

   Here are a few examples:

     .uh The Mouse Problem
     .uh "The Mouse Problem"
     .uh The\ Mouse\ Problem

The first line is the `uh' macro being called with 3 arguments, `The',
`Mouse', and `Problem'.  The latter two have the same effect of calling
the `uh' macro with one argument, `The Mouse Problem'.(2) (
2)

   A double quote which isn't preceded by a space doesn't start a macro
argument.  If not closing a string, it is printed literally.

   For example,

     .xxx a" "b c" "de"fg"

has the arguments `a"', `b c', `de', and `fg"'.  Don't rely on this
obscure behaviour!

   There are two possibilities to get a double quote reliably.

   * Enclose the whole argument with double quotes and use two
     consecutive double quotes to represent a single one.  This
     traditional solution has the disadvantage that double quotes don't
     survive argument expansion again if called in compatibility mode
     (using the `-C' option of `groff'):

          .de xx
          .  tm xx: `\\$1' `\\$2' `\\$3'
          .
          .  yy "\\$1" "\\$2" "\\$3"
          ..
          .de yy
          .  tm yy: `\\$1' `\\$2' `\\$3'
          ..
          .xx A "test with ""quotes""" .
              => xx: `A' `test with "quotes"' `.'
              => yy: `A' `test with ' `quotes""'

     If not in compatibility mode, you get the expected result

          xx: `A' `test with "quotes"' `.'
          yy: `A' `test with "quotes"' `.'

     since `gtroff' preserves the input level.

   * Use the double quote glyph `\(dq'.  This works with and without
     compatibility mode enabled since `gtroff' doesn't convert `\(dq'
     back to a double quote input character.

     Not that this method won't work with UNIX `troff' in general since
     the glyph `dq' isn't defined normally.

   Double quotes in the `ds' request are handled differently.  See
Strings, for more details.

   (1) Plan 9's `troff' implementation also allows tabs for argument
separation - `gtroff' intentionally doesn't support this.

   (2) The last solution, i.e., using escaped spaces, is "classical" in
the sense that it can be found in most `troff' documents.
Nevertheless, it is not optimal in all situations, since `\ ' inserts a
fixed-width, non-breaking space character which can't stretch.
`gtroff' provides a different command `\~' to insert a stretchable,
non-breaking space.

Macros
------

   `gtroff' has a "macro" facility for defining a series of lines which
can be invoked by name.  They are called in the same manner as requests
- arguments also may be passed in the same manner.

   See Writing Macros, and Request Arguments.

Escapes
-------

   Escapes may occur anywhere in the input to `gtroff'.  They usually
begin with a backslash and are followed by a single character which
indicates the function to be performed.  The escape character can be
changed; see Character Translations.

   Escape sequences which require an identifier as a parameter accept
three possible syntax forms.

   * The next single character is the identifier.

   * If this single character is an opening parenthesis, take the
     following two characters as the identifier.  Note that there is no
     closing parenthesis after the identifier.

   * If this single character is an opening bracket, take all characters
     until a closing bracket as the identifier.

Examples:

     \fB
     \n(XX
     \*[TeX]

   Other escapes may require several arguments and/or some special
format.  In such cases the argument is traditionally enclosed in single
quotes (and quotes are always used in this manual for the definitions
of escape sequences).  The enclosed text is then processed according to
what that escape expects.  Example:

     \l'1.5i\(bu'

   Note that the quote character can be replaced with any other
character which does not occur in the argument (even a newline or a
space character) in the following escapes: `\o', `\b', and `\X'.  This
makes e.g.

     A caf
     \o
     e\'

     in Paris
       => A cafe' in Paris

possible, but it is better not to use this feature to avoid confusion.

   The following escapes sequences (which are handled similarly to
characters since they don't take a parameter) are also allowed as
delimiters: `\%', `\ ', `\|', `\^', `\{', `\}', `\'', `\`', `\-', `\_',
`\!', `\?', `\@', `\)', `\/', `\,', `\&', `\:', `\~', `\0', `\a', `\c',
`\d', `\e', `\E', `\p', `\r', `\t', and `\u'.  Again, don't use these
if possible.

   No newline characters as delimiters are allowed in the following
escapes: `\A', `\B', `\Z', `\C', and `\w'.

   Finally, the escapes `\D', `\h', `\H', `\l', `\L', `\N', `\R', `\s',
`\S', `\v', and `\x' can't use the following characters as delimiters:

   * The digits `0'-`9'.

   * The (single-character) operators `+-/*%<>=&:().'.

   * The space, tab, and newline characters.

   * All escape sequences except `\%', `\:', `\{', `\}', `\'', `\`',
     `\-', `\_', `\!', `\@', `\/', `\c', `\e', and `\p'.

   To have a backslash (actually, the current escape character) appear
in the output several escapes are defined: `\\', `\e' or `\E'.  These
are very similar, and only differ with respect to being used in macros
or diversions.  See Character Translations, for an exact
description of those escapes.

   See Implementation Differences, Copy-in Mode, and
Diversions, Identifiers, for more information.

Comments
........

   Probably one of the most(1) (1) common
forms of escapes is the comment.

 - Escape: \"
     Start a comment.  Everything to the end of the input line is
     ignored.

     This may sound simple, but it can be tricky to keep the comments
     from interfering with the appearance of the final output.

     If the escape is to the right of some text or a request, that
     portion of the line is ignored, but the space leading up to it is
     noticed by `gtroff'.  This only affects the `ds' and `as' request
     and its variants.

     One possibly irritating idiosyncracy is that tabs must not be used
     to line up comments.  Tabs are not treated as whitespace between
     the request and macro arguments.

     A comment on a line by itself is treated as a blank line, because
     after eliminating the comment, that is all that remains:

          Test
          \" comment
          Test

     produces

          Test

          Test

     To avoid this, it is common to start the line with `.\"' which
     causes the line to be treated as an undefined request and thus
     ignored completely.

     Another commenting scheme seen sometimes is three consecutive
     single quotes (`'''') at the beginning of a line.  This works, but
     `gtroff' gives a warning about an undefined macro (namely `'''),
     which is harmless, but irritating.

 - Escape: \#
     To avoid all this, `gtroff' has a new comment mechanism using the
     `\#' escape.  This escape works the same as `\"' except that the
     newline is also ignored:

          Test
          \# comment
          Test

     produces

          Test Test

     as expected.

 - Request: .ig yy
     Ignore all input until `gtroff' encounters the macro named `.'YY
     on a line by itself (or `..' if YY is not specified).  This is
     useful for commenting out large blocks of text:

          text text text...
          .ig
          This is part of a large block
          of text that has been
          temporarily(?) commented out.

          We can restore it simply by removing
          the .ig request and the ".." at the
          end of the block.
          ..
          More text text text...

     produces

          text text text...  More text text text...

     Note that the commented-out block of text does not cause a break.

     The input is read in copy-mode; auto-incremented registers _are_
     affected (see Auto-increment).

   (1) Unfortunately, this is a lie.  But hopefully future `gtroff'
hackers will believe it `:-)'

Registers
=========

   Numeric variables in `gtroff' are called "registers".  There are a
number of built-in registers, supplying anything from the date to
details of formatting parameters.

   See Identifiers, for details on register identifiers.

Setting Registers
-----------------

   Define or set registers using the `nr' request or the `\R' escape.

 - Request: .nr ident value
 - Escape: \R'IDENT VALUE'
     Set number register IDENT to VALUE.  If IDENT doesn't exist,
     `gtroff' creates it.

     The argument to `\R' usually has to be enclosed in quotes.  See
     Escapes, for details on parameter delimiting characters.

     The `\R' escape doesn't produce an input token in `gtroff'; with
     other words, it vanishes completely after `gtroff' has processed
     it.

   For example, the following two lines are equivalent:

     .nr a (((17 + (3 * 4))) % 4)
     \R'a (((17 + (3 * 4))) % 4)'
         => 1

   Both `nr' and `\R' have two additional special forms to increment or
decrement a register.

 - Request: .nr ident +value
 - Request: .nr ident -value
 - Escape: \R'IDENT +VALUE'
 - Escape: \R'IDENT -VALUE'
     Increment (decrement) register IDENT by VALUE.

          .nr a 1
          .nr a +1
          \na
              => 2

     To assign the negated value of a register to another register,
     some care must be taken to get the desired result:

          .nr a 7
          .nr b 3
          .nr a -\nb
          \na
              => 4
          .nr a (-\nb)
          \na
              => -3

     The surrounding parentheses prevent the interpretation of the
     minus sign as a decrementing operator.  An alternative is to start
     the assignment with a `0':

          .nr a 7
          .nr b -3
          .nr a \nb
          \na
              => 4
          .nr a 0\nb
          \na
              => -3

 - Request: .rr ident
     Remove number register IDENT.  If IDENT doesn't exist, the request
     is ignored.

 - Request: .rnn ident1 ident2
     Rename number register IDENT1 to IDENT2.  If either IDENT1 or
     IDENT2 doesn't exist, the request is ignored.

 - Request: .aln ident1 ident2
     Create an alias IDENT1 for a number register IDENT2.  The new name
     and the old name are exactly equivalent.  If IDENT1 is undefined,
     a warning of type `reg' is generated, and the request is ignored.
     See Debugging, for information about warnings.

Interpolating Registers
-----------------------

   Numeric registers can be accessed via the `\n' escape.

 - Escape: \nI
 - Escape: \n(ID
 - Escape: \n[IDENT]
     Interpolate number register with name IDENT (one-character name I,
     two-character name ID). This means that the value of the register
     is expanded in-place while `gtroff' is parsing the input line.
     Nested assignments (also called indirect assignments) are possible.

          .nr a 5
          .nr as \na+\na
          \n(as
              => 10

          .nr a1 5
          .nr ab 6
          .ds str b
          .ds num 1
          \n[a\n[num]]
              => 5
          \n[a\*[str]]
              => 6

Auto-increment
--------------

   Number registers can also be auto-incremented and auto-decremented.
The increment or decrement value can be specified with a third argument
to the `nr' request or `\R' escape.

 - Request: .nr ident value incr
     Set number register IDENT to VALUE; the increment for
     auto-incrementing is set to INCR.  Note that the `\R' escape
     doesn't support this notation.

   To activate auto-incrementing, the escape `\n' has a special syntax
form.

 - Escape: \n+I
 - Escape: \n-I
 - Escape: \n(+ID
 - Escape: \n(-ID
 - Escape: \n+(ID
 - Escape: \n-(ID
 - Escape: \n[+IDENT]
 - Escape: \n[-IDENT]
 - Escape: \n+[IDENT]
 - Escape: \n-[IDENT]
     Before interpolating, increment or decrement IDENT (one-character
     name I, two-character name ID) by the auto-increment value as
     specified with the `nr' request (or the `\R' escape).  If no
     auto-increment value has been specified, these syntax forms are
     identical to `\n'.

   For example,

     .nr a 0 1
     .nr xx 0 5
     .nr foo 0 -2
     \n+a, \n+a, \n+a, \n+a, \n+a
     .br
     \n-(xx, \n-(xx, \n-(xx, \n-(xx, \n-(xx
     .br
     \n+[foo], \n+[foo], \n+[foo], \n+[foo], \n+[foo]

produces

     1, 2, 3, 4, 5
     -5, -10, -15, -20, -25
     -2, -4, -6, -8, -10

   To change the increment value without changing the value of a
register (A in the example), the following can be used:

     .nr a \na 10

Assigning Formats
-----------------

   When a register is used in the text of an input file (as opposed to
part of an expression), it is textually replaced (or interpolated) with
a representation of that number.  This output format can be changed to
a variety of formats (numbers, Roman numerals, etc.).  This is done
using the `af' request.

 - Request: .af ident format
     Change the output format of a number register.  The first argument
     IDENT is the name of the number register to be changed, and the
     second argument FORMAT is the output format.  The following output
     formats are available:

    `1'
          Decimal arabic numbers.  This is the default format: 0, 1, 2,
          3, ....

    `0...0'
          Decimal numbers with as many digits as specified.  So, `00'
          would result in printing numbers as 01, 02, 03, ....

          In fact, any digit instead of zero will do; `gtroff' only
          counts how many digits are specified.  As a consequence,
          `af''s default format `1' could be specified as `0' also (and
          exactly this is returned by the `\g' escape, see below).

    `I'
          Upper-case Roman numerals: 0, I, II, III, IV, ....

    `i'
          Lower-case Roman numerals: 0, i, ii, iii, iv, ....

    `A'
          Upper-case letters: 0, A, B, C, ..., Z, AA, AB, ....

    `a'
          Lower-case letters: 0, a, b, c, ..., z, aa, ab, ....

     Omitting the number register format causes a warning of type
     `missing'.  See Debugging, for more details.  Specifying a
     nonexistent format causes an error.

     The following example produces `10, X, j, 010':

          .nr a 10
          .af a 1           \" the default format
          \na,
          .af a I
          \na,
          .af a a
          \na,
          .af a 001
          \na

     The largest number representable for the `i' and `I' formats is
     39999 (or -39999); UNIX `troff' uses `z' and `w' to represent
     10000 and 5000 in Roman numerals, and so does `gtroff'.
     Currently, the correct glyphs of Roman numeral five thousand and
     Roman numeral ten thousand (Unicode code points `U+2182' and
     `U+2181', respectively) are not available.

     If IDENT doesn't exist, it is created.

     Changing the output format of a read-only register causes an
     error.  It is necessary to first copy the register's value to a
     writeable register, then apply the `af' request to this other
     register.

 - Escape: \gI
 - Escape: \g(ID
 - Escape: \g[IDENT]
     Return the current format of the specified register IDENT
     (one-character name I, two-character name ID).  For example, `\ga'
     after the previous example would produce the string `000'.  If the
     register hasn't been defined yet, nothing is returned.

Built-in Registers
------------------

   The following lists some built-in registers which are not described
elsewhere in this manual.  Any register which begins with a `.' is
read-only.  A complete listing of all built-in registers can be found in
appendix Register Index.

`.F'
     This string-valued register returns the current input file name.

`.H'
     Horizontal resolution in basic units.

`.V'
     Vertical resolution in basic units.

`seconds'
     The number of seconds after the minute, normally in the range 0
     to 59, but can be up to 61 to allow for leap seconds.  Initialized
     at start-up of `gtroff'.

`minutes'
     The number of minutes after the hour, in the range 0 to 59.
     Initialized at start-up of `gtroff'.

`hours'
     The number of hours past midnight, in the range 0 to 23.
     Initialized at start-up of `gtroff'.

`dw'
     Day of the week (1-7).

`dy'
     Day of the month (1-31).

`mo'
     Current month (1-12).

`year'
     The current year.

`yr'
     The current year minus 1900.  Unfortunately, the documentation of
     UNIX Version 7's `troff' had a year 2000 bug: It incorrectly
     claimed that `yr' contains the last two digits of the year.  That
     claim has never been true of either AT&T `troff' or GNU `troff'.
     Old `troff' input that looks like this:

          '\" The following line stopped working after 1999
          This document was formatted in 19\n(yr.

     can be corrected as follows:

          This document was formatted in \n[year].

     or, to be portable to older `troff' versions, as follows:

          .nr y4 1900+\n(yr
          This document was formatted in \n(y4.

`.c'
`c.'
     The current _input_ line number.  Register `.c' is read-only,
     whereas `c.' (a `gtroff' extension) is writable also, affecting
     both `.c' and `c.'.

`ln'
     The current _output_ line number after a call to the `nm' request
     to activate line numbering.

     See Miscellaneous, for more information about line numbering.

`.x'
     The major version number.  For example, if the version number
     is 1.03 then `.x' contains `1'.

`.y'
     The minor version number.  For example, if the version number
     is 1.03 then `.y' contains `03'.

`.Y'
     The revision number of `groff'.

`$$'
     The process ID of `gtroff'.

`.g'
     Always 1.  Macros should use this to determine whether they are
     running under GNU `troff'.

`.A'
     If the command line option `-a' is used to produce an ASCII
     approximation of the output, this is set to 1, zero otherwise.
     See Groff Options.

`.P'
     This register is set to 1 (and to 0 otherwise) if the current page
     is actually being printed, i.e., if the `-o' option is being used
     to only print selected pages.  See Groff Options, for more
     information.

`.T'
     If `gtroff' is called with the `-T' command line option, the
     number register `.T' is set to 1, and zero otherwise.  See Groff Options.

     Additionally, `gtroff' predefines a single read-write string
     register `.T' which contains the current output device (for
     example, `latin1' or `ps').

Manipulating Filling and Adjusting
==================================

   Various ways of causing "breaks" were given in Implicit Line Breaks.
The `br' request likewise causes a break.  Several other
requests also cause breaks, but implicitly.  These are `bp', `ce',
`cf', `fi', `fl', `in', `nf', `rj', `sp', `ti', and `trf'.

 - Request: .br
     Break the current line, i.e., the input collected so far is emitted
     without adjustment.

     If the no-break control character is used, `gtroff' suppresses the
     break:

          a
          'br
          b
              => a b

   Initially, `gtroff' fills and adjusts text to both margins.  Filling
can be disabled via the `nf' request and re-enabled with the `fi'
request.

 - Request: .fi
 - Register: \n[.u]
     Activate fill mode (which is the default).  This request implicitly
     enables adjusting; it also inserts a break in the text currently
     being filled.  The read-only number register `.u' is set to 1.

     The fill mode status is associated with the current environment
     (see Environments).

     See Line Control, for interaction with the `\c' escape.

 - Request: .nf
     Activate no-fill mode.  Input lines are output as-is, retaining
     line breaks and ignoring the current line length.  This command
     implicitly disables adjusting; it also causes a break.  The number
     register `.u' is set to 0.

     The fill mode status is associated with the current environment
     (see Environments).

     See Line Control, for interaction with the `\c' escape.

 - Request: .ad [mode]
 - Register: \n[.j]
     Set adjusting mode.

     Activation and deactivation of adjusting is done implicitly with
     calls to the `fi' or `nf' requests.

     MODE can have one of the following values:

    `l'
          Adjust text to the left margin.  This produces what is
          traditionally called ragged-right text.

    `r'
          Adjust text to the right margin, producing ragged-left text.

    `c'
          Center filled text.  This is different to the `ce' request
          which only centers text without filling.

    `b'
    `n'
          Justify to both margins.  This is the default used by
          `gtroff'.

     With no argument, `gtroff' adjusts lines in the same way it did
     before adjusting was deactivated (with a call to `na', for
     example).

          text
          .ad r
          text
          .ad c
          text
          .na
          text
          .ad  \" back to centering
          text

     The current adjustment mode is available in the read-only number
     register `.j'; it can be stored and subsequently used to set
     adjustment.

     The adjustment mode status is associated with the current
     environment (see Environments).

 - Request: .na
     Disable adjusting.  This request won't change the current
     adjustment mode: A subsequent call to `ad' uses the previous
     adjustment setting.

     The adjustment mode status is associated with the current
     environment (see Environments).

 - Request: .brp
 - Escape: \p
     Adjust the current line and cause a break.

     In most cases this produces very ugly results since `gtroff'
     doesn't have a sophisticated paragraph building algorithm (as TeX
     have, for example); instead, `gtroff' fills and adjusts a paragraph
     line by line:

            This is an uninteresting sentence.
            This is an uninteresting sentence.\p
            This is an uninteresting sentence.

     is formatted as

            This is  an uninteresting  sentence.   This  is an
            uninteresting                            sentence.
            This is an uninteresting sentence.

 - Request: .ss word_space_size [sentence_space_size]
 - Register: \n[.ss]
 - Register: \n[.sss]
     Change the minimum size of a space between filled words.  It takes
     its units as one twelfth of the space width parameter for the
     current font.  Initially both the WORD_SPACE_SIZE and
     SENTENCE_SPACE_SIZE are 12.

     If two arguments are given to the `ss' request, the second
     argument sets the sentence space size.  If the second argument is
     not given, sentence space size is set to WORD_SPACE_SIZE.  The
     sentence space size is used in two circumstances: If the end of a
     sentence occurs at the end of a line in fill mode, then both an
     inter-word space and a sentence space are added; if two spaces
     follow the end of a sentence in the middle of a line, then the
     second space is a sentence space.  If a second argument is never
     given to the `ss' request, the behaviour of UNIX `troff' is the
     same as that exhibited by GNU `troff'.  In GNU `troff', as in UNIX
     `troff', a sentence should always be followed by either a newline
     or two spaces.

     The read-only number registers `.ss' and `.sss' hold the values of
     the parameters set by the first and second arguments of the `ss'
     request.

     The word space and sentence space values are associated with the
     current environment (see Environments).

     Contrary to AT&T `troff', this request is _not_ ignored if a TTY
     output device is used; the given values are then rounded down to a
     multiple of 12 (see Implementation Differences).

     The request is ignored if there is no parameter.

 - Request: .ce [nnn]
 - Register: \n[.ce]
     Center text.  While the `.ad c' request also centers text, it
     fills the text as well.  `ce' does not fill the text it affects.
     This request causes a break.  The number of lines still to be
     centered is associated with the current environment (see
     Environments).

     The following example demonstrates the differences.  Here the
     input:

          .ll 4i
          .ce 1000
          This is a small text fragment which shows the differences
          between the `.ce' and the `.ad c' request.
          .ce 0

          .ad c
          This is a small text fragment which shows the differences
          between the `.ce' and the `.ad c' request.

     And here the result:

            This is a small text fragment which
                   shows the differences
          between the `.ce' and the `.ad c' request.

            This is a small text fragment which
          shows the differences between the `.ce'
                  and the `.ad c' request.

     With no arguments, `ce' centers the next line of text.  NNN
     specifies the number of lines to be centered.  If the argument is
     zero or negative, centering is disabled.

     The basic length for centering text is the line length (as set
     with the `ll' request) minus the indentation (as set with the `in'
     request).  Temporary indentation is ignored.

     As can be seen in the previous example, it is a common idiom to
     turn on centering for a large number of lines, and to turn off
     centering after text to be centered.  This is useful for any
     request which takes a number of lines as an argument.

     The `.ce' read-only number register contains the number of lines
     remaining to be centered, as set by the `ce' request.

 - Request: .rj [nnn]
 - Register: \n[.rj]
     Justify unfilled text to the right margin.  Arguments are
     identical to the `ce' request.  The `.rj' read-only number
     register is the number of lines to be right-justified as set by
     the `rj' request.  This request causes a break.  The number of
     lines still to be right-justified is associated with the current
     environment (see Environments).

Manipulating Hyphenation
========================

   As discussed in Hyphenation, `gtroff' hyphenates words.
There are a number of ways to influence hyphenation.

 - Request: .hy [mode]
 - Register: \n[.hy]
     Enable hyphenation.  The request has an optional numeric argument,
     MODE, to restrict hyphenation if necessary:

    `1'
          The default argument if MODE is omitted.  Hyphenate without
          restrictions.  This is also the start-up value of `gtroff'.

    `2'
          Do not hyphenate the last word on a page or column.

    `4'
          Do not hyphenate the last two characters of a word.

    `8'
          Do not hyphenate the first two characters of a word.

     Values in the previous table are additive.  For example, the
     value 12 causes `gtroff' to neither hyphenate the last two nor the
     first two characters of a word.

     The current hyphenation restrictions can be found in the read-only
     number register `.hy'.

     The hyphenation mode is associated with the current environment
     (see Environments).

 - Request: .nh
     Disable hyphenation (i.e., set the hyphenation mode to zero).  Note
     that the hyphenation mode of the last call to `hy' is not
     remembered.

     The hyphenation mode is associated with the current environment
     (see Environments).

 - Request: .hlm [nnn]
 - Register: \n[.hlm]
 - Register: \n[.hlc]
     Set the maximum number of consecutive hyphenated lines to NNN.  If
     this number is negative, there is no maximum.  The default value
     is -1 if NNN is omitted.  This value is associated with the
     current environment (see Environments).  Only lines output
     from a given environment count towards the maximum associated with
     that environment.  Hyphens resulting from `\%' are counted;
     explicit hyphens are not.

     The current setting of `hlm' is available in the `.hlm' read-only
     number register.  Also the number of immediately preceding
     consecutive hyphenated lines are available in the read-only number
     register `.hlc'.

 - Request: .hw word1 word2 ...
     Define how WORD1, WORD2, etc. are to be hyphenated.  The words
     must be given with hyphens at the hyphenation points.  For example:

          .hw in-sa-lub-rious

     Besides the space character, any character whose hyphenation code
     value is zero can be used to separate the arguments of `hw' (see
     the documentation for the `hcode' request below for more
     information).  In addition, this request can be used more than
     once.

     Hyphenation exceptions specified with the `hw' request are
     associated with the current hyphenation language; it causes an
     error if there is no current hyphenation language.

     This request is ignored if there is no parameter.

     In old versions of `troff' there was a limited amount of space to
     store such information; fortunately, with `gtroff', this is no
     longer a restriction.

 - Escape: \%
 - Escape: \:
     To tell `gtroff' how to hyphenate words on the fly, use the `\%'
     escape, also known as the "hyphenation character".  Preceding a
     word with this character prevents it from being hyphenated;
     putting it inside a word indicates to `gtroff' that the word may
     be hyphenated at that point.  Note that this mechanism only
     affects that one occurrence of the word; to change the hyphenation
     of a word for the entire document, use the `hw' request.

     The `\:' escape inserts a zero-width break point (that is, the
     word breaks but without adding a hyphen).

          ... check the /var/log/\:httpd/\:access_log file ...

     Note that `\X' and `\Y' start a word, that is, the `\%' escape in
     (say) ` \X'...'\%foobar' and ` \Y'...'\%foobar' no longer prevents
     hyphenation but inserts a hyphenation point at the beginning of
     `foobar'; most likely this isn't what you want to do.

 - Request: .hc [char]
     Change the hyphenation character to CHAR.  This character then
     works the same as the `\%' escape, and thus, no longer appears in
     the output.  Without an argument, `hc' resets the hyphenation
     character to be `\%' (the default) only.

     The hyphenation character is associated with the current
     environment (see Environments).

 - Request: .hpf pattern_file
 - Request: .hpfa pattern_file
 - Request: .hpfcode a b [c d ...]
     Read in a file of hyphenation patterns.  This file is searched for
     in the same way as `NAME.tmac' (or `tmac.NAME') is searched for if
     the `-mNAME' option is specified.

     It should have the same format as (simple) TeX patterns files.
     More specifically, the following scanning rules are implemented.

        * A percent sign starts a comment (up to the end of the line)
          even if preceded by a backslash.

        * No support for `digraphs' like `\$'.

        * `^^XX' (X is 0-9 or a-f) and `^^X' (character code of X in
          the range 0-127) are recognized; other use of `^' causes an
          error.

        * No macro expansion.

        * `hpf' checks for the expression `\patterns{...}' (possibly
          with whitespace before and after the braces).  Everything
          between the braces is taken as hyphenation patterns.
          Consequently, `{' and `}' are not allowed in patterns.

        * Similarly, `\hyphenation{...}' gives a list of hyphenation
          exceptions.

        * `\endinput' is recognized also.

        * For backwards compatibility, if `\patterns' is missing, the
          whole file is treated as a list of hyphenation patterns (only
          recognizing the `%' character as the start of a comment).

     If no `hpf' request is specified (either in the document or in a
     macro package), `gtroff' won't hyphenate at all.

     The `hpfa' request appends a file of patterns to the current list.

     The `hpfcode' request defines mapping values for character codes in
     hyphenation patterns.  `hpf' or `hpfa' then apply the mapping
     (after reading the patterns) before replacing or appending them to
     the current list of patterns.  Its arguments are pairs of
     character codes - integers from 0 to 255.  The request maps
     character code A to code B, code C to code D, and so on.  You can
     use character codes which would be invalid otherwise.

     The set of hyphenation patterns is associated with the current
     language set by the `hla' request.  The `hpf' request is usually
     invoked by the `troffrc' or `troffrc-end' file; by default,
     `troffrc' loads hyphenation patterns for American English (in file
     `hyphen.us').

     A second call to `hpf' (for the same language) will replace the
     hyphenation patterns with the new ones.

     Invoking `hpf' causes an error if there is no current hyphenation
     language.

 - Request: .hcode c1 code1 c2 code2 ...
     Set the hyphenation code of character C1 to CODE1, that of C2 to
     CODE2, etc.  A hyphenation code must be a single input character
     (not a special character) other than a digit or a space.
     Initially each lower-case letter (`a'-`z') has its hyphenation
     code set to itself, and each upper-case letter (`A'-`Z') has a
     hyphenation code which is the lower-case version of itself.

     This request is ignored if it has no parameter.

 - Request: .hym [length]
 - Register: \n[.hym]
     Set the (right) hyphenation margin to LENGTH.  If the current
     adjustment mode is not `b' or `n', the line is not hyphenated if
     it is shorter than LENGTH.  Without an argument, the hyphenation
     margin is reset to its default value, which is 0.  The default
     scaling indicator for this request is `m'.  The hyphenation margin
     is associated with the current environment (see Environments).

     A negative argument resets the hyphenation margin to zero, emitting
     a warning of type `range'.

     The current hyphenation margin is available in the `.hym' read-only
     number register.

 - Request: .hys [hyphenation_space]
 - Register: \n[.hys]
     Set the hyphenation space to HYPHENATION_SPACE.  If the current
     adjustment mode is `b' or `n', don't hyphenate the line if it can
     be justified by adding no more than HYPHENATION_SPACE extra space
     to each word space.  Without argument, the hyphenation space is
     set to its default value, which is 0.  The default scaling
     indicator for this request is `m'.  The hyphenation space is
     associated with the current environment (see Environments).

     A negative argument resets the hyphenation space to zero, emitting
     a warning of type `range'.

     The current hyphenation space is available in the `.hys' read-only
     number register.

 - Request: .shc [glyph]
     Set the "soft hyphen character" to GLYPH.(1) (1)
     If the argument is omitted, the soft
     hyphen character is set to the default glyph `\(hy' (this is the
     start-up value of `gtroff' also).  The soft hyphen character is
     the glyph that is inserted when a word is hyphenated at a line
     break.  If the soft hyphen character does not exist in the font of
     the character immediately preceding a potential break point, then
     the line is not broken at that point.  Neither definitions
     (specified with the `char' request) nor translations (specified
     with the `tr' request) are considered when finding the soft hyphen
     character.

 - Request: .hla language
 - Register: \n[.hla]
     Set the current hyphenation language to the string LANGUAGE.
     Hyphenation exceptions specified with the `hw' request and
     hyphenation patterns specified with the `hpf' and `hpfa' requests
     are both associated with the current hyphenation language.  The
     `hla' request is usually invoked by the `troffrc' or the
     `troffrc-end' files; `troffrc' sets the default language to `us'.

     The current hyphenation language is available as a string in the
     read-only number register `.hla'.

          .ds curr_language \n[.hla]
          \*[curr_language]
              => us

   (1) "Soft hyphen character" is a misnomer since it is an output
glyph.

Manipulating Spacing
====================

 - Request: .sp [distance]
     Space downwards DISTANCE.  With no argument it advances 1 line.  A
     negative argument causes `gtroff' to move up the page the
     specified distance.  If the argument is preceded by a `|' then
     `gtroff' moves that distance from the top of the page.  This
     request causes a line break.  The default scaling indicator is `v'.

 - Request: .ls [nnn]
 - Register: \n[.L]
     Output NNN-1 blank lines after each line of text.  With no
     argument, `gtroff' uses the previous value before the last `ls'
     call.

          .ls 2    \" This causes double-spaced output
          .ls 3    \" This causes triple-spaced output
          .ls      \" Again double-spaced

     The line spacing is associated with the current environment (see
     Environments).

     The read-only number register `.L' contains the current line
     spacing setting.

   See Changing Type Sizes, for the requests `vs' and `pvs' as
alternatives to `ls'.

 - Escape: \x'SPACING'
 - Register: \n[.a]
     Sometimes, extra vertical spacing is only needed occasionally, e.g.
     to allow space for a tall construct (like an equation).  The `\x'
     escape does this.  The escape is given a numerical argument,
     usually enclosed in quotes (like `\x'3p''); the default scaling
     indicator is `v'.  If this number is positive extra vertical space
     is inserted below the current line.  A negative number adds space
     above.  If this escape is used multiple times on the same line,
     the maximum of the values is used.

     See Escapes, for details on parameter delimiting characters.

     The `.a' read-only number register contains the most recent
     (nonnegative) extra vertical line space.

     Using `\x' can be necessary in combination with the `\b' escape,
     as the following example shows.

          This is a test with the \[rs]b escape.
          .br
          This is a test with the \[rs]b escape.
          .br
          This is a test with \b'xyz'\x'-1m'\x'1m'.
          .br
          This is a test with the \[rs]b escape.
          .br
          This is a test with the \[rs]b escape.

     produces

          This is a test with the \b escape.
          This is a test with the \b escape.
                              x
          This is a test with y.
                              z
          This is a test with the \b escape.
          This is a test with the \b escape.

 - Request: .ns
 - Request: .rs
 - Register: \n[.ns]
     Enable "no-space mode".  In this mode, spacing (either via `sp' or
     via blank lines) is disabled.  The `bp' request to advance to the
     next page is also disabled, except if it is accompanied by a page
     number (see Page Control, for more information).  This
     mode ends when actual text is output or the `rs' request is
     encountered which ends no-space mode.  The read-only number
     register `.ns' is set to 1 as long as no-space mode is active.

     This request is useful for macros that conditionally insert
     vertical space before the text starts (for example, a paragraph
     macro could insert some space except when it is the first
     paragraph after a section header).

Tabs and Fields
===============

   A tab character (ASCII char 9, EBCDIC char 5) causes a horizontal
movement to the next tab stop (much like it did on a typewriter).

 - Escape: \t
     This escape is a non-interpreted tab character.  In copy mode
     (see Copy-in Mode), `\t' is the same as a real tab character.

 - Request: .ta [n1 n2 ... nn T r1 r2 ... rn]
 - Register: \n[.tabs]
     Change tab stop positions.  This request takes a series of tab
     specifiers as arguments (optionally divided into two groups with
     the letter `T') which indicate where each tab stop is to be
     (overriding any previous settings).

     Tab stops can be specified absolutely, i.e., as the distance from
     the left margin.  For example, the following sets 6 tab stops every
     one inch.

          .ta 1i 2i 3i 4i 5i 6i

     Tab stops can also be specified using a leading `+' which means
     that the specified tab stop is set relative to the previous tab
     stop.  For example, the following is equivalent to the previous
     example.

          .ta 1i +1i +1i +1i +1i +1i

     `gtroff' supports an extended syntax to specify repeat values after
     the `T' mark (these values are always taken as relative) - this is
     the usual way to specify tabs set at equal intervals.  The
     following is, yet again, the same as the previous examples.  It
     does even more since it defines an infinite number of tab stops
     separated by one inch.

          .ta T 1i

     Now we are ready to interpret the full syntax given at the
     beginning: Set tabs at positions N1, N2, ..., NN and then set tabs
     at NN+R1, NN+R2, ..., NN+RN and then at NN+RN+R1, NN+RN+R2, ...,
     NN+RN+RN, and so on.

     Example: `4c +6c T 3c 5c 2c' is equivalent to `4c 10c 13c 18c 20c
     23c 28c 30c ...'.

     The material in each tab column (i.e., the column between two tab
     stops) may be justified to the right or left or centered in the
     column.  This is specified by appending `R', `L', or `C' to the tab
     specifier.  The default justification is `L'.  Example:

          .ta 1i 2iC 3iR

     Some notes:

        * The default unit of the `ta' request is `m'.

        * A tab stop is converted into a non-breakable horizontal
          movement which can be neither stretched nor squeezed.  For
          example,

               .ds foo a\tb\tc
               .ta T 5i
               \*[foo]

          creates a single line which is a bit longer than 10 inches (a
          string is used to show exactly where the tab characters are).
          Now consider the following:

               .ds bar a\tb b\tc
               .ta T 5i
               \*[bar]

          `gtroff' first converts the tab stops of the line into
          unbreakable horizontal movements, then splits the line after
          the second `b' (assuming a sufficiently short line length).
          Usually, this isn't what the user wants.

        * Superfluous tabs (i.e., tab characters which do not
          correspond to a tab stop) are ignored except the first one
          which delimits the characters belonging to the last tab stop
          for right-justifying or centering.  Consider the following
          example

               .ds Z   foo\tbar\tfoo
               .ds ZZ  foo\tbar\tfoobar
               .ds ZZZ foo\tbar\tfoo\tbar
               .ta 2i 4iR
               \*[Z]
               .br
               \*[ZZ]
               .br
               \*[ZZZ]
               .br

          which produces the following output:

               foo                 bar              foo
               foo                 bar           foobar
               foo                 bar              foobar

          The first line right-justifies the second `foo' relative to
          the tab stop.  The second line right-justifies `foobar'.  The
          third line finally right-justifies only `foo' because of the
          additional tab character which marks the end of the string
          belonging to the last defined tab stop.

        * Tab stops are associated with the current environment (see
          Environments).

        * Calling `ta' without an argument removes all tab stops.

        * The start-up value of `gtroff' is `T 0.5i' in troff mode and
          `T 0.8i' in nroff mode (the latter is done with an explicit
          call to the `ta' request in the file `tty.tmac'.

     The read-only number register `.tabs' contains a string
     representation of the current tab settings suitable for use as an
     argument to the `ta' request.

          .ds tab-string \n[.tabs]
          \*[tab-string]
              => T120u

     The `troff' version of the Plan 9 operating system uses register
     `.S' for the same purpose.

 - Request: .tc [fill-glyph]
     Normally `gtroff' fills the space to the next tab stop with
     whitespace.  This can be changed with the `tc' request.  With no
     argument `gtroff' reverts to using whitespace, which is the
     default.  The value of this "tab repetition character" is
     associated with the current environment (see Environments).(1)
     (1)

 - Request: .linetabs n
 - Register: \n[.linetabs]
     If N is missing or not zero, enable "line-tabs" mode, or disable
     it otherwise (the default).  In line-tabs mode, `gtroff' computes
     tab distances relative to the (current) output line instead of the
     input line.

     For example, the following code:

          .ds x a\t\c
          .ds y b\t\c
          .ds z c
          .ta 1i 3i
          \*x
          \*y
          \*z

     in normal mode, results in the output

          a         b         c

     in line-tabs mode, the same code outputs

          a         b                   c

     Line-tabs mode is associated with the current environment.  The
     read-only register `.linetabs' is set to 1 if in line-tabs mode,
     and 0 in normal mode.

   (1) "Tab repetition character" is a misnomer since it is an output
glyph.

Leaders
-------

   Sometimes it may may be desirable to use the `tc' request to fill a
particular tab stop with a given glyph (for example dots in a table of
contents), but also normal tab stops on the rest of the line.  For this
`gtroff' provides an alternate tab mechanism, called "leaders" which
does just that.

   A leader character (character code 1) behaves similarly to a tab
character: It moves to the next tab stop.  The only difference is that
for this movement, the fill glyph defaults to a period character and
not to space.

 - Escape: \a
     This escape is a non-interpreted leader character.  In copy mode
     (see Copy-in Mode), `\a' is the same as a real leader
     character.

 - Request: .lc [fill-glyph]
     Declare the "leader repetition character".(1) (
     1) Without an argument, leaders act the same as
     tabs (i.e., using whitespace for filling).  `gtroff''s start-up
     value is a dot (`.').  The value of the leader repetition
     character is associated with the current environment (see
     Environments).

   For a table of contents, to name an example, tab stops may be
defined so that the section number is one tab stop, the title is the
second with the remaining space being filled with a line of dots, and
then the page number slightly separated from the dots.

     .ds entry 1.1\tFoo\a\t12
     .lc .
     .ta 1i 5i +.25i
     \*[entry]

This produces

     1.1  Foo..........................................  12

   (1) "Leader repetition character" is a misnomer since it is an
output glyph.

Fields
------

   "Fields" are a more general way of laying out tabular data.  A field
is defined as the data between a pair of "delimiting characters".  It
contains substrings which are separated by "padding characters".  The
width of a field is the distance on the _input_ line from the position
where the field starts to the next tab stop.  A padding character
inserts stretchable space similar to TeX's `\hss' command (thus it can
even be negative) to make the sum of all substring lengths plus the
stretchable space equal to the field width.  If more than one padding
character is inserted, the available space is evenly distributed among
them.

 - Request: .fc [delim-char [padding-char]]
     Define a delimiting and a padding character for fields.  If the
     latter is missing, the padding character defaults to a space
     character.  If there is no argument at all, the field mechanism is
     disabled (which is the default).  Note that contrary to e.g. the
     tab repetition character, delimiting and padding characters are
     _not_ associated to the current environment (see Environments).

     Example:

          .fc # ^
          .ta T 3i
          #foo^bar^smurf#
          .br
          #foo^^bar^smurf#

     and here the result:

          foo         bar          smurf
          foo            bar       smurf

Character Translations
======================

   The control character (`.') and the no-break control character (`'')
can be changed with the `cc' and `c2' requests, respectively.

 - Request: .cc [c]
     Set the control character to C.  With no argument the default
     control character `.' is restored.  The value of the control
     character is associated with the current environment (see
     Environments).

 - Request: .c2 [c]
     Set the no-break control character to C.  With no argument the
     default control character `'' is restored.  The value of the
     no-break control character is associated with the current
     environment (see Environments).

 - Request: .eo
     Disable the escape mechanism completely.  After executing this
     request, the backslash character `\' no longer starts an escape
     sequence.

     This request can be very helpful in writing macros since it is not
     necessary then to double the escape character.  Here an example:

          .\" This is a simplified version of the
          .\" .BR request from the man macro package
          .eo
          .de BR
          .  ds result \&
          .  while (\n[.$] >= 2) \{\
          .    as result \fB\$1\fR\$2
          .    shift 2
          .  \}
          .  if \n[.$] .as result \fB\$1
          \*[result]
          .  ft R
          ..
          .ec

 - Request: .ec [c]
     Set the escape character to C.  With no argument the default
     escape character `\' is restored.  It can be also used to
     re-enable the escape mechanism after an `eo' request.

     Note that changing the escape character globally will likely break
     macro packages since `gtroff' has no mechanism to `intern' macros,
     i.e., to convert a macro definition into an internal form which is
     independent of its representation (TeX has this mechanism).  If a
     macro is called, it is executed literally.

 - Request: .ecs
 - Request: .ecr
     The `ecs' request saves the current escape character in an
     internal register.  Use this request in combination with the `ec'
     request to temporarily change the escape character.

     The `ecr' request restores the escape character saved with `ecs'.
     Without a previous call to `ecs', this request sets the escape
     character to `\'.

 - Escape: \\
 - Escape: \e
 - Escape: \E
     Print the current escape character (which is the backslash
     character `\' by default).

     `\\' is a `delayed' backslash; more precisely, it is the default
     escape character followed by a backslash, which no longer has
     special meaning due to the leading escape character.  It is _not_
     an escape sequence in the usual sense!  In any unknown escape
     sequence `\X' the escape character is ignored and X is printed.
     But if X is equal to the current escape character, no warning is
     emitted.

     As a consequence, only at top-level or in a diversion a backslash
     glyph is printed; in copy-in mode, it expands to a single
     backslash which then combines with the following character to an
     escape sequence.

     The `\E' escape differs from `\e' by printing an escape character
     that is not interpreted in copy mode.  Use this to define strings
     with escapes that work when used in copy mode (for example, as a
     macro argument).  The following example defines strings to begin
     and end a superscript:

          .ds { \v'-.3m'\s'\Es[.s]*60/100'
          .ds } \s0\v'.3m'

     Another example to demonstrate the differences between the various
     escape sequences, using a strange escape character, `-'.

          .ec -
          .de xxx
          --A'123'
          ..
          .xxx
              => -A'foo'

     The result is surprising for most users, expecting `1' since `foo'
     is a valid identifier.  What has happened?  As mentioned above,
     the leading escape character makes the following character
     ordinary.  Written with the default escape character the sequence
     `--' becomes `\-' - this is the minus sign.

     If the escape character followed by itself is a valid escape
     sequence, only `\E' yields the expected result:

          .ec -
          .de xxx
          -EA'123'
          ..
          .xxx
              => 1

 - Escape: \.
     Similar to `\\', the sequence `\.' isn't a real escape sequence.
     As before, a warning message is suppressed if the escape character
     is followed by a dot, and the dot itself is printed.

          .de foo
          .  nop foo
          .
          .  de bar
          .    nop bar
          \\..
          .
          ..
          .foo
          .bar
              => foo bar

     The first backslash is consumed while the macro is read, and the
     second is swallowed while exexuting macro `foo'.

   A "translation" is a mapping of an input character to an output
glyph.  The mapping occurs at output time, i.e., the input character
gets assigned the metric information of the mapped output character
right before input tokens are converted to nodes (see Gtroff Internals,
for more on this process).

 - Request: .tr abcd...
 - Request: .trin abcd...
     Translate character A to glyph B, character C to glyph D, etc.  If
     there is an odd number of arguments, the last one is translated to
     an unstretchable space (`\ ').

     The `trin' request is identical to `tr', but when you unformat a
     diversion with `asciify' it ignores the translation.  See
     Diversions, for details about the `asciify' request.

     Some notes:

        * Special characters (`\(XX', `\[XXX]', `\C'XXX'', `\'', `\`',
          `\-', `\_'), glyphs defined with the `char' request, and
          numbered glyphs (`\N'XXX'') can be translated also.

        * The `\e' escape can be translated also.

        * Characters can be mapped onto the `\%' and `\~' escapes (but
          `\%' and `\~' can't be mapped onto another glyph).

        * The following characters can't be translated: space (with one
          exception, see below), backspace, newline, leader (and `\a'),
          tab (and `\t').

        * Translations are not considered for finding the soft hyphen
          character set with the `shc' request.

        * The pair `C\&' (this is an arbitrary character C followed by
          the zero width space character) maps this character to
          nothing.

               .tr a\&
               foo bar
                   => foo br

          It is even possible to map the space character to nothing:

               .tr aa \&
               foo bar
                   => foobar

          As shown in the example, the space character can't be the
          first character/glyph pair as an argument of `tr'.
          Additionally, it is not possible to map the space character
          to any other glyph; requests like `.tr aa x' undo `.tr aa \&'
          instead.

          If justification is active, lines are justified in spite of
          the `empty' space character (but there is no minimal
          distance, i.e. the space character, between words).

        * After an output glyph has been constructed (this happens at
          the moment immediately before the glyph is appended to an
          output glyph list, either by direct output, in a macro,
          diversion, or string), it is no longer affected by `tr'.

        * Translating character to glyphs where one of them or both are
          undefined is possible also; `tr' does not check whether the
          entities in its argument do exist.

          See Gtroff Internals.

        * `troff' no longer has a hard-coded dependency on Latin-1; all
          `charXXX' entities have been removed from the font
          description files.  This has a notable consequence which
          shows up in warnings like `can't find character with input
          code XXX' if the `tr' request isn't handled properly.

          Consider the following translation:

               .tr e'E'

          This maps input character `e'' onto glyph `E'', which is
          identical to glyph `char201'.  But this glyph intentionally
          doesn't exist!  Instead, `\[char201]' is treated as an input
          character entity and is by default mapped onto `\['E]', and
          `gtroff' doesn't handle translations of translations.

          The right way to write the above translation is

               .tr e'\['E]

          With other words, the first argument of `tr' should be an
          input character or entity, and the second one a glyph entity.

        * Without an argument, the `tr' request is ignored.

 - Request: .trnt abcd...
     `trnt' is the same as the `tr' request except that the
     translations do not apply to text that is transparently throughput
     into a diversion with `\!'.  See Diversions, for more
     information.

     For example,

          .tr ab
          .di x
          \!.tm a
          .di
          .x

     prints `b' to the standard error stream; if `trnt' is used instead
     of `tr' it prints `a'.

Troff and Nroff Mode
====================

   Originally, `nroff' and `troff' were two separate programs, the
former for TTY output, the latter for everything else.  With GNU
`troff', both programs are merged into one executable, sending its
output to a device driver (`grotty' for TTY devices, `grops' for
POSTSCRIPT, etc.) which interprets the intermediate output of `gtroff'.
For UNIX `troff' it makes sense to talk about "Nroff mode" and "Troff
mode" since the differences are hardcoded.  For GNU `troff', this
distinction is not appropriate because `gtroff' simply takes the
information given in the font files for a particular device without
handling requests specially if a TTY output device is used.

   Usually, a macro package can be used with all output devices.
Nevertheless, it is sometimes necessary to make a distinction between
TTY and non-TTY devices: `gtroff' provides two built-in conditions `n'
and `t' for the `if', `ie', and `while' requests to decide whether
`gtroff' shall behave like `nroff' or like `troff'.

 - Request: .troff
     Make the `t' built-in condition true (and the `n' built-in
     condition false) for `if', `ie', and `while' conditional requests.
     This is the default if `gtroff' (_not_ `groff') is started with
     the `-R' switch to avoid loading of the start-up files `troffrc'
     and `troffrc-end'.  Without `-R', `gtroff' stays in troff mode if
     the output device is not a TTY (e.g. `ps').

 - Request: .nroff
     Make the `n' built-in condition true (and the `t' built-in
     condition false) for `if', `ie', and `while' conditional requests.
     This is the default if `gtroff' uses a TTY output device; the
     code for switching to nroff mode is in the file `tty.tmac' which
     is loaded by the start-up file `troffrc'.

   See Conditionals and Loops, for more details on built-in
conditions.

Line Layout
===========

   The following drawing shows the dimensions which `gtroff' uses for
placing a line of output onto the page.  They are labeled with the
request which manipulates each dimension.

                     -->| in |<--
                        |<-----------ll------------>|
                   +----+----+----------------------+----+
                   |    :    :                      :    |
                   +----+----+----------------------+----+
                -->| po |<--
                   |<--------paper width---------------->|

These dimensions are:

`po'
     "Page offset" - this is the leftmost position of text on the final
     output, defining the "left margin".

`in'
     "Indentation" - this is the distance from the left margin where
     text is printed.

`ll'
     "Line length" - this is the distance from the left margin to right
     margin.

   A simple demonstration:

     .ll 3i
     This is text without indentation.
     The line length has been set to 3\~inch.
     .in +.5i
     .ll -.5i
     Now the left and right margins are both increased.
     .in
     .ll
     Calling .in and .ll without parameters restore
     the previous values.

   Result:

     This  is text without indenta-
     tion.   The  line  length  has
     been set to 3 inch.
          Now   the  left  and
          right  margins   are
          both increased.
     Calling  .in  and  .ll without
     parameters restore the  previ-
     ous values.

 - Request: .po [offset]
 - Request: .po +offset
 - Request: .po -offset
 - Register: \n[.o]
     Set horizontal page offset to OFFSET (or increment or decrement
     the current value by OFFSET).  Note that this request does not
     cause a break, so changing the page offset in the middle of text
     being filled may not yield the expected result.  The initial value
     is 1i.  For TTY output devices, it is set to 0 in the startup file
     `troffrc'; the default scaling indicator is `m' (and not `v' as
     incorrectly documented in the original UNIX troff manual).

     The current page offset can be found in the read-only number
     register `.o'.

     If `po' is called without an argument, the page offset is reset to
     the previous value before the last call to `po'.

          .po 3i
          \n[.o]
              => 720
          .po -1i
          \n[.o]
              => 480
          .po
          \n[.o]
              => 720

 - Request: .in [indent]
 - Request: .in +indent
 - Request: .in -indent
 - Register: \n[.i]
     Set indentation to INDENT (or increment or decrement the current
     value by INDENT).  This request causes a break.  Initially, there
     is no indentation.

     If `in' is called without an argument, the indentation is reset to
     the previous value before the last call to `in'.  The default
     scaling indicator is `m'.

     The indentation is associated with the current environment (see
     Environments).

     If a negative indentation value is specified (which is not
     allowed), `gtroff' emits a warning of type `range' and sets the
     indentation to zero.

     The effect of `in' is delayed until a partially collected line (if
     it exists) is output.  A temporary indent value is reset to zero
     also.

     The current indentation (as set by `in') can be found in the
     read-only number register `.i'.

 - Request: .ti offset
 - Request: .ti +offset
 - Request: .ti -offset
 - Register: \n[.in]
     Temporarily indent the next output line by OFFSET.  If an
     increment or decrement value is specified, adjust the temporary
     indentation relative to the value set by the `in' request.

     This request causes a break; its value is associated with the
     current environment (see Environments).  The default scaling
     indicator is `m'.  A call of `ti' without an argument is ignored.

     If the total indentation value is negative (which is not allowed),
     `gtroff' emits a warning of type `range' and sets the temporary
     indentation to zero.  `Total indentation' is either OFFSET if
     specified as an absolute value, or the temporary plus normal
     indentation, if OFFSET is given as a relative value.

     The effect of `ti' is delayed until a partially collected line (if
     it exists) is output.

     The read-only number register `.in' is the indentation that applies
     to the current output line.

     The difference between `.i' and `.in' is that the latter takes
     into account whether a partially collected line still uses the old
     indentation value or a temporary indentation value is active.

 - Request: .ll [length]
 - Request: .ll +length
 - Request: .ll -length
 - Register: \n[.l]
 - Register: \n[.ll]
     Set the line length to LENGTH (or increment or decrement the
     current value by LENGTH).  Initially, the line length is set to
     6.5i.  The effect of `ll' is delayed until a partially collected
     line (if it exists) is output.  The default scaling indicator is
     `m'.

     If `ll' is called without an argument, the line length is reset to
     the previous value before the last call to `ll'.  If a negative
     line length is specified (which is not allowed), `gtroff' emits a
     warning of type `range' and sets the line length to zero.

     The line length is associated with the current environment (see
     Environments).

     The current line length (as set by `ll') can be found in the
     read-only number register `.l'.  The read-only number register
     `.ll' is the line length that applies to the current output line.

     Similar to `.i' and `.in', the difference between `.l' and `.ll'
     is that the latter takes into account whether a partially
     collected line still uses the old line length value.

Line Control
============

   It is important to understand how `gtroff' handles input and output
lines.

   Many escapes use positioning relative to the input line.  For
example, this

     This is a \h'|1.2i'test.

     This is a
     \h'|1.2i'test.

produces

     This is a   test.

     This is a             test.

   The main usage of this feature is to define macros which act exactly
at the place where called.

     .\" A simple macro to underline a word
     .de underline
     .  nop \\$1\l'|0\[ul]'
     ..

In the above example, `|0' specifies a negative distance from the
current position (at the end of the just emitted argument `\$1') back
to the beginning of the input line.  Thus, the `\l' escape draws a line
from right to left.

   `gtroff' makes a difference between input and output line
continuation; the latter is also called "interrupting" a line.

 - Escape: \<RET>
 - Escape: \c
 - Register: \n[.int]
     Continue a line.  `\<RET>' (this is a backslash at the end of a
     line immediately followed by a newline) works on the input level,
     suppressing the effects of the following newline in the input.

          This is a \
          .test
              => This is a .test

     The `|' operator is also affected.

     `\c' works on the output level.  Anything after this escape on the
     same line is ignored, except `\R' which works as usual.  Anything
     before `\c' on the same line will be appended to the current
     partial output line.  The next non-command line after an
     interrupted line counts as a new input line.

     The visual results depend on whether no-fill mode is active.

        * If no-fill mode is active (using the `nf' request), the next
          input text line after `\c' will be handled as a continuation
          of the same input text line.

               .nf
               This is a \c
               test.
                   => This is a test.

        * If fill mode is active (using the `fi' request), a word
          interrupted with `\c' will be continued with the text on the
          next input text line, without an intervening space.

               This is a te\c
               st.
                   => This is a test.

     Note that an intervening control line which causes a break is
     stronger than `\c', flushing out the current partial line in the
     usual way.

     The `.int' register contains a positive value if the last output
     line was interrupted with `\c'; this is associated with the
     current environment (see Environments).

Page Layout
===========

   `gtroff' provides some very primitive operations for controlling
page layout.

 - Request: .pl [length]
 - Request: .pl +length
 - Request: .pl -length
 - Register: \n[.p]
     Set the "page length" to LENGTH (or increment or decrement the
     current value by LENGTH).  This is the length of the physical
     output page.  The default scaling indicator is `v'.

     The current setting can be found in the read-only number register
     `.p'.

     Note that this only specifies the size of the page, not the top and
     bottom margins.  Those are not set by `gtroff' directly.  See
     Traps, for further information on how to do this.

     Negative `pl' values are possible also, but not very useful: No
     trap is sprung, and each line is output on a single page (thus
     suppressing all vertical spacing).

     If no argument or an invalid argument is given, `pl' sets the page
     length to 11i.

   `gtroff' provides several operations which help in setting up top
and bottom titles (or headers and footers).

 - Request: .tl 'left'center'right'
     Print a "title line".  It consists of three parts: a left
     justified portion, a centered portion, and a right justified
     portion.  The argument separator `'' can be replaced with any
     character not occurring in the title line.  The `%' character is
     replaced with the current page number.  This character can be
     changed with the `pc' request (see below).

     Without argument, `tl' is ignored.

     Some notes:

        * A title line is not restricted to the top or bottom of a page.

        * `tl' prints the title line immediately, ignoring a partially
          filled line (which stays untouched).

        * It is not an error to omit closing delimiters.  For example,
          `.tl /foo' is equivalent to `.tl /foo///': It prints a title
          line with the left justified word `foo'; the centered and
          right justfied parts are empty.

        * `tl' accepts the same parameter delimiting characters as the
          `\A' escape; see Escapes.

 - Request: .lt [length]
 - Request: .lt +length
 - Request: .lt -length
 - Register: \n[.lt]
     The title line is printed using its own line length, which is
     specified (or incremented or decremented) with the `lt' request.
     Initially, the title line length is set to 6.5i.  If a negative
     line length is specified (which is not allowed), `gtroff' emits a
     warning of type `range' and sets the title line length to zero.
     The default scaling indicator is `m'.  If `lt' is called without
     an argument, the title length is reset to the previous value
     before the last call to `lt'.

     The current setting of this is available in the `.lt' read-only
     number register; it is associated with the current environment
     (see Environments).

 - Request: .pn page
 - Request: .pn +page
 - Request: .pn -page
 - Register: \n[.pn]
     Change (increase or decrease) the page number of the _next_ page.
     The only argument is the page number; the request is ignored
     without a parameter.

     The read-only number register `.pn' contains the number of the next
     page: either the value set by a `pn' request, or the number of the
     current page plus 1.

 - Register: \n[%]
     A read-write register holding the current page number.

 - Request: .pc [char]
     Change the page number character (used by the `tl' request) to a
     different character.  With no argument, this mechanism is disabled.
     Note that this doesn't affect the number register `%'.

   See Traps.

Page Control
============

 - Request: .bp [page]
 - Request: .bp +page
 - Request: .bp -page
     Stop processing the current page and move to the next page.  This
     request causes a break.  It can also take an argument to set
     (increase, decrease) the page number of the next page.  The only
     difference between `bp' and `pn' is that `pn' does not cause a
     break or actually eject a page.

          .de newpage                         \" define macro
          'bp                                 \" begin page
          'sp .5i                             \" vertical space
          .tl 'left top'center top'right top' \" title
          'sp .3i                             \" vertical space
          ..                                  \" end macro

     `bp' has no effect if not called within the top-level diversion
     (see Diversions).

 - Request: .ne [space]
     It is often necessary to force a certain amount of space before a
     new page occurs.  This is most useful to make sure that there is
     not a single "orphan" line left at the bottom of a page.  The `ne'
     request ensures that there is a certain distance, specified by the
     first argument, before the next page is triggered (see
     Traps, for further information).  The default scaling indicator
     for `ne' is `v'; the default value of SPACE is 1v if no argument
     is given.

     For example, to make sure that no fewer than 2 lines get orphaned,
     do the following before each paragraph:

          .ne 2
          text text text

     `ne' will then automatically cause a page break if there is space
     for one line only.

 - Request: .sv [space]
 - Request: .os
     `sv' is similar to the `ne' request; it reserves the specified
     amount of vertical space.  If the desired amount of space exists
     before the next trap (or the bottom page boundary if no trap is
     set), the space is output immediately (ignoring a partially filled
     line which stays untouched).  If there is not enough space, it is
     stored for later output via the `os' request.  The default value
     is 1v if no argument is given; the default scaling indicator is
     `v'.

     Both `sv' and `os' ignore no-space mode.  While the `sv' request
     allows negative values for SPACE, `os' will ignore them.

 - Register: \n[nl]
     This register contains the current vertical position.  If the
     vertical position is zero and the top of page transition hasn't
     happened yet, `nl' is set to negative value.  `gtroff' itself does
     this at the very beginning of a document before anything has been
     printed, but the main usage is to plant a header trap on a page if
     this page has already started.

     Consider the following:

          .de xxx
          .  sp
          .  tl ''Header''
          .  sp
          ..
          .
          First page.
          .bp
          .wh 0 xxx
          .nr nl (-1)
          Second page.

     Result:

          First page.

          ...

                                       Header

          Second page.

          ...

     Without resetting `nl' to a negative value, the just planted trap
     would be active beginning with the _next_ page, not the current
     one.

     See Diversions, for a comparison with the `.h' and `.d'
     registers.

Fonts
=====

   `gtroff' can switch fonts at any point in the text.

   The basic set of fonts is `R', `I', `B', and `BI'.  These are Times
Roman, Italic, Bold, and Bold Italic.  For non-TTY devices, there is
also at least one symbol font which contains various special symbols
(Greek, mathematics).

Changing Fonts
--------------

 - Request: .ft [font]
 - Escape: \fF
 - Escape: \f(FN
 - Escape: \f[FONT]
     The `ft' request and the `\f' escape change the current font to
     FONT (one-character name F, two-character name FN).

     If FONT is a style name (as set with the `sty' request or with the
     `styles' command in the `DESC' file), use it within the current
     font family (as set with the `fam' request, `\F' escape, or with
     the `family' command in the `DESC' file).

     With no argument or using `P' as an argument, `.ft' switches to
     the previous font.  Use `\f[]' to do this with the escape.  The
     old syntax forms `\fP' or `\f[P]' are also supported.

     Fonts are generally specified as upper-case strings, which are
     usually 1 to 4 characters representing an abbreviation or acronym
     of the font name.  This is no limitation, just a convention.

     The example below produces two identical lines.

          eggs, bacon,
          .ft B
          spam
          .ft
          and sausage.

          eggs, bacon, \fBspam\fP and sausage.

     Note that `\f' doesn't produce an input token in `gtroff'.  As a
     consequence, it can be used in requests like `mc' (which expects a
     single character as an argument) to change the font on the fly:

          .mc \f[I]x\f[]

     See Font Positions, for an alternative syntax.

 - Request: .ftr f [g]
     Translate font F to font G.  Whenever a font named F is referred
     to in a `\f' escape sequence, or in the `ft', `ul', `bd', `cs',
     `tkf', `special', `fspecial', `fp', or `sty' requests, font G is
     used.  If G is missing or equal to F the translation is undone.

Font Families
-------------

   Due to the variety of fonts available, `gtroff' has added the
concept of "font families" and "font styles".  The fonts are specified
as the concatenation of the font family and style.  Specifying a font
without the family part causes `gtroff' to use that style of the
current family.

   Currently, fonts for the devices `-Tps', `-Tdvi', and `-Tlbp' are
set up to this mechanism.  By default, `gtroff' uses the Times family
with the four styles `R', `I', `B', and `BI'.

   This way, it is possible to use the basic four fonts and to select a
different font family on the command line (see Groff Options).

 - Request: .fam [family]
 - Register: \n[.fam]
 - Escape: \FF
 - Escape: \F(FM
 - Escape: \F[FAMILY]
 - Register: \n[.fn]
     Switch font family to FAMILY (one-character name F, two-character
     name FM).  If no argument is given, switch back to the previous
     font family.  Use `\F[]' to do this with the escape.  Note that
     `\FP' doesn't work; it selects font family `P' instead.

     The value at start-up is `T'.  The current font family is
     available in the read-only number register `.fam' (this is a
     string-valued register); it is associated with the current
     environment.

          spam,
          .fam H    \" helvetica family
          spam,     \" used font is family H + style R = HR
          .ft B     \" family H + style B = font HB
          spam,
          .fam T    \" times family
          spam,     \" used font is family T + style B = TB
          .ft AR    \" font AR (not a style)
          baked beans,
          .ft R     \" family T + style R = font TR
          and spam.

     Note that `\F' doesn't produce an input token in `gtroff'.  As a
     consequence, it can be used in requests like `mc' (which expects a
     single character as an argument) to change the font family on the
     fly:

          .mc \F[P]x\F[]

     The `.fn' register contains the current "real font name" of the
     current font.  This is a string-valued register.  If the current
     font is a style, the value of `\n[.fn]' is the proper
     concatenation of family and style name.

 - Request: .sty n style
     Associate STYLE with font position N.  A font position can be
     associated either with a font or with a style.  The current font
     is the index of a font position and so is also either a font or a
     style.  If it is a style, the font that is actually used is the
     font which name is the concatenation of the name of the current
     family and the name of the current style.  For example, if the
     current font is 1 and font position 1 is associated with style `R'
     and the current font family is `T', then font `TR' will be used.
     If the current font is not a style, then the current family is
     ignored.  If the requests `cs', `bd', `tkf', `uf', or `fspecial'
     are applied to a style, they will instead be applied to the member
     of the current family corresponding to that style.

     N must be a non-negative integer value.

     The default family can be set with the `-f' option (see Groff Options).
     The `styles' command in the `DESC' file controls
     which font positions (if any) are initially associated with styles
     rather than fonts.  For example, the default setting for
     POSTSCRIPT fonts

          styles R I B BI

     is equivalent to

          .sty 1 R
          .sty 2 I
          .sty 3 B
          .sty 4 BI

     `fam' and `\F' always check whether the current font position is
     valid; this can give surprising results if the current font
     position is associated with a style.

     In the following example, we want to access the POSTSCRIPT font
     `FooBar' from the font family `Foo':

          .sty \n[.fp] Bar
          .fam Foo
              => warning: can't find font `FooR'

     The default font position at start-up is 1; for the POSTSCRIPT
     device, this is associated with style `R', so `gtroff' tries to
     open `FooR'.

     A solution to this problem is to use a dummy font like the
     following:

          .fp 0 dummy TR    \" set up dummy font at position 0
          .sty \n[.fp] Bar  \" register style `Bar'
          .ft 0             \" switch to font at position 0
          .fam Foo          \" activate family `Foo'
          .ft Bar           \" switch to font `FooBar'

     See Font Positions.

Font Positions
--------------

   For the sake of old phototypesetters and compatibility with old
versions of `troff', `gtroff' has the concept of font "positions", on
which various fonts are mounted.

 - Request: .fp pos font [external-name]
 - Register: \n[.f]
 - Register: \n[.fp]
     Mount font FONT at position POS (which must be a non-negative
     integer).  This numeric position can then be referred to with font
     changing commands.  When `gtroff' starts it is using font
     position 1 (which must exist; position 0 is unused usually at
     start-up).

     The current font in use, as a font position, is available in the
     read-only number register `.f'.  This can be useful to remember the
     current font for later recall.  It is associated with the current
     environment (see Environments).

          .nr save-font \n[.f]
          .ft B
          ... text text text ...
          .ft \n[save-font]

     The number of the next free font position is available in the
     read-only number register `.fp'.  This is useful when mounting a
     new font, like so:

          .fp \n[.fp] NEATOFONT

     Fonts not listed in the `DESC' file are automatically mounted on
     the next available font position when they are referenced.  If a
     font is to be mounted explicitly with the `fp' request on an unused
     font position, it should be mounted on the first unused font
     position, which can be found in the `.fp' register.  Although
     `gtroff' does not enforce this strictly, it is not allowed to
     mount a font at a position whose number is much greater (approx.
     1000 positions) than that of any currently used position.

     The `fp' request has an optional third argument.  This argument
     gives the external name of the font, which is used for finding the
     font description file.  The second argument gives the internal
     name of the font which is used to refer to the font in `gtroff'
     after it has been mounted.  If there is no third argument then the
     internal name is used as the external name.  This feature makes it
     possible to use fonts with long names in compatibility mode.

   Both the `ft' request and the `\f' escape have alternative syntax
forms to access font positions.

 - Request: .ft nnn
 - Escape: \fN
 - Escape: \f(NN
 - Escape: \f[NNN]
     Change the current font position to NNN (one-digit position N,
     two-digit position NN), which must be a non-negative integer.

     If NNN is associated with a style (as set with the `sty' request
     or with the `styles' command in the `DESC' file), use it within
     the current font family (as set with the `fam' request, the `\F'
     escape, or with the `family' command in the `DESC' file).

          this is font 1
          .ft 2
          this is font 2
          .ft                   \" switch back to font 1
          .ft 3
          this is font 3
          .ft
          this is font 1 again

     See Changing Fonts, for the standard syntax form.

Using Symbols
-------------

   A "glyph" is a graphical representation of a "character".  While a
character is an abstract entity containing semantic information, a
glyph is something which can be actually seen on screen or paper.  It
is possible that a character has multiple glyph representation forms
(for example, the character `A' can be either written in a roman or an
italic font, yielding two different glyphs); sometimes more than one
character maps to a single glyph (this is a "ligature" - the most
common is `fi').

   A "symbol" is simply a named glyph.  Within `gtroff', all glyph
names of a particular font are defined in its font file.  If the user
requests a glyph not available in this font, `gtroff' looks up an
ordered list of "special fonts".  By default, the POSTSCRIPT output
device supports the two special fonts `SS' (slanted symbols) and `S'
(symbols) (the former is looked up before the latter).  Other output
devices use different names for special fonts.  Fonts mounted with the
`fonts' keyword in the `DESC' file are globally available.  To install
additional special fonts locally (i.e. for a particular font), use the
`fspecial' request.

   In summary, `gtroff' tries the following to find a given symbol:

   * If the symbol has been defined with the `char' request, use it.
     This hides a symbol with the same name in the current font.

   * Check the current font.

   * If the symbol has been defined with the `fchar' request, use it.

   * Check all fonts given with the `fspecial' request, in the order of
     appearance in `fspecial' calls.

   * Check all fonts given with the `special' request, in the order of
     appearance in `special' calls (inclusively the special fonts
     defined in the `DESC' file, which come first).

   * As a last resort, consult all fonts loaded up to now (in the order
     they have been called the first time) for special fonts and check
     them.

   See Font Files, and Special Fonts, for more details.

 - Escape: \(NM
 - Escape: \[NAME]
     Insert a symbol NAME (two-character name NM).  There is no special
     syntax for one-character names - the natural form `\N' would
     collide with escapes.(1) (1)

     If NAME is undefined, a warning of type `char' is generated, and
     the escape is ignored.  See Debugging, for information about
     warnings.

     The list of available symbols is device dependent; see the
     `groff_char(7)' man page for a complete list for the given output
     device.  For example, say

          man -Tdvi groff_char > groff_char.dvi

     for a list using the default DVI fonts (not all versions of the
     `man' program support the `-T' option).  If you want to use an
     additional macro package to change the used fonts, `groff' must be
     called directly:

          groff -Tdvi -mec -man groff_char.7 > groff_char.dvi

 - Escape: \C'XXX'
     Typeset the glyph named XXX.(2) (2)
     Normally it is more convenient to use `\[XXX]', but `\C' has the
     advantage that it is compatible with newer versions of AT&T
     `troff' and is available in compatibility mode.

 - Escape: \N'N'
     Typeset the glyph with code N in the current font (`n' is *not*
     the input character code).  The number N can be any non-negative
     decimal integer.  Most devices only have glyphs with codes between
     0 and 255; the Unicode output device uses codes in the range
     0-65535.  If the current font does not contain a glyph with that
     code, special fonts are _not_ searched.  The `\N' escape sequence
     can be conveniently used in conjunction with the `char' request:

          .char \[phone] \f[ZD]\N'37'

     The code of each glyph is given in the fourth column in the font
     description file after the `charset' command.  It is possible to
     include unnamed glyphs in the font description file by using a
     name of `---'; the `\N' escape sequence is the only way to use
     these.

   Some escape sequences directly map onto special glyphs.

 - Escape: \'
     This is a backslash followed by the apostrophe character, ASCII
     character `0x27' (EBCDIC character `0x7D').  The same as `\[aa]',
     the acute accent.

 - Escape: \`
     This is a backslash followed by ASCII character `0x60' (EBCDIC
     character `0x79' usually).  The same as `\[ga]', the grave accent.

 - Escape: \-
     This is the same as `\[-]', the minus sign in the current font.

 - Request: .cflags n c1 c2 ...
     Input characters and symbols have certain properties associated
     with it.(3) (3)  These properties
     can be modified with the `cflags' request.  The first argument is
     the sum of the desired flags and the remaining arguments are the
     characters or symbols to have those properties.  It is possible to
     omit the spaces between the characters or symbols.

    `1'
          The character ends sentences (initially characters `.?!' have
          this property).

    `2'
          Lines can be broken before the character (initially no
          characters have this property).

    `4'
          Lines can be broken after the character (initially the
          character `-' and the symbols `\(hy' and `\(em' have this
          property).

    `8'
          The character overlaps horizontally (initially the symbols
          `\(ul\(rn\(ru' have this property).

    `16'
          The character overlaps vertically (initially symbol `\(br' has
          this property).

    `32'
          An end-of-sentence character followed by any number of
          characters with this property is treated as the end of a
          sentence if followed by a newline or two spaces; in other
          words the character is "transparent" for the purposes of
          end-of-sentence recognition - this is the same as having a
          zero space factor in TeX (initially characters `"')]*' and
          the symbols `\(dg\(rq' have this property).

 - Request: .char g [string]
 - Request: .fchar g [string]
     Define a new glyph G to be STRING (which can be empty).(4) (
     4)  Every time glyph G needs to be
     printed, STRING is processed in a temporary environment and the
     result is wrapped up into a single object.  Compatibility mode is
     turned off and the escape character is set to `\' while STRING is
     being processed.  Any emboldening, constant spacing or track
     kerning is applied to this object rather than to individual
     characters in STRING.

     A glyph defined by this request can be used just like a normal
     glyph provided by the output device.  In particular, other
     characters can be translated to it with the `tr' or `trin'
     requests; it can be made the leader character by the `lc' request;
     repeated patterns can be drawn with the glyph using the `\l' and
     `\L' escape sequences; words containing the glyph can be
     hyphenated correctly if the `hcode' request is used to give the
     glyph's symbol a hyphenation code.

     There is a special anti-recursion feature: Use of `g' within the
     glyph's definition is handled like normal characters and symbols
     not defined with `char'.

     Note that the `tr' and `trin' requests take precedence if `char'
     accesses the same symbol.

          .tr XY
          X
              => Y
          .char X Z
          X
              => Y
          .tr XX
          X
              => Z

     The `fchar' request defines a fallback glyph: `gtroff' only checks
     for glyphs defined with `fchar' if it cannot find the glyph in the
     current font.  `gtroff' carries out this test before checking
     special fonts.

 - Request: .rchar c1 c2 ...
     Remove the definitions of glyphs C1, C2, .... This undoes the
     effect of a `char' or `fchar' request.

     It is possible to omit the whitespace between arguments.

   See Special Characters.

   (1) Note that a one-character symbol is not the same as an input
character, i.e., the character `a' is not the same as `\[a]'.  By
default, `groff' defines only a single one-character symbol, `\[-]'; it
is usually accessed as `\-'.  On the other hand, `gtroff' has the
special feature that `\[charXXX]' is the same as the input character
with character code XXX.  For example, `\[char97]' is identical to the
letter `a' if ASCII encoding is active.

   (2) `\C' is actually a misnomer since it accesses an output glyph.

   (3) Note that the output glyphs themselves don't have such
properties.  For `gtroff', a glyph is a numbered box with a given
width, depth, and height, nothing else.  All manipulations with the
`cflags' request work on the input level.

   (4) `char' is a misnomer since an output glyph is defined.

Special Fonts
-------------

   Special fonts are those that `gtroff' searches when it cannot find
the requested glyph in the current font.  The Symbol font is usually a
special font.

   `gtroff' provides the following two requests to add more special
fonts.  See Using Symbols, for a detailed description of the glyph
searching mechanism in `gtroff'.

   Usually, only non-TTY devices have special fonts.

 - Request: .special s1 s2 ...
 - Request: .fspecial f s1 s2 ...
     Use the `special' request to define special fonts.  They are
     appended to the list of global special fonts in the given order.
     The first entries in this list are the fonts defined with the
     `fonts' command in the `DESC' file which are marked as special in
     the corresponding font description files.

     Use the `fspecial' request to designate special fonts only when
     font F font is active.  They are appended to the list of special
     fonts for F in the given order.  Initially, this list is empty.

Artificial Fonts
----------------

   There are a number of requests and escapes for artificially creating
fonts.  These are largely vestiges of the days when output devices did
not have a wide variety of fonts, and when `nroff' and `troff' were
separate programs.  Most of them are no longer necessary in GNU
`troff'.  Nevertheless, they are supported.

 - Escape: \H'HEIGHT'
 - Escape: \H'+HEIGHT'
 - Escape: \H'-HEIGHT'
     Change (increment, decrement) the height of the current font, but
     not the width.  If HEIGHT is zero, restore the original height.
     Default scaling indicator is `z'.

     Currently, only the `-Tps' device supports this feature.

     Note that `\H' doesn't produce an input token in `gtroff'.  As a
     consequence, it can be used in requests like `mc' (which expects a
     single character as an argument) to change the font on the fly:

          .mc \H'+5z'x\H'0'

     In compatibility mode, `gtroff' behaves differently:  If an
     increment or decrement is used, it is always taken relative to the
     current point size and not relative to the previously selected font
     height.  Thus,

          .cp 1
          \H'+5'test \H'+5'test

     prints the word `test' twice with the same font height (five
     points larger than the current font size).

 - Escape: \S'SLANT'
     Slant the current font by SLANT degrees.  Positive values slant to
     the right.

     Currently, only the `-Tps' device supports this feature.

     Note that `\S' doesn't produce an input token in `gtroff'.  As a
     consequence, it can be used in requests like `mc' (which expects a
     single character as an argument) to change the font on the fly:

          .mc \S'20'x\S'0'

     This request is incorrectly documented in the original UNIX troff
     manual; the slant is always set to an absolute value.

 - Request: .ul [lines]
     The `ul' request normally underlines subsequent lines if a TTY
     output device is used.  Otherwise, the lines are printed in italics
     (only the term `underlined' is used in the following).  The single
     argument is the number of input lines to be underlined; with no
     argument, the next line is underlined.  If LINES is zero or
     negative, stop the effects of `ul' (if it was active).  Requests
     and empty lines do not count for computing the number of underlined
     input lines, even if they produce some output like `tl'.  Lines
     inserted by macros (e.g. invoked by a trap) do count.

     At the beginning of `ul', the current font is stored and the
     underline font is activated.  Within the span of a `ul' request,
     it is possible to change fonts, but after the last line affected by
     `ul' the saved font is restored.

     This number of lines still to be underlined is associated with the
     current environment (see Environments).  The underline font
     can be changed with the `uf' request.

     The `ul' request does not underline spaces.

 - Request: .cu [lines]
     The `cu' request is similar to `ul' but underlines spaces as well
     (if a TTY output device is used).

 - Request: .uf font
     Set the underline font (globally) used by `ul' and `cu'.  By
     default, this is the font at position 2.  FONT can be either a
     non-negative font position or the name of a font.

 - Request: .bd font [offset]
 - Request: .bd font1 font2 [offset]
 - Register: \n[.b]
     Artificially create a bold font by printing each glyph twice,
     slightly offset.

     Two syntax forms are available.

        * Imitate a bold font unconditionally.  The first argument
          specifies the font to embolden, and the second is the number
          of basic units, minus one, by which the two glyphs are
          offset.  If the second argument is missing, emboldening is
          turned off.

          FONT can be either a non-negative font position or the name
          of a font.

          OFFSET is available in the `.b' read-only register if a
          special font is active; in the `bd' request, its default unit
          is `u'.

        * Imitate a bold form conditionally.  Embolden FONT1 by OFFSET
          only if font FONT2 is the current font.  This command can be
          issued repeatedly to set up different emboldening values for
          different current fonts.  If the second argument is missing,
          emboldening is turned off for this particular current font.

          This affects special fonts only (either set up with the
          `special' command in font files or with the `fspecial'
          request).

 - Request: .cs font [width [em-size]]
     Switch to and from "constant glyph space mode".  If activated, the
     width of every glyph is WIDTH/36 ems.  The em size is given
     absolutely by EM-SIZE; if this argument is missing, the em value
     is taken from the current font size (as set with the `ps' request)
     when the font is effectively in use.  Without second and third
     argument, constant glyph space mode is deactivated.

     Default scaling indicator for EM-SIZE is `z'; WIDTH is an integer.

Ligatures and Kerning
---------------------

   Ligatures are groups of characters that are run together, i.e,
producing a single glyph.  For example, the letters `f' and `i' can
form a ligature `fi' as in the word `file'.  This produces a cleaner
look (albeit subtle) to the printed output.  Usually, ligatures are not
available in fonts for TTY output devices.

   Most POSTSCRIPT fonts support the fi and fl ligatures.  The C/A/T
typesetter that was the target of AT&T `troff' also supported `ff',
`ffi', and `ffl' ligatures.  Advanced typesetters or `expert' fonts may
include ligatures for `ft' and `ct', although GNU `troff' does not
support these (yet).

 - Request: .lg [flag]
 - Register: \n[.lg]
     Switch the ligature mechanism on or off; if the parameter is
     non-zero or missing, ligatures are enabled, otherwise disabled.
     Default is on.  The current ligature mode can be found in the
     read-only number register `.lg' (set to 1 or 2 if ligatures are
     enabled, 0 otherwise).

     Setting the ligature mode to 2 enables the two-character ligatures
     (fi, fl, and ff) and disables the three-character ligatures (ffi
     and ffl).

   "Pairwise kerning" is another subtle typesetting mechanism that
modifies the distance between a glyph pair to improve readability.  In
most cases (but not always) the distance is decreased.  Typewriter-like
fonts and fonts for terminals where all glyphs have the same width
don't use kerning.

 - Request: .kern [flag]
 - Register: \n[.kern]
     Switch kerning on or off.  If the parameter is non-zero or missing,
     enable pairwise kerning, otherwise disable it.  The read-only
     number register `.kern' is set to 1 if pairwise kerning is enabled,
     0 otherwise.

     If the font description file contains pairwise kerning information,
     glyphs from that font are kerned.  Kerning between two glyphs can
     be inhibited by placing `\&' between them: `V\&A'.

     See Font File Format.

   "Track kerning" expands or reduces the space between glyphs.  This
can be handy, for example, if you need to squeeze a long word onto a
single line or spread some text to fill a narrow column.  It must be
used with great care since it is usually considered bad typography if
the reader notices the effect.

 - Request: .tkf f s1 n1 s2 n2
     Enable track kerning for font F.  If the current font is F the
     width of every glyph is increased by an amount between N1 and N2
     (N1, N2 can be negative); if the current point size is less than
     or equal to S1 the width is increased by N1; if it is greater than
     or equal to S2 the width is increased by N2; if the point size is
     greater than or equal to S1 and less than or equal to S2 the
     increase in width is a linear function of the point size.

     The default scaling indicator is `z' for S1 and S2, `p' for N1 and
     N2.

     Note that the track kerning amount is added even to the rightmost
     glyph in a line; for large values it is thus recommended to
     increase the line length by the same amount to compensate it.

   Sometimes, when typesetting letters of different fonts, more or less
space at such boundaries are needed.  There are two escapes to help
with this.

 - Escape: \/
     Increase the width of the preceding glyph so that the spacing
     between that glyph and the following glyph is correct if the
     following glyph is a roman glyph.  For example, if an italic `f'
     is immediately followed by a roman right parenthesis, then in many
     fonts the top right portion of the `f' overlaps the top left of
     the right parenthesis.  Use this escape sequence whenever an
     italic glyph is immediately followed by a roman glyph without any
     intervening space.  This small amount of space is also called
     "italic correction".

 - Escape: \,
     Modify the spacing of the following glyph so that the spacing
     between that glyph and the preceding glyph is correct if the
     preceding glyph is a roman glyph.  Use this escape sequence
     whenever a roman glyph is immediately followed by an italic glyph
     without any intervening space.  In analogy to above, this space
     could be called "left italic correction", but this term isn't used
     widely.

 - Escape: \&
     Insert a zero-width character, which is invisible.  Its intended
     use is to stop interaction of a character with its surrounding.

        * It prevents the insertion of extra space after an
          end-of-sentence character.

               Test.
               Test.
                   => Test.  Test.
               Test.\&
               Test.
                   => Test. Test.

        * It prevents interpretation of a control character at the
          beginning of an input line.

               .Test
                   => warning: `Test' not defined
               \&.Test
                   => .Test

        * It prevents kerning between two glyphs.

        * It is needed to map an arbitrary character to nothing in the
          `tr' request (see Character Translations).

 - Escape: \)
     This escape is similar to `\&' except that it behaves like a
     character declared with the `cflags' request to be transparent for
     the purposes of an end-of-sentence character.

     Its main usage is in macro definitions to protect against arguments
     starting with a control character.

          .de xxx
          \)\\$1
          ..
          .de yyy
          \&\\$1
          ..
          This is a test.\c
          .xxx '
          This is a test.
              =>This is a test.'  This is a test.
          This is a test.\c
          .yyy '
          This is a test.
              =>This is a test.' This is a test.

Sizes
=====

   `gtroff' uses two dimensions with each line of text, type size and
vertical spacing.  The "type size" is approximately the height of the
tallest glyph.(1) (1)  "Vertical spacing" is the
amount of space `gtroff' allows for a line of text; normally, this is
about 20% larger than the current type size.  Ratios smaller than this
can result in hard-to-read text; larger than this, it spreads the text
out more vertically (useful for term papers).  By default, `gtroff'
uses 10 point type on 12 point spacing.

   The difference between type size and vertical spacing is known, by
typesetters, as "leading" (this is pronounced `ledding').

   (1) This is usually the parenthesis.  Note that in most cases the
real dimensions of the glyphs in a font are _not_ related to its type
size!  For example, the standard POSTSCRIPT font families `Times
Roman', `Helvetica', and `Courier' can't be used together at 10pt; to
get acceptable output, the size of `Helvetica' has to be reduced by one
point, and the size of `Courier' must be increased by one point.

Changing Type Sizes
-------------------

 - Request: .ps [size]
 - Request: .ps +size
 - Request: .ps -size
 - Escape: \sSIZE
 - Register: \n[.s]
     Use the `ps' request or the `\s' escape to change (increase,
     decrease) the type size (in points).  Specify SIZE as either an
     absolute point size, or as a relative change from the current size.
     The size 0, or no argument, goes back to the previous size.

     Default scaling indicator of `size' is `z'.  If `size' is zero or
     negative, it is set to 1u.

     The read-only number register `.s' returns the point size in
     points as a decimal fraction.  This is a string.  To get the point
     size in scaled points, use the `.ps' register instead.

     `.s' is associated with the current environment (see
     Environments).

          snap, snap,
          .ps +2
          grin, grin,
          .ps +2
          wink, wink, \s+2nudge, nudge,\s+8 say no more!
          .ps 10

     The `\s' escape may be called in a variety of ways.  Much like
     other escapes there must be a way to determine where the argument
     ends and the text begins.  Any of the following forms are valid:

    `\sN'
          Set the point size to N points.  N must be either 0 or in the
          range 4 to 39.

    `\s+N'
    `\s-N'
          Increase or decrease the point size by N points.  N must be
          exactly one digit.

    `\s(NN'
          Set the point size to NN points.  NN must be exactly two
          digits.

    `\s+(NN'
    `\s-(NN'
    `\s(+NN'
    `\s(-NN'
          Increase or decrease the point size by NN points.  NN must be
          exactly two digits.

     Note that `\s' doesn't produce an input token in `gtroff'.  As a
     consequence, it can be used in requests like `mc' (which expects a
     single character as an argument) to change the font on the fly:

          .mc \s[20]x\s[0]

     See Fractional Type Sizes, for yet another syntactical form of
     using the `\s' escape.

 - Request: .sizes s1 s2 ... sn [0]
     Some devices may only have certain permissible sizes, in which case
     `gtroff' rounds to the nearest permissible size.  The `DESC' file
     specifies which sizes are permissible for the device.

     Use the `sizes' request to change the permissible sizes for the
     current output device.  Arguments are in scaled points; the
     `sizescale' line in the `DESC' file for the output device provides
     the scaling factor.  For example, if the scaling factor is 1000,
     then the value 12000 is 12 points.

     Each argument can be a single point size (such as `12000'), or a
     range of sizes (such as `4000-72000').  You can optionally end the
     list with a zero.

 - Request: .vs [space]
 - Request: .vs +space
 - Request: .vs -space
 - Register: \n[.v]
     Change (increase, decrease) the vertical spacing by SPACE.  The
     default scaling indicator is `p'.

     If `vs' is called without an argument, the vertical spacing is
     reset to the previous value before the last call to `vs'.

     `gtroff' creates a warning of type `range' if SPACE is zero or
     negative; the vertical spacing is then set to the vertical
     resolution (as given in the `.V' register).

     The read-only number register `.v' contains the current vertical
     spacing; it is associated with the current environment (see
     Environments).

   The effective vertical line spacing consists of four components.

   * The vertical line spacing as set with the `vs' request.

   * The "post-vertical line spacing" as set with the `pvs' request.
     This is vertical space which will be added after a line has been
     output.

   * The "extra pre-vertical line space" as set with the `\x' request,
     using a negative value.  This is vertical space which will be
     added once before the current line has been output.

   * The "extra post-vertical line space" as set with the `\x' request,
     using a positive value.  This is vertical space which will be
     added once after the current line has been output.

   It is usually better to use `vs' or `pvs' instead of `ls' to produce
double-spaced documents: `vs' and `pvs' have a finer granularity for
the inserted vertical space compared to `ls'; furthermore, certain
preprocessors assume single-spacing.

   See Manipulating Spacing, for more details on the `\x' escape
and the `ls' request.

 - Request: .pvs [space]
 - Request: .pvs +space
 - Request: .pvs -space
 - Register: \n[.pvs]
     Change (increase, decrease) the post-vertical spacing by SPACE.
     The default scaling indicator is `p'.

     If `pvs' is called without an argument, the post-vertical spacing
     is reset to the previous value before the last call to `pvs'.

     `gtroff' creates a warning of type `range' if SPACE is zero or
     negative; the vertical spacing is then set to zero.

     The read-only number register `.pvs' contains the current
     post-vertical spacing; it is associated with the current
     environment (see Environments).

Fractional Type Sizes
---------------------

   A "scaled point" is equal to 1/SIZESCALE points, where SIZESCALE is
specified in the `DESC' file (1 by default).  There is a new scale
indicator `z' which has the effect of multiplying by SIZESCALE.
Requests and escape sequences in `gtroff' interpret arguments that
represent a point size as being in units of scaled points, but they
evaluate each such argument using a default scale indicator of `z'.
Arguments treated in this way are the argument to the `ps' request, the
third argument to the `cs' request, the second and fourth arguments to
the `tkf' request, the argument to the `\H' escape sequence, and those
variants of the `\s' escape sequence that take a numeric expression as
their argument (see below).

   For example, suppose SIZESCALE is 1000; then a scaled point is
equivalent to a millipoint; the request `.ps 10.25' is equivalent to
`.ps 10.25z' and thus sets the point size to 10250 scaled points, which
is equal to 10.25 points.

   `gtroff' disallows the use of the `z' scale indicator in instances
where it would make no sense, such as a numeric expression whose
default scale indicator was neither `u' nor `z'.  Similarly it would
make no sense to use a scaling indicator other than `z' or `u' in a
numeric expression whose default scale indicator was `z', and so
`gtroff' disallows this as well.

   There is also new scale indicator `s' which multiplies by the number
of units in a scaled point.  So, for example, `\n[.ps]s' is equal to
`1m'.  Be sure not to confuse the `s' and `z' scale indicators.

 - Register: \n[.ps]
     A read-only number register returning the point size in scaled
     points.

     `.ps' is associated with the current environment (see
     Environments).

 - Register: \n[.psr]
 - Register: \n[.sr]
     The last-requested point size in scaled points is contained in the
     `.psr' read-only number register.  The last requested point size
     in points as a decimal fraction can be found in `.sr'.  This is a
     string-valued read-only number register.

     Note that the requested point sizes are device-independent, whereas
     the values returned by the `.ps' and `.s' registers are not.  For
     example, if a point size of 11pt is requested, and a `sizes'
     request (or a `sizescale' line in a `DESC' file) specifies 10.95pt
     instead, this value is actually used.

     Both registers are associated with the current environment (see
     Environments).

   The `\s' escape has the following syntax for working with fractional
type sizes:

`\s[N]'
`\s'N''
     Set the point size to N scaled points; N is a numeric expression
     with a default scale indicator of `z'.

`\s[+N]'
`\s[-N]'
`\s+[N]'
`\s-[N]'
`\s'+N''
`\s'-N''
`\s+'N''
`\s-'N''
     Increase or or decrease the point size by N scaled points; N is a
     numeric expression with a default scale indicator of `z'.

   See Font Files.

Strings
=======

   `gtroff' has string variables, which are entirely for user
convenience (i.e. there are no built-in strings exept `.T', but even
this is a read-write string variable).

 - Request: .ds name [string]
 - Request: .ds1 name [string]
 - Escape: \*N
 - Escape: \*(NM
 - Escape: \*[NAME ARG1 ARG2 ...]
     Define and access a string variable NAME (one-character name N,
     two-character name NM).  If NAME already exists, `ds' overwrites
     the previous definition.  Only the syntax form using brackets can
     take arguments which are handled identically to macro arguments;
     the single exception is that a closing bracket as an argument must
     be enclosed in double quotes.  See Request Arguments, and
     Parameters.

     Example:

          .ds foo a \\$1 test
          .
          This is \*[foo nice].
              => This is a nice test.

     The `\*' escape "interpolates" (expands in-place) a
     previously-defined string variable.  To be more precise, the stored
     string is pushed onto the input stack which is then parsed by
     `gtroff'.  Similar to number registers, it is possible to nest
     strings, i.e. string variables can be called within string
     variables.

     If the string named by the `\*' escape does not exist, it is
     defined as empty, and a warning of type `mac' is emitted (see
     Debugging, for more details).

     *Caution:* Unlike other requests, the second argument to the `ds'
     request takes up the entire line including trailing spaces.  This
     means that comments on a line with such a request can introduce
     unwanted space into a string.

          .ds UX \s-1UNIX\s0\u\s-3tm\s0\d \" UNIX trademark

     Instead the comment should be put on another line or have the
     comment escape adjacent with the end of the string.

          .ds UX \s-1UNIX\s0\u\s-3tm\s0\d\"  UNIX trademark

     To produce leading space the string can be started with a double
     quote.  No trailing quote is needed; in fact, any trailing quote is
     included in your string.

          .ds sign "           Yours in a white wine sauce,

     Strings are not limited to a single line of text.  A string can
     span several lines by escaping the newlines with a backslash.  The
     resulting string is stored _without_ the newlines.

          .ds foo lots and lots \
          of text are on these \
          next several lines

     It is not possible to have real newlines in a string.  To put a
     single double quote character into a string, use two consecutive
     double quote characters.

     The `ds1' request turns off compatibility mode while interpreting
     a string.  To be more precise, a "compatibility save" input token
     is inserted at the beginning of  the string, and a "compatibility
     restore" input token at the end.

          .nr xxx 12345
          .ds aa The value of xxx is \\n[xxx].
          .ds1 bb The value of xxx ix \\n[xxx].
          .
          .cp 1
          .
          \*(aa
              => warning: number register `[' not defined
              => The value of xxx is 0xxx].
          \*(bb
              => The value of xxx ix 12345.

     Strings, macros, and diversions (and boxes) share the same name
     space.  Internally, even the same mechanism is used to store them.
     This has some interesting consequences.  For example, it is
     possible to call a macro with string syntax and vice versa.

          .de xxx
          a funny test.
          ..
          This is \*[xxx]
              => This is a funny test.

          .ds yyy a funny test
          This is
          .yyy
              => This is a funny test.

     Diversions and boxes can be also called with string syntax.

     Another consequence is that you can copy one-line diversions or
     boxes to a string.

          .di xxx
          a \fItest\fR
          .br
          .di
          .ds yyy This is \*[xxx]\c
          \*[yyy].
              => This is a test.

     As the previous example shows, it is possible to store formatted
     output in strings.  The `\c' escape prevents the insertion of an
     additional blank line in the output.

     Copying diversions longer than a single output line produces
     unexpected results.

          .di xxx
          a funny
          .br
          test
          .br
          .di
          .ds yyy This is \*[xxx]\c
          \*[yyy].
              => test This is a funny.

     Usually, it is not predictable whether a diversion contains one or
     more output lines, so this mechanism should be avoided.  With UNIX
     `troff', this was the only solution to strip off a final newline
     from a diversion.  Another disadvantage is that the spaces in the
     copied string are already formatted, making them unstretchable.
     This can cause ugly results.

     A clean solution to this problem is available in GNU `troff',
     using the requests `chop' to remove the final newline of a
     diversion, and `unformat' to make the horizontal spaces
     stretchable again.

          .box xxx
          a funny
          .br
          test
          .br
          .box
          .chop xxx
          .unformat xxx
          This is \*[xxx].
              => This is a funny test.

     See Gtroff Internals, for more information.

 - Request: .as name [string]
 - Request: .as1 name [string]
     The `as' request is similar to `ds' but appends STRING to the
     string stored as NAME instead of redefining it.  If NAME doesn't
     exist yet, it is created.

          .as sign " with shallots, onions and garlic,

     The `as1' request is similar to `as', but compatibility mode is
     switched off while the appended string is interpreted.  To be more
     precise, a "compatibility save" input token is inserted at the
     beginning of the appended string, and a "compatibility restore"
     input token at the end.

   Rudimentary string manipulation routines are given with the next two
requests.

 - Request: .substring str n1 [n2]
     Replace the string named STR with the substring defined by the
     indices N1 and N2.  The first character in the string has index 0.
     If N2 is omitted, it is taken to be equal to the string's length.
     If the index value N1 or N2 is negative, it is counted from the
     end of the string, going backwards: The last character has
     index -1, the character before the last character has index -2,
     etc.

          .ds xxx abcdefgh
          .substring xxx 1 -4
          \*[xxx]
              => bcde

 - Request: .length reg str
     Compute the number of characters of STR and return it in the
     number register REG.  If REG doesn't exist, it is created.  `str'
     is read in copy mode.

          .ds xxx abcd\h'3i'efgh
          .length yyy \n[xxx]
          \n[yyy]
              => 14

 - Request: .rn xx yy
     Rename the request, macro, diversion, or string XX to YY.

 - Request: .rm xx
     Remove the request, macro, diversion, or string XX.  `gtroff'
     treats subsequent invocations as if the object had never been
     defined.

 - Request: .als new old
     Create an alias named NEW for the request, string, macro, or
     diversion object named OLD.  The new name and the old name are
     exactly equivalent (it is similar to a hard rather than a soft
     link). If OLD is undefined, `gtroff' generates a warning of type
     `mac' and ignores the request.

 - Request: .chop xx
     Remove (chop) the last character from the macro, string, or
     diversion named XX.  This is useful for removing the newline from
     the end of diversions that are to be interpolated as strings.
     This command can be used repeatedly; see Gtroff Internals,
     for details on nodes inserted additionally by `gtroff'.

   See Identifiers, and Comments.

Conditionals and Loops
======================

Operators in Conditionals
-------------------------

   In `if' and `while' requests, there are several more operators
available:

`e'
`o'
     True if the current page is even or odd numbered (respectively).

`n'
     True if the document is being processed in nroff mode (i.e., the
     `.nroff' command has been issued).

`t'
     True if the document is being processed in troff mode (i.e., the
     `.troff' command has been issued).

`v'
     Always false.  This condition is for compatibility with other
     `troff' versions only.

`'XXX'YYY''
     True if the string XXX is equal to the string YYY.  Other
     characters can be used in place of the single quotes; the same set
     of delimiters as for the `\D' escape is used (see Escapes).
     `gtroff' formats the strings before being compared:

          .ie "|"\fR|\fP" \
          true
          .el \
          false
              => true

     The resulting motions, glyph sizes, and fonts have to match,(1)
     (1) and not the
     individual motion, size, and font requests.  In the previous
     example, `|' and `\fR|\fP' both result in a roman `|' glyph with
     the same point size and at the same location on the page, so the
     strings are equal.  If `.ft I' had been added before the `.ie',
     the result would be "false" because (the first) `|' produces an
     italic `|' rather than a roman one.

`r XXX'
     True if there is a number register named XXX.

`d XXX'
     True if there is a string, macro, diversion, or request named XXX.

`m XXX'
     True if there is a color named XXX.

`c G'
     True if there is a glyph G available(2) (2);
     G is either an ASCII character or a
     special character (`\(GG' or `\[GGG]'); the condition is also true
     if G has been defined by the `char' request.

   Note that these operators can't be combined with other operators like
`:' or `&'; only a leading `!' (without whitespace between the
exclamation mark and the operator) can be used to negate the result.

     .nr xxx 1
     .ie !r xxx \
     true
     .el \
     false
         => false

   A whitespace after `!' always evaluates to zero (this bizarre
behaviour is due to compatibility with UNIX `troff').

     .nr xxx 1
     .ie ! r xxx \
     true
     .el \
     false
         => r xxx true

   It is possible to omit the whitespace before the argument to the
`r', `d', and `c' operators.

   See Expressions.

   (1) The created output nodes must be identical.  See Gtroff Internals.

   (2) The name of this conditional operator is a misnomer since it
tests names of output glyphs.

if-else
-------

   `gtroff' has if-then-else constructs like other languages, although
the formatting can be painful.

 - Request: .if expr anything
     Evaluate the expression EXPR, and executes ANYTHING (the remainder
     of the line) if EXPR evaluates to non-zero (true).  ANYTHING is
     interpreted as though it was on a line by itself (except that
     leading spaces are swallowed).  See Expressions, for more info.

          .nr xxx 1
          .nr yyy 2
          .if ((\n[xxx] == 1) & (\n[yyy] == 2)) true
              => true

 - Request: .nop anything
     Executes ANYTHING.  This is similar to `.if 1'.

 - Request: .ie expr anything
 - Request: .el anything
     Use the `ie' and `el' requests to write an if-then-else.  The
     first request is the `if' part and the latter is the `else' part.

          .ie n .ls 2 \" double-spacing in nroff
          .el   .ls 1 \" single-spacing in troff

 - Escape: \{
 - Escape: \}
     In many cases, an if (or if-else) construct needs to execute more
     than one request.  This can be done using the `\{' and `\}'
     escapes.  The following example shows the possible ways to use
     these escapes (note the position of the opening and closing
     braces).

          .ie t \{\
          .    ds lq ``
          .    ds rq ''
          .\}
          .el \
          .\{\
          .    ds lq "
          .    ds rq "\}

   See Expressions.

while
-----

   `gtroff' provides a looping construct using the `while' request,
which is used much like the `if' (and related) requests.

 - Request: .while expr anything
     Evaluate the expression EXPR, and repeatedly execute ANYTHING (the
     remainder of the line) until EXPR evaluates to 0.

          .nr a 0 1
          .while (\na < 9) \{\
          \n+a,
          .\}
          \n+a
              => 1, 2, 3, 4, 5, 6, 7, 8, 9, 10

     Some remarks.

        * The body of a `while' request is treated like the body of a
          `de' request: `gtroff' temporarily stores it in a macro which
          is deleted after the loop has been exited.  It can
          considerably slow down a macro if the body of the `while'
          request (within the macro) is large.  Each time the macro is
          executed, the `while' body is parsed and stored again as a
          temporary macro.

               .de xxx
               .  nr num 10
               .  while (\\n[num] > 0) \{\
               .    \" many lines of code
               .    nr num -1
               .  \}
               ..

          The traditional and ofter better solution (UNIX `troff'
          doesn't have the `while' request) is to use a recursive macro
          instead which is parsed only once during its definition.

               .de yyy
               .  if (\\n[num] > 0) \{\
               .    \" many lines of code
               .    nr num -1
               .    yyy
               .  \}
               ..
               .
               .de xxx
               .  nr num 10
               .  yyy
               ..

          Note that the number of available recursion levels is set
          to 1000 (this is a compile-time constant value of `gtroff').

        * The closing brace of a `while' body must end a line.

               .if 1 \{\
               .  nr a 0 1
               .  while (\n[a] < 10) \{\
               .    nop \n+[a]
               .\}\}
                   => unbalanced \{ \}

 - Request: .break
     Break out of a `while' loop.  Be sure not to confuse this with the
     `br' request (causing a line break).

 - Request: .continue
     Finish the current iteration of a `while' loop, immediately
     restarting the next iteration.

   See Expressions.

Writing Macros
==============

   A "macro" is a collection of text and embedded commands which can be
invoked multiple times.  Use macros to define common operations.

 - Request: .de name [end]
 - Request: .de1 name [end]
 - Request: .dei name [end]
     Define a new macro named NAME.  `gtroff' copies subsequent lines
     (starting with the next one) into an internal buffer until it
     encounters the line `..' (two dots).  The optional second argument
     to `de' changes this to a macro to `.END'.

     There can be whitespace after the first dot in the line containing
     the ending token (either `.' or macro `END').

     Here a small example macro called `P' which causes a break and
     inserts some vertical space.  It could be used to separate
     paragraphs.

          .de P
          .  br
          .  sp .8v
          ..

     The following example defines a macro within another.  Remember
     that expansion must be protected twice; once for reading the macro
     and once for executing.

          \# a dummy macro to avoid a warning
          .de end
          ..
          .
          .de foo
          .  de bar end
          .    nop \f[B]Hallo \\\\$1!\f[]
          .  end
          ..
          .
          .foo
          .bar Joe
              => Hallo Joe!

     Since `\f' has no expansion, it isn't necessary to protect its
     backslash.  Had we defined another macro within `bar' which takes
     a parameter, eight backslashes would be necessary before `$1'.

     The `de1' request turns off compatibility mode while executing the
     macro.  On entry, the current compatibility mode is saved and
     restored at exit.

          .nr xxx 12345
          .
          .de aa
          The value of xxx is \\n[xxx].
          ..
          .de1 bb
          The value of xxx ix \\n[xxx].
          ..
          .
          .cp 1
          .
          .aa
              => warning: number register ^[' not defined
              => The value of xxx is 0xxx].
          .bb
              => The value of xxx ix 12345.

     The `dei' request defines a macro indirectly.  That is, it expands
     strings whose names are NAME or END before performing the append.

     This:

          .ds xx aa
          .ds yy bb
          .dei xx yy

     is equivalent to:

          .de aa bb

     Using `trace.tmac', you can trace calls to `de' and `de1'.

     Note that macro identifiers are shared with identifiers for
     strings and diversions.

 - Request: .am xx
 - Request: .am1 xx
 - Request: .ami xx yy
     Works similarly to `de' except it appends onto the macro named XX.
     So, to make the previously defined `P' macro actually do indented
     instead of block paragraphs, add the necessary code to the
     existing macro like this:

          .am P
          .ti +5n
          ..

     The `am1' request turns off compatibility mode while executing the
     appended macro piece.  To be more precise, a "compatibility save"
     input token is inserted at the beginning of the appended code, and
     a "compatibility restore" input token at the end.

     The `ami' request appends indirectly, meaning that `gtroff'
     expands strings whose names are XX or YY before performing the
     append.

     Using `trace.tmac', you can trace calls to `am' and `am1'.

   See Strings, for the `als' request to rename a macro.

   The `de', `am', `di', `da', `ds', and `as' requests (together with
its variants) only create a new object if the name of the macro,
diversion or string diversion is currently undefined or if it is
defined to be a request; normally they modify the value of an existing
object.

 - Request: .return
     Exit a macro, immediately returning to the caller.

Copy-in Mode
------------

   When `gtroff' reads in the text for a macro, string, or diversion,
it copies the text (including request lines, but excluding escapes) into
an internal buffer.  Escapes are converted into an internal form,
except for `\n', `\$', `\*', `\\' and `\<RET>' which are evaluated and
inserted into the text where the escape was located.  This is known as
"copy-in" mode or "copy" mode.

   What this means is that you can specify when these escapes are to be
evaluated (either at copy-in time or at the time of use) by insulating
the escapes with an extra backslash.  Compare this to the `\def' and
`\edef' commands in TeX.

   The following example prints the numbers 20 and 10:

     .nr x 20
     .de y
     .nr x 10
     \&\nx
     \&\\nx
     ..
     .y

Parameters
----------

   The arguments to a macro or string can be examined using a variety of
escapes.

 - Register: \n[.$]
     The number of arguments passed to a macro or string.  This is a
     read-only number register.

   Any individual argument can be retrieved with one of the following
escapes:

 - Escape: \$N
 - Escape: \$(NN
 - Escape: \$[NNN]
     Retrieve the Nth, NNth or NNNth argument.  As usual, the first
     form only accepts a single number (larger than zero), the second a
     two-digit number (larger or equal to 10), and the third any
     positive integer value (larger than zero).  Macros and strings can
     have an unlimited number of arguments.  Note that due to copy-in
     mode, use two backslashes on these in actual use to prevent
     interpolation until the macro is actually invoked.

 - Request: .shift [n]
     Shift the arguments 1 position, or as many positions as specified
     by its argument.  After executing this request, argument I becomes
     argument I-N; arguments 1 to N are no longer available.  Shifting
     by negative amounts is currently undefined.

 - Escape: \$*
 - Escape: \$@
     In some cases it is convenient to use all of the arguments at once
     (for example, to pass the arguments along to another macro).  The
     `\$*' escape concatenates all the arguments separated by spaces.  A
     similar escape is `\$@', which concatenates all the arguments with
     each surrounded by double quotes, and separated by spaces.  If not
     in compatibility mode, the input level of double quotes is
     preserved (see Request Arguments).

 - Escape: \$0
     The name used to invoke the current macro.  The `als' request can
     make a macro have more than one name.

          .de generic-macro
          .  ...
          .  if \\n[error] \{\
          .    tm \\$0: Houston, we have a problem.
          .    return
          .  \}
          ..
          .
          .als foo generic-macro
          .als bar generic-macro

   See Request Arguments.

Page Motions
============

   See Manipulating Spacing, for a discussion of the main request
for vertical motion, `sp'.

 - Request: .mk [reg]
 - Request: .rt [dist]
     The request `mk' can be used to mark a location on a page, for
     movement to later.  This request takes a register name as an
     argument in which to store the current page location.  With no
     argument it stores the location in an internal register.  The
     results of this can be used later by the `rt' or the `sp' request
     (or the `\v' escape).

     The `rt' request returns _upwards_ to the location marked with the
     last `mk' request.  If used with an argument, return to a position
     which distance from the top of the page is DIST (no previous call
     to `mk' is necessary in this case).  Default scaling indicator is
     `v'.

     Here a primitive solution for a two-column macro.

          .nr column-length 1.5i
          .nr column-gap 4m
          .nr bottom-margin 1m
          .

          .de 2c
          .  br
          .  mk
          .  ll \\n[column-length]u
          .  wh -\\n[bottom-margin]u 2c-trap
          .  nr right-side 0
          ..
          .

          .de 2c-trap
          .  ie \\n[right-side] \{\
          .    nr right-side 0
          .    po -(\\n[column-length]u + \\n[column-gap]u)
          .    \" remove trap
          .    wh -\\n[bottom-margin]u
          .  \}
          .  el \{\
          .    \" switch to right side
          .    nr right-side 1
          .    po +(\\n[column-length]u + \\n[column-gap]u)
          .    rt
          .  \}
          ..
          .

          .pl 1.5i
          .ll 4i
          This is a small test which shows how the
          rt request works in combination with mk.

          .2c
          Starting here, text is typeset in two columns.
          Note that this implementation isn't robust
          and thus not suited for a real two-column
          macro.

     Result:

          This is a small test which shows how the
          rt request works in combination with mk.

          Starting  here,    isn't    robust
          text is typeset    and   thus  not
          in two columns.    suited  for   a
          Note that  this    real two-column
          implementation     macro.

   The following escapes give fine control of movements about the page.

 - Escape: \v'E'
     Move vertically, usually from the current location on the page (if
     no absolute position operator `|' is used).  The argument E
     specifies the distance to move; positive is downwards and negative
     upwards.  The default scaling indicator for this escape is `v'.
     Beware, however, that `gtroff' continues text processing at the
     point where the motion ends, so you should always balance motions
     to avoid interference with text processing.

     `\v' doesn't trigger a trap.  This can be quite useful; for
     example, consider a page bottom trap macro which prints a marker
     in the margin to indicate continuation of a footnote or something
     similar.

   There are some special-case escapes for vertical motion.

 - Escape: \r
     Move upwards 1v.

 - Escape: \u
     Move upwards .5v.

 - Escape: \d
     Move down .5v.

 - Escape: \h'E'
     Move horizontally, usually from the current location (if no
     absolute position operator `|' is used).  The expression E
     indicates how far to move: positive is rightwards and negative
     leftwards.  The default scaling indicator for this escape is `m'.

   There are a number of special-case escapes for horizontal motion.

 - Escape: \<SP>
     An unbreakable and unpaddable (i.e. not expanded during filling)
     space.  (Note: This is a backslash followed by a space.)

 - Escape: \~
     An unbreakable space that stretches like a normal inter-word space
     when a line is adjusted.

 - Escape: \|
     A 1/6th em space.  Ignored for TTY output devices (rounded to
     zero).

 - Escape: \^
     A 1/12th em space.  Ignored for TTY output devices (rounded to
     zero).

 - Escape: \0
     A space the size of a digit.

   The following string sets the TeX logo:

     .ds TeX T\h'-.1667m'\v'.224m'E\v'-.224m'\h'-.125m'X

 - Escape: \w'TEXT'
 - Register: \n[st]
 - Register: \n[sb]
 - Register: \n[rst]
 - Register: \n[rsb]
 - Register: \n[ct]
 - Register: \n[ssc]
 - Register: \n[skw]
     Return the width of the specified TEXT in basic units.  This
     allows horizontal movement based on the width of some arbitrary
     text (e.g. given as an argument to a macro).

          The length of the string `abc' is \w'abc'u.
              => The length of the string `abc' is 72u.

     Font changes may occur in TEXT which don't affect current settings.

     After use, `\w' sets several registers:

    `st'
    `sb'
          The highest and lowest point of the baseline, respectively,
          in TEXT.

    `rst'
    `rsb'
          Like the `st' and `sb' registers, but takes account of the
          heights and depths of glyphs.  With other words, this gives
          the highest and lowest point of TEXT.

    `ct'
          Defines the kinds of glyphs occurring in TEXT:

         0
               only short glyphs, no descenders or tall glyphs.

         1
               at least one descender.

         2
               at least one tall glyph.

         3
               at least one each of a descender and a tall glyph.

    `ssc'
          The amount of horizontal space (possibly negative) that
          should be added to the last glyph before a subscript.

    `skw'
          How far to right of the center of the last glyph in the `\w'
          argument, the center of an accent from a roman font should be
          placed over that glyph.

 - Escape: \kP
 - Escape: \k(PS
 - Escape: \k[POSITION]
     Store the current horizontal position in the _input_ line in
     number register with name POSITION (one-character name P,
     two-character name PS).  Use this, for example, to return to the
     beginning of a string for highlighting or other decoration.

 - Register: \n[hp]
     The current horizontal position at the input line.

 - Register: \n[.k]
     A read-only number register containing the current horizontal
     output position.

 - Escape: \o'ABC'
     Overstrike glyphs A, B, C, ...; the glyphs are centered, and the
     resulting spacing is the largest width of the affected glyphs.

 - Escape: \zG
     Print glyph G with zero width, i.e., without spacing.  Use this to
     overstrike glyphs left-aligned.

 - Escape: \Z'ANYTHING'
     Print ANYTHING, then restore the horizontal and vertical position.
     The argument may not contain tabs or leaders.

     The following is an example of a strike-through macro:

          .de ST
          .nr ww \w'\\$1'
          \Z@\v'-.25m'\l'\\n[ww]u'@\\$1
          ..
          .
          This is
          .ST "a test"
          an actual emergency!

Drawing Requests
================

   `gtroff' provides a number of ways to draw lines and other figures
on the page.  Used in combination with the page motion commands (see
Page Motions, for more info), a wide variety of figures can be
drawn.  However, for complex drawings these operations can be quite
cumbersome, and it may be wise to use graphic preprocessors like `gpic'
or `ggrn'.  See gpic, and ggrn, for more information.

   All drawing is done via escapes.

 - Escape: \l'L'
 - Escape: \l'LG'
     Draw a line horizontally.  L is the length of the line to be
     drawn.  If it is positive, start the line at the current location
     and draw to the right; its end point is the new current location.
     Negative values are handled differently: The line starts at the
     current location and draws to the left, but the current location
     doesn't move.

     L can also be specified absolutely (i.e. with a leading `|') which
     draws back to the beginning of the input line.  Default scaling
     indicator is `m'.

     The optional second parameter G is a glyph to draw the line with.
     If this second argument is not specified, `gtroff' uses the
     underscore glyph, `\[ru]'.

     To separate the two arguments (to prevent `gtroff' from
     interpreting a drawing glyph as a scaling indicator if the glyph is
     represented by a single character) use `\&'.

     Here a small useful example:

          .de box
          \[br]\\$*\[br]\l'|0\[rn]'\l'|0\[ul]'
          ..

     Note that this works by outputting a box rule (a vertical line),
     then the text given as an argument and then another box rule.
     Finally, the line drawing escapes both draw from the current
     location to the beginning of the _input_ line - this works because
     the line length is negative, not moving the current point.

 - Escape: \L'L'
 - Escape: \L'LG'
     Draw vertical lines.  Its parameters are similar to the `\l'
     escape, except that the default scaling indicator is `v'.  The
     movement is downwards for positive values, and upwards for
     negative values.  The default glyph is the box rule glyph,
     `\[br]'.  As with the vertical motion escapes, text processing
     blindly continues where the line ends.

          This is a \L'3v'test.

     Here the result, produced with `grotty'.

          This is a
                    |
                    |
                    |test.

 - Escape: \D'COMMAND ARG ...'
     The `\D' escape provides a variety of drawing functions.  Note
     that on character devices, only vertical and horizontal lines are
     supported within `grotty'; other devices may only support a subset
     of the available drawing functions.

     The default scaling indicator for all subcommands of `\D' is `m'
     for horizontal distances and `v' for vertical ones.  Exceptions
     are `\D'f ...'' and `\D't ...'' which use `u' as the default.

    `\D'l DX DY''
          Draw a line from the current location to the relative point
          specified by (DX,DY).

          The following example is a macro for creating a box around a
          text string; for simplicity, the box margin is taken as a
          fixed value, 0.2m.

               .de BOX
               .  nr @wd \w'\\$1'
               \h'.2m'\
               \h'-.2m'\v'(.2m - \\n[rsb]u)'\
               \D'l 0 -(\\n[rst]u - \\n[rsb]u + .4m)'\
               \D'l (\\n[@wd]u + .4m) 0'\
               \D'l 0 (\\n[rst]u - \\n[rsb]u + .4m)'\
               \D'l -(\\n[@wd]u + .4m) 0'\
               \h'.2m'\v'-(.2m - \\n[rsb]u)'\
               \\$1\
               \h'.2m'
               ..

          First, the width of the string is stored in register `@wd'.
          Then, four lines are drawn to form a box, properly offset by
          the box margin.  The registers `rst' and `rsb' are set by the
          `\w' escape, containing the largest height and depth of the
          whole string.

    `\D'c D''
          Draw a circle with a diameter of D with the leftmost point at
          the current position.

    `\D'C D''
          Draw a solid circle with the same parameters as an outlined
          circle.  No outline is drawn.

    `\D'e X Y''
          Draw an ellipse with a horizontal diameter of X and a vertical
          diameter of Y with the leftmost point at the current position.

    `\D'E X Y''
          Draw a solid ellipse with the same parameters as an outlined
          ellipse.  No outline is drawn.

    `\D'a DX1 DY1 DX2 DY2''
          Draw an arc clockwise from the current location through the
          two specified relative locations (DX1,DY1) and (DX2,DY2).
          The coordinates of the first point are relative to the
          current position, and the coordinates of the second point are
          relative to the first point.

    `\D'~ DX1 DY1 DX2 DY2 ...''
          Draw a spline from the current location to the relative point
          (DX1,DY1) and then to (DX2,DY2), and so on.

    `\D'f N''
          Set the shade of gray to be used for filling solid objects
          to N; N must be an integer between 0 and 1000, where 0
          corresponds solid white and 1000 to solid black, and values
          in between correspond to intermediate shades of gray.  This
          applies only to solid circles, solid ellipses, and solid
          polygons.  By default, a level of 1000 is used.

    `\D'p DX1 DY1 DX2 DY2 ...''
          Draw a polygon from the current location to the relative
          position (DX1,DY1) and then to (DX2,DY2) and so on.  When the
          specified data points are exhausted, a line is drawn back to
          the starting point.

    `\D'P DX1 DY1 DX2 DY2 ...''
          Draw a solid polygon with the same parameters as an outlined
          polygon.  No outline is drawn.

          Here a better variant of the box macro to fill the box with
          some color.  Note that the box must be drawn before the text
          since colors in `gtroff' are not transparent; the filled
          polygon would hide the text completely.

               .de BOX
               .  nr @wd \w'\\$1'
               \h'.2m'\
               \h'-.2m'\v'(.2m - \\n[rsb]u)'\
               \M[lightcyan]\
               \D'P 0 -(\\n[rst]u - \\n[rsb]u + .4m) \
                    (\\n[@wd]u + .4m) 0 \
                    0 (\\n[rst]u - \\n[rsb]u + .4m) \
                    -(\\n[@wd]u + .4m) 0'\
               \h'.2m'\v'-(.2m - \\n[rsb]u)'\
               \M[]\
               \\$1\
               \h'.2m'
               ..

    `\D't N''
          Set the current line thickness to N machine units.  A value of
          zero selects the smallest available line thickness.  A
          negative value makes the line thickness proportional to the
          current point size (this is the default behaviour of AT&T
          `troff').

   See Graphics Commands.

 - Escape: \b'STRING'
     "Pile" a sequence of glyphs vertically, and center it vertically
     on the current line.  Use it to build large brackets and braces.

     Here an example how to create a large opening brace:

          \b'\[lt]\[bv]\[lk]\[bv]\[lb]'

     The first glyph is on the top, the last glyph in STRING is at the
     bottom.  Note that `gtroff' separates the glyphs vertically by 1m,
     and the whole object is centered 0.5m above the current baseline;
     the largest glyph width is used as the width for the whole object.
     This rather unflexible positioning algorithm doesn't work with
     `-Tdvi' since the bracket pieces vary in height for this device.
     Instead, use the `eqn' preprocessor.

     See Manipulating Spacing, how to adjust the vertical spacing
     with the `\x' escape.

Traps
=====

   "Traps" are locations, which, when reached, call a specified macro.
These traps can occur at a given location on the page, at a given
location in the current diversion, at a blank line, after a certain
number of input lines, or at the end of input.

   Setting a trap is also called "planting".  It is also said that a
trap is "sprung" if the associated macro is executed.

Page Location Traps
-------------------

   "Page location traps" perform an action when `gtroff' reaches or
passes a certain vertical location on the page.  Page location traps
have a variety of purposes, including:

   * setting headers and footers

   * setting body text in multiple columns

   * setting footnotes

 - Request: .vpt flag
 - Register: \n[.vpt]
     Enable vertical position traps if FLAG is non-zero, or disables
     them otherwise.  Vertical position traps are traps set by the `wh'
     or `dt' requests.  Traps set by the `it' request are not vertical
     position traps.  The parameter that controls whether vertical
     position traps are enabled is global.  Initially vertical position
     traps are enabled.  The current setting of this is available in the
     `.vpt' read-only number register.

 - Request: .wh dist [macro]
     Set a page location trap.  Positive values for DIST set the trap
     relative to the top of the page; negative values set the trap
     relative to the bottom of the page.  Default scaling indicator is
     `v'.

     MACRO is the name of the macro to execute when the trap is sprung.
     If MACRO is missing, remove the first trap (if any) at DIST.

     The following is a simple example of how many macro packages set
     headers and footers.

          .de hd                \" Page header
          '  sp .5i
          .  tl 'Title''date'
          '  sp .3i
          ..
          .
          .de fo                \" Page footer
          '  sp 1v
          .  tl ''%''
          '  bp
          ..
          .
          .wh 0   hd            \" trap at top of the page
          .wh -1i fo            \" trap one inch from bottom

     A trap at or below the bottom of the page is ignored; it can be
     made active by either moving it up or increasing the page length
     so that the trap is on the page.

     It is possible to have more than one trap at the same location; to
     do so, the traps must be defined at different locations, then
     moved together with the `ch' request; otherwise the second trap
     would replace the first one.  Earlier defined traps hide later
     defined traps if moved to the same position (the many empty lines
     caused by the `bp' request are omitted):

          .de a
          .  nop a
          ..
          .de b
          .  nop b
          ..
          .de c
          .  nop c
          ..
          .
          .wh 1i a
          .wh 2i b
          .wh 3i c
          .bp
              => a b c

          .ch b 1i
          .ch c 1i
          .bp
              => a

          .ch a 0.5i
          .bp
              => a b

 - Register: \n[.t]
     A read-only number register holding the distance to the next trap.

     If there are no traps between the current position and the bottom
     of the page, it contains the distance to the page bottom.  In a
     diversion, the distance to the page bottom is infinite (the
     returned value is the biggest integer which can be represented in
     `groff') if there are no diversion traps.

 - Request: .ch macro dist
     Change the location of a trap.  The first argument is the name of
     the macro to be invoked at the trap, and the second argument is
     the new location for the trap (note that the parameters are
     specified the opposite of the `wh' request).  This is useful for
     building up footnotes in a diversion to allow more space at the
     bottom of the page for them.

     Default scaling indicator for DIST is `v'.  If DIST is missing,
     the trap is removed.

 - Register: \n[.ne]
     The read-only number register `.ne' contains the amount of space
     that was needed in the last `ne' request that caused a trap to be
     sprung.  Useful in conjunction with the `.trunc' register.  See
     Page Control, for more information.

 - Register: \n[.trunc]
     A read-only register containing the amount of vertical space
     truncated by the most recently sprung vertical position trap, or,
     if the trap was sprung by an `ne' request, minus the amount of
     vertical motion produced by the `ne' request.  In other words, at
     the point a trap is sprung, it represents the difference of what
     the vertical position would have been but for the trap, and what
     the vertical position actually is.

Diversion Traps
---------------

 - Request: .dt dist macro
     Set a trap _within_ a diversion.  DIST is the location of the trap
     (identical to the `.wh' request; default scaling indicator is `v')
     and MACRO is the name of the macro to be invoked.  The number
     register `.t' still works within diversions.  See Diversions,
     for more information.

Input Line Traps
----------------

 - Request: .it n macro
 - Request: .itc n macro
     Set an input line trap.  N is the number of lines of input which
     may be read before springing the trap, MACRO is the macro to be
     invoked.  Request lines are not counted as input lines.

     For example, one possible use is to have a macro which prints the
     next N lines in a bold font.

          .de B
          .  it \\$1 B-end
          .  ft B
          ..
          .
          .de B-end
          .  ft R
          ..

     The `itc' request is identical, except that a line interrupted
     with `\c' counts as one input line.

     Both requests are associated with the current environment (see
     Environments); switching to another environment disables the
     current input trap, and going back reactivates it, restoring the
     number of already processed lines.

Blank Line Traps
----------------

 - Request: .blm macro
     Set a blank line trap.  `gtroff' executes MACRO when it encounters
     a blank line in the input file.

End-of-input Traps
------------------

 - Request: .em macro
     Set a trap at the end of input.  MACRO is executed after the last
     line of the input file has been processed.

     For example, if the document had to have a section at the bottom
     of the last page for someone to approve it, the `em' request could
     be used.

          .de approval
          .  ne 5v
          .  sp |(\\n[.t] - 6v)
          .  in +4i
          .  lc _
          .  br
          Approved:\t\a
          .  sp
          Date:\t\t\a
          ..
          .
          .em approval

Diversions
==========

   In `gtroff' it is possible to "divert" text into a named storage
area.  Due to the similarity to defining macros it is sometimes said to
be stored in a macro.  This is used for saving text for output at a
later time, which is useful for keeping blocks of text on the same
page, footnotes, tables of contents, and indices.

   For orthogonality it is said that `gtroff' is in the "top-level
diversion" if no diversion is active (i.e., the data is diverted to the
output device).

 - Request: .di macro
 - Request: .da macro
     Begin a diversion.  Like the `de' request, it takes an argument of
     a macro name to divert subsequent text into.  The `da' macro
     appends to an existing diversion.

     `di' or `da' without an argument ends the diversion.

 - Request: .box macro
 - Request: .boxa macro
     Begin (or appends to) a diversion like the `di' and `da' requests.
     The difference is that `box' and `boxa' do not include a
     partially-filled line in the diversion.

     Compare this:

          Before the box.
          .box xxx
          In the box.
          .br
          .box
          After the box.
          .br
              => Before the box.  After the box.
          .xxx
              => In the box.

     with this:

          Before the diversion.
          .di yyy
          In the diversion.
          .br
          .di
          After the diversion.
          .br
              => After the diversion.
          .yyy
              => Before the diversion.  In the diversion.

     `box' or `boxa' without an argument ends the diversion.

 - Register: \n[.z]
 - Register: \n[.d]
     Diversions may be nested.  The read-only number register `.z'
     contains the name of the current diversion (this is a string-valued
     register).  The read-only number register `.d' contains the current
     vertical place in the diversion.  If not in a diversion it is the
     same as the register `nl'.

 - Register: \n[.h]
     The "high-water mark" on the current page.  It corresponds to the
     text baseline of the lowest line on the page.  This is a read-only
     register.

          .tm .h==\n[.h], nl==\n[nl]
              => .h==0, nl==-1
          This is a test.
          .br
          .sp 2
          .tm .h==\n[.h], nl==\n[nl]
              => .h==40, nl==120

     As can be seen in the previous example, empty lines are not
     considered in the return value of the `.h' register.

 - Register: \n[dn]
 - Register: \n[dl]
     After completing a diversion, the read-write number registers `dn'
     and `dl' contain the vertical and horizontal size of the diversion.

          .\" Center text both horizontally & vertically
          .
          .\" Enclose macro definitions in .eo and .ec
          .\" to avoid the doubling of the backslash
          .eo
          .\" macro .(c starts centering mode
          .de (c
          .  br
          .  ev (c
          .  evc 0
          .  in 0
          .  nf
          .  di @c
          ..

          .\" macro .)c terminates centering mode
          .de )c
          .  br
          .  ev
          .  di
          .  nr @s (((\n[.t]u - \n[dn]u) / 2u) - 1v)
          .  sp \n[@s]u
          .  ce 1000
          .  @c
          .  ce 0
          .  sp \n[@s]u
          .  br
          .  fi
          .  rr @s
          .  rm @s
          .  rm @c
          ..
          .\" End of macro definitions, restore escape mechanism
          .ec

 - Escape: \!
 - Escape: \?ANYTHING\?
     Prevent requests, macros, and escapes from being interpreted when
     read into a diversion.  This takes the given text and
     "transparently" embeds it into the diversion.  This is useful for
     macros which shouldn't be invoked until the diverted text is
     actually output.

     The `\!' escape transparently embeds text up to and including the
     end of the line.  The `\?' escape transparently embeds text until
     the next occurrence of the `\?' escape.  For example:

          \?ANYTHING\?

     ANYTHING may not contain newlines; use `\!'  to embed newlines in
     a diversion.  The escape sequence `\?' is also recognized in copy
     mode and turned into a single internal code; it is this code that
     terminates ANYTHING.  Thus the following example prints 4.

          .nr x 1
          .nf
          .di d
          \?\\?\\\\?\\\\\\\\nx\\\\?\\?\?
          .di
          .nr x 2
          .di e
          .d
          .di
          .nr x 3
          .di f
          .e
          .di
          .nr x 4
          .f

     Both escapes read the data in copy mode.

     If `\!' is used in the top-level diversion, its argument is
     directly embedded into the `gtroff' intermediate output.  This can
     be used for example to control a postprocessor which processes the
     data before it is sent to the device driver.

     The `\?' escape used in the top-level diversion produces no output
     at all; its argument is simply ignored.

 - Request: .output string
     Emit STRING directly to the `gtroff' intermediate output (subject
     to copy-mode interpretation);  this is similar to `\!' used at the
     top level.  An initial double quote in STRING is stripped off to
     allow initial blanks.

     This request can't be used before the first page has started - if
     you get an error, simply insert `.br' before the `output' request.

     Without argument, `output' is ignored.

     Use with caution!  It is normally only needed for mark-up used by a
     postprocessor which does something with the output before sending
     it to the output device, filtering out `string' again.

 - Request: .asciify div
     "Unformat" the diversion specified by DIV in such a way that ASCII
     characters, characters translated with the `trin' request, space
     characters, and some escape sequences that were formatted and
     diverted are treated like ordinary input characters when the
     diversion is reread.  It can be also used for gross hacks; for
     example, the following sets register `n' to 1.

          .tr @.
          .di x
          @nr n 1
          .br
          .di
          .tr @@
          .asciify x
          .x

     See Copy-in Mode.

 - Request: .unformat div
     Like `asciify', unformat the specified diversion.  However,
     `unformat' only unformats spaces and tabs between words.
     Unformatted tabs are treated as input tokens, and spaces are
     stretchable again.

     The vertical size of lines is not preserved; glyph information
     (font, font size, space width, etc.) is retained.

Environments
============

   It happens frequently that some text should be printed in a certain
format regardless of what may be in effect at the time, for example, in
a trap invoked macro to print headers and footers.  To solve this
`gtroff' processes text in "environments".  An environment contains
most of the parameters that control text processing.  It is possible to
switch amongst these environments; by default `gtroff' processes text
in environment 0.  The following is the information kept in an
environment.

   * font parameters (size, family, style, glyph height and slant, space
     and sentence space size)

   * page parameters (line length, title length, vertical spacing, line
     spacing, indentation, line numbering, centering, right-justifying,
     underlining, hyphenation data)

   * fill and adjust mode

   * tab stops, tab and leader characters, escape character, no-break
     and hyphen indicators, margin character data

   * partially collected lines

   * input traps

   * drawing and fill colours

   These environments may be given arbitrary names (see
Identifiers, for more info).  Old versions of `troff' only had
environments named `0', `1', and `2'.

 - Request: .ev [env]
 - Register: \n[.ev]
     Switch to another environment.  The argument ENV is the name of
     the environment to switch to.  With no argument, `gtroff' switches
     back to the previous environment.  There is no limit on the number
     of named environments; they are created the first time that they
     are referenced.  The `.ev' read-only register contains the name or
     number of the current environment.  This is a string-valued
     register.

     Note that a call to `ev' (with argument) pushes the previously
     active environment onto a stack.  If, say, environments `foo',
     `bar', and `zap' are called (in that order), the first `ev'
     request without parameter switches back to environment `bar'
     (which is popped off the stack), and a second call switches back
     to environment `foo'.

     Here is an example:

          .ev footnote-env
          .fam N
          .ps 6
          .vs 8
          .ll -.5i
          .ev

          ...

          .ev footnote-env
          \(dg Note the large, friendly letters.
          .ev

 - Request: .evc env
     Copy the environment ENV into the current environment.

     The following environment data is not copied:

        * Partially filled lines.

        * The status whether the previous line was interrupted.

        * The number of lines still to center, or to right-justify, or
          to underline (with or without underlined spaces); they are
          set to zero.

        * The status whether a temporary indent is active.

        * Input traps and its associated data.

        * Line numbering mode is disabled; it can be reactivated with
          `.nm +0'.

        * The number of consecutive hyphenated lines (set to zero).

 - Register: \n[.cht]
 - Register: \n[.cdp]
 - Register: \n[.csk]
     The `\n[.cht]' register contains the maximum extent (above the
     baseline) of the last glyph added to the current environment.

     The `\n[.cdp]' register contains the maximum extent (below the
     baseline) of the last glyph added to the current environment.

     The `\n[.csk]' register contains the "skew" (how far to the right
     of the glyph's center that `gtroff' shold place an accent) of the
     last glyph added to the current environment.

Suppressing output
==================

 - Escape: \ONUM
     Disable or enable output depending on the value of NUM:

    `\O0'
          Disable any glyphs from being emitted to the device driver,
          provided that the escape occurs at the outer level (see
          `\O[3]' and `\O[4]').  Motion is not suppressed so
          effectively `\O[0]' means _pen up_.

    `\O1'
          Enable output of glyphs, provided that the escape occurs at
          the outer level.

     `\O0' and `\O1' also reset the four registers `opminx', `opminy',
     `opmaxx', and `opmaxy' to -1.  See Register Index.  These four
     registers mark the top left and bottom right hand corners of a box
     which encompasses all written glyphs.

     For example the input text:

          Hello \O[0]world \O[1]this is a test.

     produces the following output:

          Hello       this is a test.

    `\O2'
          Provided that the escape occurs at the outer level, enable
          output of glyphs and also write out to `stderr' the page
          number and four registers encompassing the glyphs previously
          written since the last call to `\O'.

    `\O3'
          Begin a nesting level.  At start-up, `gtroff' is at outer
          level.

    `\O4'
          End a nesting level.

    `\O[5PFILENAME]'
          This escape is `grohtml' specific.  Provided that this escape
          occurs at the outer nesting level write the `filename' to
          `stderr'.  The position of the image, P, must be specified
          and must be one of `l', `r', `c', or `i' (left, right,
          centered, inline).  FILENAME will be associated with the
          production of the next inline image.

Colors
======

 - Request: .color [n]
 - Register: \n[.color]
     If N is missing or non-zero, activate colors (this is the default);
     otherwise, turn it off.

     The read-only number register `.color' is 1 if colors are active,
     0 otherwise.

     Internally, `color' sets a global flag; it does not produce a
     token.  Similar to the `cp' request, you should use it at the
     beginning of your document to control color output.

     Colors can be also turned off with the `-c' command line option.

 - Request: .defcolor ident scheme color_components
     Define color with name IDENT.  SCHEME can be one of  the following
     values: `rgb' (three components), `cym' (three components), `cmyk'
     (four components), and `gray' or `grey' (one component).

     Color components can be given either as a hexadecimal string or as
     positive decimal integers in the range 0-65535.  A hexadecimal
     string contains all color components concatenated.  It must start
     with either `#' or `##'; the former specifies hex values in the
     range 0-255 (which are internally multiplied by 257), the latter
     in the range 0-65535.  Examples: `#FFC0CB' (pink), `##ffff0000ffff'
     (magenta).  The default color name value is device-specific
     (usually black).  It is possible that the default color for `\m'
     and `\M' is not identical.

     A new scaling indicator `f' has been introduced which multiplies
     its value by 65536; this makes it convenient to specify color
     components as fractions in the range 0 to 1 (1f equals 65536u).
     Example:

          .defcolor darkgreen rgb 0.1f 0.5f 0.2f

     Note that `f' is the default scaling indicator for the `defcolor'
     request, thus the above statement is equivalent to

          .defcolor darkgreen rgb 0.1 0.5 0.2

 - Escape: \mC
 - Escape: \m(CO
 - Escape: \m[COLOR]
     Set drawing color.  The following example shows how to turn the
     next four words red.

          \m[red]these are in red\m[] and these words are in black.

     The escape `\m[]' returns to the previous color.

     The drawing color is associated with the current environment
     (see Environments).

     Note that `\m' doesn't produce an input token in `gtroff'.  As a
     consequence, it can be used in requests like `mc' (which expects a
     single character as an argument) to change the color on the fly:

          .mc \m[red]x\m[]

 - Escape: \MC
 - Escape: \M(CO
 - Escape: \M[COLOR]
     Set background color for filled objects drawn with the `\D'...''
     commands.

     A red ellipse can be created with the following code:

          \M[red]\h'0.5i'\D'E 2i 1i'\M[]

     The escape `\M[]' returns to the previous fill color.

     The fill color is associated with the current environment (see
     Environments).

     Note that `\M' doesn't produce an input token in `gtroff'.

I/O
===

   `gtroff' has several requests for including files:

 - Request: .so file
     Read in the specified FILE and includes it in place of the `so'
     request.  This is quite useful for large documents, e.g. keeping
     each chapter in a separate file.  See gsoelim, for more
     information.

     Since `gtroff' replaces the `so' request with the contents of
     `file', it makes a difference whether the data is terminated with
     a newline or not: Assuming that file `xxx' contains the word `foo'
     without a final newline, this

          This is
          .so xxx
          bar

     yields `This is foobar'.

 - Request: .pso command
     Read the standard output from the specified COMMAND and includes
     it in place of the `pso' request.

     This request causes an error if used in safer mode (which is the
     default).  Use `groff''s or `troff''s `-U' option to activate
     unsafe mode.

     The comment regarding a final newline for the `so' request is valid
     for `pso' also.

 - Request: .mso file
     Identical to the `so' request except that `gtroff' searches for
     the specified FILE in the same directories as macro files for the
     the `-m' command line option.  If the file name to be included has
     the form `NAME.tmac' and it isn't found, `mso' tries to include
     `tmac.NAME' and vice versa.

 - Request: .trf file
 - Request: .cf file
     Transparently output the contents of FILE.  Each line is output as
     if it were preceded by `\!'; however, the lines are not subject to
     copy mode interpretation.  If the file does not end with a newline,
     then a newline is added (`trf' only).  For example, to define a
     macro `x' containing the contents of file `f', use

          .di x
          .trf f
          .di

     Both `trf' and `cf', when used in a diversion, embeds an object in
     the diversion which, when reread, causes the contents of FILE to
     be transparently copied through to the output.  In UNIX `troff',
     the contents of FILE is immediately copied through to the output
     regardless of whether there is a current diversion; this behaviour
     is so anomalous that it must be considered a bug.

     While `cf' copies the contents of FILE completely unprocessed,
     `trf' disallows characters such as NUL that are not valid `gtroff'
     input characters (see Identifiers).

     Both requests cause a line break.

 - Request: .nx [file]
     Force `gtroff' to continue processing of the file specified as an
     argument.  If no argument is given, immediately jump to the end of
     file.

 - Request: .rd [prompt [arg1 arg2 ...]]
     Read from standard input, and include what is read as though it
     were part of the input file.  Text is read until a blank line is
     encountered.

     If standard input is a TTY input device (keyboard), write PROMPT
     to standard error, followed by a colon (or send BEL for a beep if
     no argument is given).

     Arguments after PROMPT are available for the input.  For example,
     the line

          .rd data foo bar

     with the input `This is \$2.' prints

          This is bar.

   Using the `nx' and `rd' requests, it is easy to set up form letters.
The form letter template is constructed like this, putting the
following lines into a file called `repeat.let':

     .ce
     \*(td
     .sp 2
     .nf
     .rd
     .sp
     .rd
     .fi
     Body of letter.
     .bp
     .nx repeat.let

When this is run, a file containing the following lines should be
redirected in.  Note that requests included in this file are executed
as though they were part of the form letter.  The last block of input
is the `ex' request which tells `groff' to stop processing.  If this
was not there, `groff' would not know when to stop.

     Trent A. Fisher
     708 NW 19th Av., #202
     Portland, OR  97209

     Dear Trent,

     Len Adollar
     4315 Sierra Vista
     San Diego, CA  92103

     Dear Mr. Adollar,

     .ex

 - Request: .pi pipe
     Pipe the output of `gtroff' to the shell command(s) specified by
     PIPE.  This request must occur before `gtroff' has a chance to
     print anything.

     `pi' causes an error if used in safer mode (which is the default).
     Use `groff''s or `troff''s `-U' option to activate unsafe mode.

     Multiple calls to `pi' are allowed, acting as a chain.  For
     example,

          .pi foo
          .pi bar
          ...

     is the same as `.pi foo | bar'.

     Note that the intermediate output format of `gtroff' is piped to
     the specified commands.  Consequently, calling `groff' without the
     `-Z' option normally causes a fatal error.

 - Request: .sy cmds
 - Register: \n[systat]
     Execute the shell command(s) specified by CMDS.  The output is not
     saved anyplace, so it is up to the user to do so.

     This request causes an error if used in safer mode (which is the
     default).  Use `groff''s or `troff''s `-U' option to activate
     unsafe mode.

     For example, the following code fragment introduces the current
     time into a document:

          .sy perl -e 'printf ".nr H %d\\n.nr M %d\\n.nr S %d\\n",\
          	     (localtime(time))[2,1,0]' > /tmp/x\n[$$]
          .so /tmp/x\n[$$]
          .sy rm /tmp/x\n[$$]
          \nH:\nM:\nS

     Note that this works by having the `perl' script (run by `sy')
     print out the `nr' requests which set the number registers `H',
     `M', and `S', and then reads those commands in with the `so'
     request.

     For most practical purposes, the number registers `seconds',
     `minutes', and `hours' which are initialized at start-up of
     `gtroff' should be sufficient.  Use the `af' request to get a
     formatted output:

          .af hours 00
          .af minutes 00
          .af seconds 00
          \n[hours]:\n[minutes]:\n[seconds]

     The `systat' read-write number register contains the return value
     of the `system()' function executed by the last `sy' request.

 - Request: .open stream file
 - Request: .opena stream file
     Open the specified FILE for writing and associates the specified
     STREAM with it.

     The `opena' request is like `open', but if the file exists, append
     to it instead of truncating it.

     Both `open' and `opena' cause an error if used in safer mode
     (which is the default).  Use `groff''s or `troff''s `-U' option to
     activate unsafe mode.

 - Request: .write stream data
 - Request: .writec stream data
     Write to the file associated with the specified STREAM.  The
     stream must previously have been the subject of an open request.
     The remainder of the line is interpreted as the `ds' request reads
     its second argument: A leading `"' is stripped, and it is read in
     copy-in mode.

     The `writec' request is like `write', but only `write' appends a
     newline to the data.

 - Request: .writem stream xx
     Write the contents of the macro or string XX to the file
     associated with the specified STREAM.

     XX is read in copy mode, i.e., already formatted elements are
     ignored.  Consequently, diversions must be unformatted with the
     `asciify' request before calling `writem'.  Usually, this means a
     loss of information.

 - Request: .close stream
     Close the specified STREAM; the stream is no longer an acceptable
     argument to the `write' request.

     Here a simple macro to write an index entry.

          .open idx test.idx
          .
          .de IX
          .  write idx \\n[%] \\$*
          ..
          .
          .IX test entry
          .
          .close idx

 - Escape: \VE
 - Escape: \V(EV
 - Escape: \V[ENV]
     Interpolate the contents of the specified environment variable ENV
     (one-character name E, two-character name EV) as returned by the
     function `getenv'.  `\V' is interpreted in copy-in mode.

Postprocessor Access
====================

   There are two escapes which give information directly to the
postprocessor.  This is particularly useful for embedding POSTSCRIPT
into the final document.

 - Escape: \X'XXX'
     Embeds its argument into the `gtroff' output preceded with `x X'.

     The escapes `\&', `\)', `\%', and `\:' are ignored within `\X',
     `\ ' and `\~' are converted to single space characters.  All other
     escapes (except `\\' which produces a backslash) cause an error.

     If the `use_charnames_in_special' keyword is set in the `DESC'
     file, special characters no longer cause an error; the name XX is
     represented as `\(XX)' in the `x X' output command.  Additionally,
     the backslash is represented as `\\'.

     `use_charnames_in_special' is currently used by `grohtml' only.

 - Escape: \YN
 - Escape: \Y(NM
 - Escape: \Y[NAME]
     This is approximately equivalent to `\X'\*[NAME]'' (one-character
     name N, two-character name NM).  However, the contents of the
     string or macro NAME are not interpreted; also it is permitted for
     NAME to have been defined as a macro and thus contain newlines (it
     is not permitted for the argument to `\X' to contain newlines).
     The inclusion of newlines requires an extension to the UNIX `troff'
     output format, and confuses drivers that do not know about this
     extension (see Device Control Commands).

   See Output Devices.

Miscellaneous
=============

   This section documents parts of `gtroff' which cannot (yet) be
categorized elsewhere in this manual.

 - Request: .nm [start [inc [space [indent]]]]
     Print line numbers.  START is the line number of the _next_ output
     line.  INC indicates which line numbers are printed.  For example,
     the value 5 means to emit only line numbers which are multiples
     of 5; this defaults to 1.  SPACE is the space to be left between
     the number and the text; this defaults to one digit space.  The
     fourth argument is the indentation of the line numbers, defaulting
     to zero.  Both SPACE and INDENT are given as multiples of digit
     spaces; they can be negative also.  Without any arguments, line
     numbers are turned off.

     `gtroff' reserves three digit spaces for the line number (which is
     printed right-justified) plus the amount given by INDENT; the
     output lines are concatenated to the line numbers, separated by
     SPACE, and _without_ reducing the line length.  Depending on the
     value of the horizontal page offset (as set with the `po'
     request), line numbers which are longer than the reserved space
     stick out to the left, or the whole line is moved to the right.

     Parameters corresponding to missing arguments are not changed; any
     non-digit argument (to be more precise, any argument starting with
     a character valid as a delimiter for identifiers) is also treated
     as missing.

     If line numbering has been disabled with a call to `nm' without an
     argument, it can be reactivated with `.nm +0', using the
     previously active line numbering parameters.

     The parameters of `nm' are associated with the current environment
     (see Environments).  The current output line number is
     available in the number register `ln'.

          .po 1m
          .ll 2i
          This test shows how line numbering works with groff.
          .nm 999
          This test shows how line numbering works with groff.
          .br
          .nm xxx 3 2
          .ll -\w'0'u
          This test shows how line numbering works with groff.
          .nn 2
          This test shows how line numbering works with groff.

     And here the result:

           This  test shows how
           line numbering works
           999 with   groff.   This
          1000 test shows how  line
          1001 numbering works with
          1002 groff.
                This test shows how
                line      numbering
           works  with  groff.
           This test shows how
          1005  line      numbering
                works with groff.

 - Request: .nn [skip]
     Temporarily turn off line numbering.  The argument is the number
     of lines not to be numbered; this defaults to 1.

 - Request: .mc glyph [dist]
     Print a "margin character" to the right of the text.(1) (
     1)  The first argument is the glyph to be
     printed.  The second argument is the distance away from the right
     margin.  If missing, the previously set value is used; default is
     10pt).  For text lines that are too long (that is, longer than the
     text length plus DIST), the margin character is directly appended
     to the lines.

     With no arguments the margin character is turned off.  If this
     occurs before a break, no margin character is printed.

     For empty lines and lines produced by the `tl' request no margin
     character is emitted.

     The margin character is associated with the current environment
     (see Environments).

     This is quite useful for indicating text that has changed, and, in
     fact, there are programs available for doing this (they are called
     `nrchbar' and `changebar' and can be found in any
     `comp.sources.unix' archive.

          .ll 3i
          .mc |
          This paragraph is highlighted with a margin
          character.
          .sp
          Note that vertical space isn't marked.
          .br
          \&
          .br
          But we can fake it with `\&'.

     Result:

          This  paragraph is highlighted |
          with a margin character.       |

          Note that vertical space isn't |
          marked.                        |
                                         |
          But we can fake it with `\&'.  |

 - Request: .psbb filename
 - Register: \n[llx]
 - Register: \n[lly]
 - Register: \n[urx]
 - Register: \n[ury]
     Retrieve the bounding box of the PostScript image found in
     FILENAME.  The file must conform to Adobe's "Document Structuring
     Conventions" (DSC); the command searches for a `%%BoundingBox'
     comment and extracts the bounding box values into the number
     registers `llx', `lly', `urx', and `ury'.  If an error occurs (for
     example, `psbb' cannot find the `%%BoundingBox' comment), it sets
     the four number registers to zero.

   (1) "Margin character" is a misnomer since it is an output glyph.

`gtroff' Internals
==================

   `gtroff' processes input in three steps.  One or more input
characters are converted to an "input token".(1) (1)
Then, one or more input tokens are converted
to an "output node".  Finally, output nodes are converted to the
intermediate output language understood by all output devices.

   Actually, before step one happens, `gtroff' converts certain escape
sequences into reserved input characters (not accessible by the user);
such reserved characters are used for other internal processing also -
this is the very reason why not all characters are valid input.  See
Identifiers, for more on this topic.

   For example, the input string `fi\[:u]' is converted into a
character token `f', a character token `i', and a special token `:u'
(representing u umlaut).  Later on, the character tokens `f' and `i'
are merged to a single output node representing the ligature glyph `fi'
(provided the current font has a glyph for this ligature); the same
happens with `:u'.  All output glyph nodes are `processed' which means
that they are invariably associated with a given font, font size,
advance width, etc.  During the formatting process, `gtroff' itself
adds various nodes to control the data flow.

   Macros, diversions, and strings collect elements in two chained
lists: a list of input tokens which have been passed unprocessed, and a
list of output nodes.  Consider the following the diversion.

     .di xxx
     a
     \!b
     c
     .br
     .di

It contains these elements.

node list            token list   element number
line start node      --           1
glyph node `a'       --           2
word space node      --           3
--                   `b'          4
--                   `\n'         5
glyph node `c'       --           6
vertical size node   --           7
vertical size node   --           8
--                   `\n'         9

Elements 1, 7, and 8 are inserted by `gtroff'; the latter two (which
are always present) specify the vertical extent of the last line,
possibly modified by `\x'.  The `br' request finishes the current
partial line, inserting a newline input token which is subsequently
converted to a space when the diversion is reread.  Note that the word
space node has a fixed width which isn't stretchable anymore.  To
convert horizontal space nodes back to input tokens, use the `unformat'
request.

   Macros only contain elements in the token list (and the node list is
empty); diversions and strings can contain elements in both lists.

   Note that the `chop' request simply reduces the number of elements
in a macro, string, or diversion by one.  Exceptions are "compatibility
save" and "compatibility ignore" input tokens which are ignored.  The
`substring' request also ignores those input tokens.

   Some requests like `tr' or `cflags' work on glyph identifiers only;
this means that the associated glyph can be changed without destroying
this association.  This can be very helpful for substituting glyphs.
In the following example, we assume that glyph `foo' isn't available by
default, so we provide a substitution using the `fchar' request and map
it to input character `x'.

     .fchar \[foo] foo
     .tr x \[foo]

Now let us assume that we install an additional special font `bar'
which has glyph `foo'.

     .special bar
     .rchar \[foo]

Since glyphs defined with `fchar' are searched before glyphs in special
fonts, we must call `rchar' to remove the definition of the fallback
glyph.  Anyway, the translation is still active; `x' now maps to the
real glyph `foo'.

   (1) Except the escapes `\f', `\F', `\H', `\m', `\M', `\R', `\s', and
`\S' which are processed immediately if not in copy-in mode.

Debugging
=========

   `gtroff' is not easy to debug, but there are some useful features
and strategies for debugging.

 - Request: .lf line filename
     Change the line number and the file name `gtroff' shall use for
     error and warning messages.  LINE is the input line number of the
     _next_ line.

     Without argument, the request is ignored.

     This is a debugging aid for documents which are split into many
     files, then put together with `soelim' and other preprocessors.
     Usually, it isn't invoked manually.

 - Request: .tm string
 - Request: .tm1 string
 - Request: .tmc string
     Send STRING to the standard error output; this is very useful for
     printing debugging messages among other things.

     STRING is read in copy mode.

     The `tm' request ignores leading spaces of STRING; `tm1' handles
     its argument similar to the `ds' request: a leading double quote
     in STRING is stripped to allow initial blanks.

     The `tmc' request is similar to `tm1' but does not append a
     newline (as is done in `tm' and `tm1').

 - Request: .ab [string]
     Similar to the `tm' request, except that it causes `gtroff' to
     stop processing.  With no argument it prints `User Abort.' to
     standard error.

 - Request: .ex
     The `ex' request also causes `gtroff' to stop processing; see also
     I/O.

   When doing something involved it is useful to leave the debugging
statements in the code and have them turned on by a command line flag.

     .if \n(DB .tm debugging output

To activate these statements say

     groff -rDB=1 file

   If it is known in advance that there will be many errors and no
useful output, `gtroff' can be forced to suppress formatted output with
the `-z' flag.

 - Request: .pm
     Print the entire symbol table on `stderr'.  Names of all defined
     macros, strings, and diversions are print together with their size
     in bytes.  Since `gtroff' sometimes adds nodes by itself, the
     returned size can be larger than expected.

     This request differs from UNIX `troff': `gtroff' reports the sizes
     of diversions, ignores an additional argument to print only the
     total of the sizes, and the size isn't returned in blocks of 128
     characters.

 - Request: .pnr
     Print the names and contents of all currently defined number
     registers on `stderr'.

 - Request: .ptr
     Print the names and positions of all traps (not including input
     line traps and diversion traps) on `stderr'.  Empty slots in the
     page trap list are printed as well, because they can affect the
     priority of subsequently planted traps.

 - Request: .fl
     Instruct `gtroff' to flush its output immediately.  The intent is
     for interactive use, but this behaviour is currently not
     implemented in `gtroff'.  Contrary to UNIX `troff', TTY output is
     sent to a device driver also (`grotty'), making it non-trivial to
     communicate interactively.

     This request causes a line break.

 - Request: .backtrace
     Print a backtrace of the input stack to the standard error stream.

     Consider the following in file `test':

          .de xxx
          .  backtrace
          ..
          .de yyy
          .  xxx
          ..
          .
          .yyy

     On execution, `gtroff' prints the following:

          test:2: backtrace: macro `xxx'
          test:5: backtrace: macro `yyy'
          test:8: backtrace: file `test'

     The option `-b' of `gtroff' internally calls a variant of this
     request on each error and warning.

 - Register: \n[slimit]
     Use the `slimit' number register to set the maximum number of
     objects on the input stack.  If `slimit' is less than or equal
     to 0, there is no limit set.  With no limit, a buggy recursive
     macro can exhaust virtual memory.

     The default value is 1000; this is a compile-time constant.

 - Request: .warnscale si
     Set the scaling indicator used in warnings to SI.  Valid values for
     SI are `u', `i', `c', `p', and `P'.  At startup, it is set to `i'.

 - Request: .spreadwarn [limit]
     Make `gtroff' emit a warning if the additional space inserted for
     each space between words in an output line is larger or equal to
     LIMIT.  A negative value is changed to zero; no argument toggles
     the warning on and off without changing LIMIT.  The default scaling
     indicator is `m'.  At startup, `spreadwarn' is deactivated, and
     LIMIT is set to 3m.

     For example,

          .spreadwarn 0.2m

     will cause a warning if `gtroff' must add 0.2m or more for each
     interword space in a line.

     This request is active only if text is justified to both margins
     (using `.ad b').

   `gtroff' has command line options for printing out more warnings
(`-w') and for printing backtraces (`-b') when a warning or an error
occurs.  The most verbose level of warnings is `-ww'.

 - Request: .warn [flags]
 - Register: \n[.warn]
     Control the level of warnings checked for.  The FLAGS are the sum
     of the numbers associated with each warning that is to be enabled;
     all other warnings are disabled.  The number associated with each
     warning is listed below.  For example, `.warn 0' disables all
     warnings, and `.warn 1' disables all warnings except that about
     missing glyphs.  If no argument is given, all warnings are enabled.

     The read-only number register `.warn' contains the current warning
     level.

Warnings
--------

   The warnings that can be given to `gtroff' are divided into the
following categories.  The name associated with each warning is used by
the `-w' and `-W' options; the number is used by the `warn' request and
by the `.warn' register.

`char'
`1'
     Non-existent glyphs.(1) (1)  This is
     enabled by default.

`number'
`2'
     Invalid numeric expressions.  This is enabled by default.  See
     Expressions.

`break'
`4'
     In fill mode, lines which could not be broken so that their length
     was less than the line length.  This is enabled by default.

`delim'
`8'
     Missing or mismatched closing delimiters.

`el'
`16'
     Use of the `el' request with no matching `ie' request.  See
     if-else.

`scale'
`32'
     Meaningless scaling indicators.

`range'
`64'
     Out of range arguments.

`syntax'
`128'
     Dubious syntax in numeric expressions.

`di'
`256'
     Use of `di' or `da' without an argument when there is no current
     diversion.

`mac'
`512'
     Use of undefined strings, macros and diversions.  When an undefined
     string, macro, or diversion is used, that string is automatically
     defined as empty.  So, in most cases, at most one warning is given
     for each name.

`reg'
`1024'
     Use of undefined number registers.  When an undefined number
     register is used, that register is automatically defined to have a
     value of 0.  So, in most cases, at most one warning is given for
     use of a particular name.

`tab'
`2048'
     Use of a tab character where a number was expected.

`right-brace'
`4096'
     Use of `\}' where a number was expected.

`missing'
`8192'
     Requests that are missing non-optional arguments.

`input'
`16384'
     Invalid input characters.

`escape'
`32768'
     Unrecognized escape sequences.  When an unrecognized escape
     sequence `\X' is encountered, the escape character is ignored, and
     X is printed.

`space'
`65536'
     Missing space between a request or macro and its argument.  This
     warning is given when an undefined name longer than two characters
     is encountered, and the first two characters of the name make a
     defined name.  The request or macro is not invoked.  When this
     warning is given, no macro is automatically defined.  This is
     enabled by default.  This warning never occurs in compatibility
     mode.

`font'
`131072'
     Non-existent fonts.  This is enabled by default.

`ig'
`262144'
     Invalid escapes in text ignored with the `ig' request.  These are
     conditions that are errors when they do not occur in ignored text.

`color'
`524288'
     Color related warnings.

`all'
     All warnings except `di', `mac' and `reg'.  It is intended that
     this covers all warnings that are useful with traditional macro
     packages.

`w'
     All warnings.

   (1) `char' is a misnomer since it reports missing glyphs - there
aren't missing input characters, only invalid ones.

Implementation Differences
==========================

   GNU `troff' has a number of features which cause incompatibilities
with documents written with old versions of `troff'.

   Long names cause some incompatibilities.  UNIX `troff' interprets

     .dsabcd

as defining a string `ab' with contents `cd'.  Normally, GNU `troff'
interprets this as a call of a macro named `dsabcd'.  Also UNIX `troff'
interprets `\*[' or `\n[' as references to a string or number register
called `['.  In GNU `troff', however, this is normally interpreted as
the start of a long name.  In compatibility mode GNU `troff' interprets
long names in the traditional way (which means that they are not
recognized as names).

 - Request: .cp [n]
 - Request: .do cmd
 - Register: \n[.C]
     If N is missing or non-zero, turn on compatibility mode;
     otherwise, turn it off.

     The read-only number register `.C' is 1 if compatibility mode is
     on, 0 otherwise.

     Compatibility mode can be also turned on with the `-C' command line
     option.

     The `do' request turns off compatibility mode while executing its
     arguments as a `gtroff' command.

          .do fam T

     executes the `fam' request when compatibility mode is enabled.

     `gtroff' restores the previous compatibility setting before
     interpreting any files sourced by the CMD.

   Two other features are controlled by `-C'.  If not in compatibility
mode, GNU `troff' preserves the input level in delimited arguments:

     .ds xx '
     \w'abc\*(xxdef'

In compatibility mode, the string `72def'' is returned; without `-C'
the resulting string is `168' (assuming a TTY output device).

   Finally, the escapes `\f', `\H', `\m', `\M', `\R', `\s', and `\S'
are transparent for recognizing the beginning of a line only in
compatibility mode (this is a rather obscure feature).  For example,
the code

     .de xx
     Hallo!
     ..
     \fB.xx\fP

   prints `Hallo!' in bold face if in compatibility mode, and `.xx' in
bold face otherwise.

   GNU `troff' does not allow the use of the escape sequences `\|',
`\^', `\&', `\{', `\}', `\<SP>', `\'', `\`', `\-', `\_', `\!', `\%',
and `\c' in names of strings, macros, diversions, number registers,
fonts or environments; UNIX `troff' does.  The `\A' escape sequence
(see Identifiers) may be helpful in avoiding use of these escape
sequences in names.

   Fractional point sizes cause one noteworthy incompatibility.  In
UNIX `troff' the `ps' request ignores scale indicators and thus

     .ps 10u

sets the point size to 10 points, whereas in GNU `troff' it sets the
point size to 10 scaled points.  See Fractional Type Sizes, for
more information.

   In GNU `troff' there is a fundamental difference between
(unformatted) input characters and (formatted) output glyphs.
Everything that affects how a glyph is output is stored with the glyph
node; once a glyph node has been constructed it is unaffected by any
subsequent requests that are executed, including `bd', `cs', `tkf',
`tr', or `fp' requests.  Normally glyphs are constructed from input
characters at the moment immediately before the glyph is added to the
current output line.  Macros, diversions and strings are all, in fact,
the same type of object; they contain lists of input characters and
glyph nodes in any combination.  A glyph node does not behave like an
input character for the purposes of macro processing; it does not
inherit any of the special properties that the input character from
which it was constructed might have had.  For example,

     .di x
     \\\\
     .br
     .di
     .x

prints `\\' in GNU `troff'; each pair of input backslashes is turned
into one output backslash and the resulting output backslashes are not
interpreted as escape characters when they are reread.  UNIX `troff'
would interpret them as escape characters when they were reread and
would end up printing one `\'.  The correct way to obtain a printable
backslash is to use the `\e' escape sequence: This always prints a
single instance of the current escape character, regardless of whether
or not it is used in a diversion; it also works in both GNU `troff' and
UNIX `troff'.(1) (1)  To
store, for some reason, an escape sequence in a diversion that will be
interpreted when the diversion is reread, either use the traditional
`\!' transparent output facility, or, if this is unsuitable, the new
`\?' escape sequence.

   See Diversions, and Gtroff Internals, for more
information.

   (1) To be completely independent of the current escape character,
use `\(rs' which represents a reverse solidus (backslash) glyph.

Preprocessors
*************

   This chapter describes all preprocessors that come with `groff' or
which are freely available.

`geqn'
======

Invoking `geqn'
---------------

`gtbl'
======

Invoking `gtbl'
---------------

`gpic'
======

Invoking `gpic'
---------------

`ggrn'
======

Invoking `ggrn'
---------------

`grap'
======

   A free implementation of `grap', written by Ted Faber, is available
as an extra package from the following address:

     <http://www.lunabase.org/~faber/Vault/software/grap/>

`grefer'
========

Invoking `grefer'
-----------------

`gsoelim'
=========

Invoking `gsoelim'
------------------

Output Devices
**************

Special Characters
==================

   See Font Files.

`grotty'
========

Invoking `grotty'
-----------------

`grops'
=======

Invoking `grops'
----------------

Embedding POSTSCRIPT
--------------------

`grodvi'
========

Invoking `grodvi'
-----------------

`grolj4'
========

Invoking `grolj4'
-----------------

`grolbp'
========

Invoking `grolbp'
-----------------

`grohtml'
=========

Invoking `grohtml'
------------------

`grohtml' specific registers and strings
----------------------------------------

 - Register: \n[ps4html]
 - String: \*[www-image-template]
     The registers `ps4html' and `www-image-template' are defined by
     the `pre-grohtml' preprocessor.  `pre-grohtml' reads in the
     `troff' input, marks up the inline equations and passes the result
     firstly to

          troff -Tps -rps4html=1 -dwww-image-template=TEMPLATE

     and secondly to

          troff -Thtml

     The PostScript device is used to create all the image files, and
     the register `ps4html' enables the macro sets to ignore floating
     keeps, footers, and headings.

     The register `www-image-template' is set to the user specified
     template name or the default name.

`gxditview'
===========

Invoking `gxditview'
--------------------

File formats
************

   All files read and written by `gtroff' are text files.  The
following two sections describe their format.

`gtroff' Output
===============

   This section describes the intermediate output format of GNU
`troff'.  This output is produced by a run of `gtroff' before it is fed
into a device postprocessor program.

   As `groff' is a wrapper program around `gtroff' that automatically
calls a postprocessor, this output does not show up normally.  This is
why it is called "intermediate".  `groff' provides the option `-Z' to
inhibit postprocessing, such that the produced intermediate output is
sent to standard output just like calling `gtroff' manually.

   Here, the term "troff output" describes what is output by `gtroff',
while "intermediate output" refers to the language that is accepted by
the parser that prepares this output for the postprocessors.  This
parser is smarter on whitespace and implements obsolete elements for
compatibility, otherwise both formats are the same.(1) (1)

   The main purpose of the intermediate output concept is to facilitate
the development of postprocessors by providing a common programming
interface for all devices.  It has a language of its own that is
completely different from the `gtroff' language.  While the `gtroff'
language is a high-level programming language for text processing, the
intermediate output language is a kind of low-level assembler language
by specifying all positions on the page for writing and drawing.

   The intermediate output produced by `gtroff' is fairly readable,
while output from AT&T `troff' is rather hard to understand because of
strange habits that are still supported, but not used any longer by
`gtroff'.

   (1) The parser and postprocessor for intermediate output can be
found in the file
`GROFF-SOURCE-DIR/src/libs/libdriver/input.cc'.

Language Concepts
-----------------

   During the run of `gtroff', the input data is cracked down to the
information on what has to be printed at what position on the intended
device.  So the language of the intermediate output format can be quite
small.  Its only elements are commands with and without arguments.  In
this section, the term "command" always refers to the intermediate
output language, and never to the `gtroff' language used for document
formatting.  There are commands for positioning and text writing, for
drawing, and for device controlling.

Separation
..........

   AT&T `troff' output has strange requirements on whitespace.  The
`gtroff' output parser, however, is smart about whitespace by making it
maximally optional.  The whitespace characters, i.e., the tab, space,
and newline characters, always have a syntactical meaning.  They are
never printable because spacing within the output is always done by
positioning commands.

   Any sequence of space or tab characters is treated as a single
"syntactical space".  It separates commands and arguments, but is only
required when there would occur a clashing between the command code and
the arguments without the space.  Most often, this happens when
variable-length command names, arguments, argument lists, or command
clusters meet.  Commands and arguments with a known, fixed length need
not be separated by syntactical space.

   A line break is a syntactical element, too.  Every command argument
can be followed by whitespace, a comment, or a newline character.  Thus
a "syntactical line break" is defined to consist of optional
syntactical space that is optionally followed by a comment, and a
newline character.

   The normal commands, those for positioning and text, consist of a
single letter taking a fixed number of arguments.  For historical
reasons, the parser allows to stack such commands on the same line, but
fortunately, in `gtroff''s intermediate output, every command with at
least one argument is followed by a line break, thus providing
excellent readability.

   The other commands - those for drawing and device controlling - have
a more complicated structure; some recognize long command names, and
some take a variable number of arguments.  So all `D' and `x' commands
were designed to request a syntactical line break after their last
argument.  Only one command, `x X', has an argument that can stretch
over several lines; all other commands must have all of their arguments
on the same line as the command, i.e., the arguments may not be
splitted by a line break.

   Empty lines (these are lines containing only space and/or a
comment), can occur everywhere.  They are just ignored.

Argument Units
..............

   Some commands take integer arguments that are assumed to represent
values in a measurement unit, but the letter for the corresponding
scale indicator is not written with the output command arguments.  Most
commands assume the scale indicator `u', the basic unit of the device,
some use `z', the scaled point unit of the device, while others, such
as the color commands, expect plain integers.

   Note that single characters can have the eighth bit set, as can the
names of fonts and special characters.  The names of characters and
fonts can be of arbitrary length.  A character that is to be printed
will always be in the current font.

   A string argument is always terminated by the next whitespace
character (space, tab, or newline); an embedded `#' character is
regarded as part of the argument, not as the beginning of a comment
command.  An integer argument is already terminated by the next
non-digit character, which then is regarded as the first character of
the next argument or command.

Document Parts
..............

   A correct intermediate output document consists of two parts, the
"prologue" and the "body".

   The task of the prologue is to set the general device parameters
using three exactly specified commands.  `gtroff''s prologue is
guaranteed to consist of the following three lines (in that order):

     x T DEVICE
     x res N H V
     x init

with the arguments set as outlined in Device Control Commands.
Note that the parser for the intermediate output format is able to
swallow additional whitespace and comments as well even in the prologue.

   The body is the main section for processing the document data.
Syntactically, it is a sequence of any commands different from the ones
used in the prologue.  Processing is terminated as soon as the first
`x stop' command is encountered; the last line of any `gtroff'
intermediate output always contains such a command.

   Semantically, the body is page oriented.  A new page is started by a
`p' command.  Positioning, writing, and drawing commands are always
done within the current page, so they cannot occur before the first `p'
command.  Absolute positioning (by the `H' and `V' commands) is done
relative to the current page; all other positioning is done relative to
the current location within this page.

Command Reference
-----------------

   This section describes all intermediate output commands, both from
AT&T `troff' as well as the `gtroff' extensions.

Comment Command
...............

`#ANYTHING<end of line>'
     A comment.  Ignore any characters from the `#' character up to the
     next newline character.

     This command is the only possibility for commenting in the
     intermediate output.  Each comment can be preceded by arbitrary
     syntactical space; every command can be terminated by a comment.

Simple Commands
...............

   The commands in this subsection have a command code consisting of a
single character, taking a fixed number of arguments.  Most of them are
commands for positioning and text writing.  These commands are smart
about whitespace.  Optionally, syntactical space can be inserted
before, after, and between the command letter and its arguments.  All
of these commands are stackable, i.e., they can be preceded by other
simple commands or followed by arbitrary other commands on the same
line.  A separating syntactical space is only necessary when two
integer arguments would clash or if the preceding argument ends with a
string argument.

`C XXX<whitespace>'
     Print a special character named XXX.  The trailing syntactical
     space or line break is necessary to allow glyph names of arbitrary
     length.  The glyph is printed at the current print position; the
     glyph's size is read from the font file.  The print position is
     not changed.

`c G'
     Print glyph G at the current print position;(1) (1)
     the glyph's size is read from the font
     file.  The print position is not changed.

`f N'
     Set font to font number N (a non-negative integer).

`H N'
     Move right to the absolute vertical position N (a non-negative
     integer in basic units `u' relative to left edge of current page.

`h N'
     Move N (a non-negative integer) basic units `u' horizontally to
     the right.  The original UNIX troff manual allows negative values
     for N also, but `gtroff' doesn't use this.

`m COLOR-SCHEME [COMPONENT ...]'
     Set the color for text (glyphs), line drawing, and the outline of
     graphic objects using different color schemes; the analoguous
     command for the filling color of graphic objects is `DF'.  The
     color components are specified as integer arguments between 0 and
     65536.  The number of color components and their meaning vary for
     the different color schemes.  These commands are generated by
     `gtroff''s escape sequence `\m'.  No position changing.  These
     commands are a `gtroff' extension.

    `mc CYAN MAGENTA YELLOW'
          Set color using the CMY color scheme, having the 3 color
          components CYAN, MAGENTA, and YELLOW.

    `md'
          Set color to the default color value (black in most cases).
          No component arguments.

    `mg GRAY'
          Set color to the shade of gray given by the argument, an
          integer between 0 (black) and 65536 (white).

    `mk CYAN MAGENTA YELLOW BLACK'
          Set color using the CMYK color scheme, having the 4 color
          components CYAN, MAGENTA, YELLOW, and BLACK.

    `mr RED GREEN BLUE'
          Set color using the RGB color scheme, having the 3 color
          components RED, GREEN, and BLUE.

`N N'
     Print glyph with index N (a non-negative integer) of the current
     font.  This command is a `gtroff' extension.

`n B A'
     Inform the device about a line break, but no positioning is done by
     this command.  In AT&T `troff', the integer arguments B and A
     informed about the space before and after the current line to make
     the intermediate output more human readable without performing any
     action.  In `groff', they are just ignored, but they must be
     provided for compatibility reasons.

`p N'
     Begin a new page in the outprint.  The page number is set to N.
     This page is completely independent of pages formerly processed
     even if those have the same page number.  The vertical position on
     the outprint is automatically set to 0.  All positioning, writing,
     and drawing is always done relative to a page, so a `p' command
     must be issued before any of these commands.

`s N'
     Set point size to N scaled points (this is unit `z').  AT&T
     `troff' used the unit points (`p') instead.  See Output Language Compatibility.

`t XXX<whitespace>'
`t XXX DUMMY-ARG<whitespace>'
     Print a word, i.e., a sequence of characters XXX representing
     output glyphs which names are single characters, terminated by a
     space character or a line break; an optional second integer
     argument is ignored (this allows the formatter to generate an even
     number of arguments).  The first glyph should be printed at the
     current position, the current horizontal position should then be
     increased by the width of the first glyph, and so on for each
     glyph.  The widths of the glyphs are read from the font file,
     scaled for the current point size, and rounded to a multiple of
     the horizontal resolution.  Special characters cannot be printed
     using this command (use the `C' command for special characters).
     This command is a `gtroff' extension; it is only used for devices
     whose `DESC' file contains the `tcommand' keyword (see DESC File Format).

`u N XXX<whitespace>'
     Print word with track kerning.  This is the same as the `t'
     command except that after printing each glyph, the current
     horizontal position is increased by the sum of the width of that
     glyph and N (an integer in basic units `u').  This command is a
     `gtroff' extension; it is only used for devices whose `DESC' file
     contains the `tcommand' keyword (see DESC File Format).

`V N'
     Move down to the absolute vertical position N (a non-negative
     integer in basic units `u') relative to upper edge of current page.

`v N'
     Move N basic units `u' down (N is a non-negative integer).  The
     original UNIX troff manual allows negative values for N also, but
     `gtroff' doesn't use this.

`w'
     Informs about a paddable white space to increase readability.  The
     spacing itself must be performed explicitly by a move command.

   (1) `c' is actually a misnomer since it outputs a glyph.

Graphics Commands
.................

   Each graphics or drawing command in the intermediate output starts
with the letter `D', followed by one or two characters that specify a
subcommand; this is followed by a fixed or variable number of integer
arguments that are separated by a single space character.  A `D'
command may not be followed by another command on the same line (apart
from a comment), so each `D' command is terminated by a syntactical
line break.

   `gtroff' output follows the classical spacing rules (no space
between command and subcommand, all arguments are preceded by a single
space character), but the parser allows optional space between the
command letters and makes the space before the first argument optional.
As usual, each space can be any sequence of tab and space characters.

   Some graphics commands can take a variable number of arguments.  In
this case, they are integers representing a size measured in basic
units `u'.  The arguments called H1, H2, ..., HN stand for horizontal
distances where positive means right, negative left.  The arguments
called V1, V2, ..., VN stand for vertical distances where positive
means down, negative up.  All these distances are offsets relative to
the current location.

   Unless indicated otherwise, each graphics command directly
corresponds to a similar `gtroff' `\D' escape sequence.  See Drawing Requests.

   Unknown `D' commands are assumed to be device-specific.  Its
arguments are parsed as strings; the whole information is then sent to
the postprocessor.

   In the following command reference, the syntax element <line break>
means a syntactical line break as defined above.

`D~ H1 V1 H2 V2 ... HN VN<line break>'
     Draw B-spline from current position to offset (H1,V1), then to
     offset (H2,V2), if given, etc. up to (HN,VN).  This command takes
     a variable number of argument pairs; the current position is moved
     to the terminal point of the drawn curve.

`Da H1 V1 H2 V2<line break>'
     Draw arc from current position to (H1,V1)+(H2,V2) with center at
     (H1,V1); then move the current position to the final point of the
     arc.

`DC D<line break>'
`DC D DUMMY-ARG<line break>'
     Draw a solid circle using the current fill color with diameter D
     (integer in basic units `u') with leftmost point at the current
     position; then move the current position to the rightmost point of
     the circle.  An optional second integer argument is ignored (this
     allows the formatter to generate an even number of arguments).
     This command is a `gtroff' extension.

`Dc D<line break>'
     Draw circle line with diameter D (integer in basic units `u') with
     leftmost point at the current position; then move the current
     position to the rightmost point of the circle.

`DE H V<line break>'
     Draw a solid ellipse in the current fill color with a horizontal
     diameter of H and a vertical diameter of V (both integers in basic
     units `u') with the leftmost point at the current position; then
     move to the rightmost point of the ellipse.  This command is a
     `gtroff' extension.

`De H V<line break>'
     Draw an outlined ellipse with a horizontal diameter of H and a
     vertical diameter of V (both integers in basic units `u') with the
     leftmost point at current position; then move to the rightmost
     point of the ellipse.

`DF COLOR-SCHEME [COMPONENT ...]<line break>'
     Set fill color for solid drawing objects using different color
     schemes; the analoguous command for setting the color of text, line
     graphics, and the outline of graphic objects is `m'.  The color
     components are specified as integer arguments between 0 and 65536.
     The number of color components and their meaning vary for the
     different color schemes.  These commands are generated by
     `gtroff''s escape sequences `\D'F ...'' and `\M' (with no other
     corresponding graphics commands).  No position changing.  This
     command is a `gtroff' extension.

    `DFc CYAN MAGENTA YELLOW<line break>'
          Set fill color for solid drawing objects using the CMY color
          scheme, having the 3 color components CYAN, MAGENTA, and
          YELLOW.

    `DFd<line break>'
          Set fill color for solid drawing objects to the default fill
          color value (black in most cases).  No component arguments.

    `DFg GRAY<line break>'
          Set fill color for solid drawing objects to the shade of gray
          given by the argument, an integer between 0 (black) and 65536
          (white).

    `DFk CYAN MAGENTA YELLOW BLACK<line break>'
          Set fill color for solid drawing objects using the CMYK color
          scheme, having the 4 color components CYAN, MAGENTA, YELLOW,
          and BLACK.

    `DFr RED GREEN BLUE<line break>'
          Set fill color for solid drawing objects using the RGB color
          scheme, having the 3 color components RED, GREEN, and BLUE.

`Df N<line break>'
     The argument N must be an integer in the range -32767 to 32767.

    0 <= N <= 1000
          Set the color for filling solid drawing objects to a shade of
          gray, where 0 corresponds to solid white, 1000 (the default)
          to solid black, and values in between to intermediate shades
          of gray; this is obsoleted by command `DFg'.

    N < 0 or N < 1000
          Set the filling color to the color that is currently being
          used for the text and the outline, see command `m'.  For
          example, the command sequence

               mg 0 0 65536
               Df -1

          sets all colors to blue.

     No position changing.  This command is a `gtroff' extension.

`Dl H V<line break>'
     Draw line from current position to offset (H,V) (integers in basic
     units `u'); then set current position to the end of the drawn line.

`Dp H1 V1 H2 V2 ... HN VN<line break>'
     Draw a polygon line from current position to offset (H1,V1), from
     there to offset (H2,V2), etc. up to offset (HN,VN), and from there
     back to the starting position.  For historical reasons, the
     position is changed by adding the sum of all arguments with odd
     index to the actual horizontal position and the even ones to the
     vertical position.  Although this doesn't make sense it is kept
     for compatibility.  This command is a `gtroff' extension.

`Dp H1 V1 H2 V2 ... HN VN<line break>'
     Draw a solid polygon in the current fill color rather than an
     outlined polygon, using the same arguments and positioning as the
     corresponding `Dp' command.  This command is a `gtroff' extension.

`Dt N<line break>'
     Set the current line thickness to N (an integer in basic units
     `u') if N>0; if N=0 select the smallest available line thickness;
     if N<0 set the line thickness proportional to the point size (this
     is the default before the first `Dt' command was specified).  For
     historical reasons, the horizontal position is changed by adding
     the argument to the actual horizontal position, while the vertical
     position is not changed.  Although this doesn't make sense it is
     kept for compatibility.  This command is a `gtroff' extension.

Device Control Commands
.......................

   Each device control command starts with the letter `x', followed by
a space character (optional or arbitrary space or tab in `gtroff') and
a subcommand letter or word; each argument (if any) must be preceded by
a syntactical space.  All `x' commands are terminated by a syntactical
line break; no device control command can be followed by another
command on the same line (except a comment).

   The subcommand is basically a single letter, but to increase
readability, it can be written as a word, i.e., an arbitrary sequence
of characters terminated by the next tab, space, or newline character.
All characters of the subcommand word but the first are simply ignored.
For example, `gtroff' outputs the initialization command `x i' as
`x init' and the resolution command `x r' as `x res'.

   In the following, the syntax element <line break> means a
syntactical line break (see Separation).

`xF NAME<line break>'
     The `F' stands for FILENAME.

     Use NAME as the intended name for the current file in error
     reports.  This is useful for remembering the original file name
     when `gtroff' uses an internal piping mechanism.  The input file is
     not changed by this command.  This command is a `gtroff' extension.

`xf N S<line break>'
     The `f' stands for FONT.

     Mount font position N (a non-negative integer) with font named S
     (a text word).  See Font Positions.

`xH N<line break>'
     The `H' stands for HEIGHT.

     Set glyph height to N (a positive integer in scaled points `z').
     AT&T `troff' uses the unit points (`p') instead.  See Output Language Compatibility.

`xi<line break>'
     The `i' stands for INIT.

     Initialize device.  This is the third command of the prologue.

`xp<line break>'
     The `p' stands for PAUSE.

     Parsed but ignored.  The original UNIX troff manual writes

          pause device, can be restarted

`xr N H V<line break>'
     The `r' stands for RESOLUTION.

     Resolution is N, while H is the minimal horizontal motion, and V
     the minimal vertical motion possible with this device; all
     arguments are positive integers in basic units `u' per inch.  This
     is the second command of the prologue.

`xS N<line break>'
     The `S' stands for SLANT.

     Set slant to N (an integer in basic units `u').

`xs<line break>'
     The `s' stands for STOP.

     Terminates the processing of the current file; issued as the last
     command of any intermediate troff output.

`xt<line break>'
     The `t' stands for TRAILER.

     Generate trailer information, if any.  In GTROFF, this is actually
     just ignored.

`xT XXX<line break>'
     The `T' stands for TYPESETTER.

     Set name of device to word XXX, a sequence of characters ended by
     the next white space character.  The possible device names coincide
     with those from the `groff' `-T' option.  This is the first
     command of the prologue.

`xu N<line break>'
     The `u' stands for UNDERLINE.

     Configure underlining of spaces.  If N is 1, start underlining of
     spaces; if N is 0, stop underlining of spaces.  This is needed for
     the `cu' request in nroff mode and is ignored otherwise.  This
     command is a `gtroff' extension.

`xX ANYTHING<line break>'
     The `x' stands for X-ESCAPE.

     Send string ANYTHING uninterpreted to the device.  If the line
     following this command starts with a `+' character this line is
     interpreted as a continuation line in the following sense.  The
     `+' is ignored, but a newline character is sent instead to the
     device, the rest of the line is sent uninterpreted.  The same
     applies to all following lines until the first character of a line
     is not a `+' character.  This command is generated by the `gtroff'
     escape sequence `\X'.  The line-continuing feature is a `gtroff'
     extension.

Obsolete Command
................

   In AT&T `troff' output, the writing of a single glyph is mostly done
by a very strange command that combines a horizontal move and a single
character giving the glyph name.  It doesn't have a command code, but
is represented by a 3-character argument consisting of exactly 2 digits
and a character.

DDG
     Move right DD (exactly two decimal digits) basic units `u', then
     print glyph G (represented as a single character).

     In `gtroff', arbitrary syntactical space around and within this
     command is allowed to be added.  Only when a preceding command on
     the same line ends with an argument of variable length a
     separating space is obligatory.  In AT&T `troff', large clusters
     of these and other commands are used, mostly without spaces; this
     made such output almost unreadable.

   For modern high-resolution devices, this command does not make sense
because the width of the glyphs can become much larger than two decimal
digits.  In `gtroff', this is only used for the devices `X75',
`X75-12', `X100', and `X100-12'.  For other devices, the commands `t'
and `u' provide a better functionality.

Intermediate Output Examples
----------------------------

   This section presents the intermediate output generated from the same
input for three different devices.  The input is the sentence `hell
world' fed into `gtroff' on the command line.

High-resolution device `ps'
     This is the standard output of `gtroff' if no `-T' option is given.

          shell> echo "hell world" | groff -Z -T ps

          x T ps
          x res 72000 1 1
          x init
          p1
          x font 5 TR
          f5
          s10000
          V12000
          H72000
          thell
          wh2500
          tw
          H96620
          torld
          n12000 0
          x trailer
          V792000
          x stop

     This output can be fed into `grops' to get its representation as a
     PostScript file.

Low-resolution device `latin1'
     This is similar to the high-resolution device except that the
     positioning is done at a minor scale.  Some comments (lines
     starting with `#') were added for clarification; they were not
     generated by the formatter.

          shell> echo "hell world" | groff -Z -T latin1

          # prologue
          x T latin1
          x res 240 24 40
          x init
          # begin a new page
          p1
          # font setup
          x font 1 R
          f1
          s10
          # initial positioning on the page
          V40
          H0
          # write text `hell'
          thell
          # inform about space, and issue a horizontal jump
          wh24
          # write text `world'
          tworld
          # announce line break, but do nothing because ...
          n40 0
          # ... the end of the document has been reached
          x trailer
          V2640
          x stop

     This output can be fed into `grotty' to get a formatted text
     document.

AT&T `troff' output
     Since a computer monitor has a very low resolution compared to
     modern printers the intermediate output for the X Window devices
     can use the jump-and-write command with its 2-digit displacements.

          shell> echo "hell world" | groff -Z -T X100

          x T X100
          x res 100 1 1
          x init
          p1
          x font 5 TR
          f5
          s10
          V16
          H100
          # write text with jump-and-write commands
          ch07e07l03lw06w11o07r05l03dh7
          n16 0
          x trailer
          V1100
          x stop

     This output can be fed into `xditview' or `gxditview' for
     displaying in X.

     Due to the obsolete jump-and-write command, the text clusters in
     the AT&T `troff' output are almost unreadable.

Output Language Compatibility
-----------------------------

   The intermediate output language of AT&T `troff' was first
documented in the UNIX troff manual, with later additions documented in
`A Typesetter-indenpendent TROFF', written by Brian Kernighan.

   The `gtroff' intermediate output format is compatible with this
specification except for the following features.

   * The classical quasi device independence is not yet implemented.

   * The old hardware was very different from what we use today.  So the
     `groff' devices are also fundamentally different from the ones in
     AT&T `troff'.  For example, the AT&T PostScript device is called
     `post' and has a resolution of only 720 units per inch, suitable
     for printers 20 years ago, while `groff''s `ps' device has a
     resolution of 72000 units per inch.  Maybe, by implementing some
     rescaling mechanism similar to the classical quasi device
     independence, `groff' could emulate AT&T's `post' device.

   * The B-spline command `D~' is correctly handled by the intermediate
     output parser, but the drawing routines aren't implemented in some
     of the postprocessor programs.

   * The argument of the commands `s' and `x H' has the implicit unit
     scaled point `z' in `gtroff', while AT&T `troff' has point (`p').
     This isn't an incompatibility but a compatible extension, for both
     units coincide for all devices without a `sizescale' parameter in
     the `DESC' file, including all postprocessors from AT&T and
     `groff''s text devices.  The few `groff' devices with a
     `sizescale' parameter either do not exist for AT&T `troff', have a
     different name, or seem to have a different resolution.  So
     conflicts are very unlikely.

   * The position changing after the commands `Dp', `DP', and `Dt' is
     illogical, but as old versions of `gtroff' used this feature it is
     kept for compatibility reasons.

Font Files
==========

   The `gtroff' font format is roughly a superset of the `ditroff' font
format (as used in later versions of AT&T `troff' and its descendants).
Unlike the `ditroff' font format, there is no associated binary
format; all files are text files.(1) (1)
The font files for device NAME are stored in a directory `devNAME'.
There are two types of file: a device description file called `DESC'
and for each font F a font file called `F'.

   (1) Plan 9 `troff' has also abandoned the binary format.

`DESC' File Format
------------------

   The `DESC' file can contain the following types of line.  Except for
the `charset' keyword which must comes last (if at all), the order of
the lines is not important.

`res N'
     There are N machine units per inch.

`hor N'
     The horizontal resolution is N machine units.

`vert N'
     The vertical resolution is N machine units.

`sizescale N'
     The scale factor for point sizes.  By default this has a value
     of 1.  One scaled point is equal to one point/N.  The arguments to
     the `unitwidth' and `sizes' commands are given in scaled points.
     See Fractional Type Sizes, for more information.

`unitwidth N'
     Quantities in the font files are given in machine units for fonts
     whose point size is N scaled points.

`prepro PROGRAM'
     Call PROGRAM as a preprocessor.  Currently, this keyword is used
     by `groff' with option `-Thtml' only.

`postpro PROGRAM'
     Call PROGRAM as a postprocessor.  For example, the line

          postpro grodvi

     in the file `devdvi/DESC' makes `groff' call `grodvi' if option
     `-Tdvi' is given (and `-Z' isn't used).

`tcommand'
     This means that the postprocessor can handle the `t' and `u'
     intermediate output commands.

`sizes S1 S2 ... SN 0'
     This means that the device has fonts at S1, S2, ...  SN scaled
     points.  The list of sizes must be terminated by 0 (this is digit
     zero).  Each SI can also be a range of sizes M-N.  The list can
     extend over more than one line.

`styles S1 S2 ... SM'
     The first M font positions are associated with styles S1 ... SM.

`fonts N F1 F2 F3 ... FN'
     Fonts F1 ... FN are mounted in the font positions M+1, ..., M+N
     where M is the number of styles.  This command may extend over
     more than one line.  A font name of 0 means no font is mounted on
     the corresponding font position.

`family FAM'
     The default font family is FAM.

`use_charnames_in_special'
     This command indicates that `gtroff' should encode special
     characters inside special commands.  Currently, this is only used
     by the HTML output device.  See Postprocessor Access.

`papersize STRING ...'
     Select a paper size.  Valid values for STRING are the ISO paper
     types `A0'-`A7', `B0'-`B7', `C0'-`C7', `D0'-`D7', `DL', and the US
     paper types `letter', `legal', `tabloid', `ledger', `statement',
     `executive', `com10', and `monarch'.  Case is not significant for
     STRING if it holds predefined paper types.  Alternatively, STRING
     can be a file name (e.g. `/etc/papersize'); if the file can be
     opened, `groff' reads the first line and tests for the above paper
     sizes.  Finally, STRING can be a custom paper size in the format
     `LENGTH,WIDTH' (no spaces before and after the comma).  Both
     LENGTH and WIDTH must have a unit appended; valid values are `i'
     for inches, `C' for centimeters, `p' for points, and `P' for
     picas.  Example: `12c,235p'.  An argument which starts with a
     digit is always treated as a custom paper format.  `papersize'
     sets both the vertical and horizontal dimension of the output
     medium.

     More than one argument can be specified; `groff' scans from left to
     right and uses the first valid paper specification.

`pass_filenames'
     Tell `gtroff' to emit the name of the source file currently being
     processed.  This is achieved by the intermediate output command
     `F'.  Currently, this is only used by the HTML output device.

`print PROGRAM'
     Use PROGRAM as a spooler program for printing.  If omitted, the
     `-l' and `-L' options of `groff' are ignored.

`charset'
     This line and everything following in the file are ignored.  It is
     allowed for the sake of backwards compatibility.

   The `res', `unitwidth', `fonts', and `sizes' lines are mandatory.
Other commands are ignored by `gtroff' but may be used by
postprocessors to store arbitrary information about the device in the
`DESC' file.

   Here a list of obsolete keywords which are recognized by `groff' but
completely ignored: `spare1', `spare2', `biggestfont'.

Font File Format
----------------

   A "font file", also (and probably better) called a "font description
file", has two sections.  The first section is a sequence of lines each
containing a sequence of blank delimited words; the first word in the
line is a key, and subsequent words give a value for that key.

`name F'
     The name of the font is F.

`spacewidth N'
     The normal width of a space is N.

`slant N'
     The glyphs of the font have a slant of N degrees.  (Positive means
     forward.)

`ligatures LIG1 LIG2 ... LIGN [0]'
     Glyphs LIG1, LIG2, ..., LIGN are ligatures; possible ligatures are
     `ff', `fi', `fl', `ffi' and `ffl'.  For backwards compatibility,
     the list of ligatures may be terminated with a 0.  The list of
     ligatures may not extend over more than one line.

`special'
     The font is "special"; this means that when a glyph is requested
     that is not present in the current font, it is searched for in any
     special fonts that are mounted.

   Other commands are ignored by `gtroff' but may be used by
postprocessors to store arbitrary information about the font in the font
file.

   The first section can contain comments which start with the `#'
character and extend to the end of a line.

   The second section contains one or two subsections.  It must contain
a `charset' subsection and it may also contain a `kernpairs'
subsection.  These subsections can appear in any order.  Each
subsection starts with a word on a line by itself.

   The word `charset' starts the character set subsection.(1) (
1)  The `charset' line is followed by a
sequence of lines.  Each line gives information for one glyph.  A line
comprises a number of fields separated by blanks or tabs.  The format is

     NAME METRICS TYPE CODE [ENTITY-NAME] [`--' COMMENT]

NAME identifies the glyph name(2) (2):
If NAME is a single character C then it corresponds to the `gtroff'
input character C; if it is of the form `\C' where C is a single
character, then it corresponds to the special character `\[C]';
otherwise it corresponds to the special character `\[NAME]'.  If it is
exactly two characters XX it can be entered as `\(XX'.  Note that
single-letter special characters can't be accessed as `\C'; the only
exception is `\-' which is identical to `\[-]'.

   `gtroff' supports 8-bit input characters; however some utilities
have difficulties with eight-bit characters.  For this reason, there is
a convention that the entity name `charN' is equivalent to the single
input character whose code is N.  For example, `char163' would be
equivalent to the character with code 163 which is the pounds sterling
sign in the ISO Latin-1 character set.  You shouldn't use `charN'
entities in font description files since they are related to input, not
output.  Otherwise, you get hard-coded connections between input and
output encoding which prevents use of different (input) character sets.

   The name `---' is special and indicates that the glyph is unnamed;
such glyphs can only be used by means of the `\N' escape sequence in
`gtroff'.

   The TYPE field gives the glyph type:

`1'
     the glyph has a descender, for example, `p';

`2'
     the glyph has an ascender, for example, `b';

`3'
     the glyph has both an ascender and a descender, for example, `('.

   The CODE field gives the code which the postprocessor uses to print
the glyph.  The glyph can also be input to `gtroff' using this code by
means of the `\N' escape sequence.  CODE can be any integer.  If it
starts with `0' it is interpreted as octal; if it starts with `0x' or
`0X' it is interpreted as hexadecimal.  Note, however, that the `\N'
escape sequence only accepts a decimal integer.

   The ENTITY-NAME field gives an ASCII string identifying the glyph
which the postprocessor uses to print the `gtroff' glyph NAME.  This
field is optional and has been introduced so that the HTML device
driver can encode its character set.  For example, the glyph `\[Po]' is
represented as `&pound;' in HTML 4.0.

   Anything on the line after the ENTITY-NAME field resp. after `--'
will be ignored.

   The METRICS field has the form:

     WIDTH[`,'HEIGHT[`,'DEPTH[`,'ITALIC-CORRECTION
       [`,'LEFT-ITALIC-CORRECTION[`,'SUBSCRIPT-CORRECTION]]]]]

There must not be any spaces between these subfields (it has been split
here into two lines for better legibility only).  Missing subfields are
assumed to be 0.  The subfields are all decimal integers.  Since there
is no associated binary format, these values are not required to fit
into a variable of type `char' as they are in `ditroff'.  The WIDTH
subfield gives the width of the glyph.  The HEIGHT subfield gives the
height of the glyph (upwards is positive); if a glyph does not extend
above the baseline, it should be given a zero height, rather than a
negative height.  The DEPTH subfield gives the depth of the glyph, that
is, the distance from the baseline to the lowest point below the
baseline to which the glyph extends (downwards is positive); if a glyph
does not extend below the baseline, it should be given a zero depth,
rather than a negative depth.  The ITALIC-CORRECTION subfield gives the
amount of space that should be added after the glyph when it is
immediately to be followed by a glyph from a roman font.  The
LEFT-ITALIC-CORRECTION subfield gives the amount of space that should
be added before the glyph when it is immediately to be preceded by a
glyph from a roman font.  The SUBSCRIPT-CORRECTION gives the amount of
space that should be added after a glyph before adding a subscript.
This should be less than the italic correction.

   A line in the `charset' section can also have the format

     NAME "

This indicates that NAME is just another name for the glyph mentioned
in the preceding line.

   The word `kernpairs' starts the kernpairs section.  This contains a
sequence of lines of the form:

     C1 C2 N

This means that when glyph C1 appears next to glyph C2 the space
between them should be increased by N.  Most entries in the kernpairs
section have a negative value for N.

   (1) This keyword is misnamed since it starts a list of ordered
glyphs, not characters.

   (2) The distinction between input, characters, and output, glyphs,
is not clearly separated in the terminology of `groff'; for example,
the `char' request should be called `glyph' since it defines an output
entity.

Installation
************

Copying This Manual
*******************

GNU Free Documentation License
==============================

                        Version 1.1, March 2000
     Copyright (C) 2000 Free Software Foundation, Inc.
     59 Temple Place, Suite 330, Boston, MA  02111-1307, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     written document "free" in the sense of freedom: to assure everyone
     the effective freedom to copy and redistribute it, with or without
     modifying it, either commercially or noncommercially.  Secondarily,
     this License preserves for the author and publisher a way to get
     credit for their work, while not being considered responsible for
     modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.
     We recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work that contains a
     notice placed by the copyright holder saying it can be distributed
     under the terms of this License.  The "Document", below, refers to
     any such manual or work.  Any member of the public is a licensee,
     and is addressed as "you".

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter
     section of the Document that deals exclusively with the
     relationship of the publishers or authors of the Document to the
     Document's overall subject (or to related matters) and contains
     nothing that could fall directly within that overall subject.
     (For example, if the Document is in part a textbook of
     mathematics, a Secondary Section may not explain any mathematics.)
     The relationship could be a matter of historical connection with
     the subject or with related matters, or of legal, commercial,
     philosophical, ethical or political position regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in
     the notice that says that the Document is released under this
     License.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, whose contents can be viewed and edited directly
     and straightforwardly with generic text editors or (for images
     composed of pixels) generic paint programs or (for drawings) some
     widely available drawing editor, and that is suitable for input to
     text formatters or for automatic translation to a variety of
     formats suitable for input to text formatters.  A copy made in an
     otherwise Transparent file format whose markup has been designed
     to thwart or discourage subsequent modification by readers is not
     Transparent.  A copy that is not "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and
     standard-conforming simple HTML designed for human modification.
     Opaque formats include PostScript, PDF, proprietary formats that
     can be read and edited only by proprietary word processors, SGML
     or XML for which the DTD and/or processing tools are not generally
     available, and the machine-generated HTML produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow
     the conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies of the Document numbering more than
     100, and the Document's license notice requires Cover Texts, you
     must enclose the copies in covers that carry, clearly and legibly,
     all these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the
     title equally prominent and visible.  You may add other material
     on the covers in addition.  Copying with changes limited to the
     covers, as long as they preserve the title of the Document and
     satisfy these conditions, can be treated as verbatim copying in
     other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a
     machine-readable Transparent copy along with each Opaque copy, or
     state in or with each Opaque copy a publicly-accessible
     computer-network location containing a complete Transparent copy
     of the Document, free of added material, which the general
     network-using public has access to download anonymously at no
     charge using public-standard network protocols.  If you use the
     latter option, you must take reasonably prudent steps, when you
     begin distribution of Opaque copies in quantity, to ensure that
     this Transparent copy will remain thus accessible at the stated
     location until at least one year after the last time you
     distribute an Opaque copy (directly or through your agents or
     retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of
     copies, to give them a chance to provide you with an updated
     version of the Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with
     the Modified Version filling the role of the Document, thus
     licensing distribution and modification of the Modified Version to
     whoever possesses a copy of it.  In addition, you must do these
     things in the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of
          previous versions (which should, if there were any, be listed
          in the History section of the Document).  You may use the
          same title as a previous version if the original publisher of
          that version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has less than five).

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section entitled "History", and its title, and
          add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on
          the Title Page.  If there is no section entitled "History" in
          the Document, create one stating the title, year, authors,
          and publisher of the Document as given on its Title Page,
          then add an item describing the Modified Version as stated in
          the previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in
          the "History" section.  You may omit a network location for a
          work that was published at least four years before the
          Document itself, or if the original publisher of the version
          it refers to gives permission.

       K. In any section entitled "Acknowledgments" or "Dedications",
          preserve the section's title, and preserve in the section all
          the substance and tone of each of the contributor
          acknowledgments and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document,
          unaltered in their text and in their titles.  Section numbers
          or the equivalent are not considered part of the section
          titles.

       M. Delete any section entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section as "Endorsements" or to
          conflict in title with any Invariant Section.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option
     designate some or all of these sections as invariant.  To do this,
     add their titles to the list of Invariant Sections in the Modified
     Version's license notice.  These titles must be distinct from any
     other section titles.

     You may add a section entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end
     of the list of Cover Texts in the Modified Version.  Only one
     passage of Front-Cover Text and one of Back-Cover Text may be
     added by (or through arrangements made by) any one entity.  If the
     Document already includes a cover text for the same cover,
     previously added by you or by arrangement made by the same entity
     you are acting on behalf of, you may not add another; but you may
     replace the old one, on explicit permission from the previous
     publisher that added the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination
     all of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections entitled
     "History" in the various original documents, forming one section
     entitled "History"; likewise combine any sections entitled
     "Acknowledgments", and any sections entitled "Dedications".  You
     must delete all sections entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the
     documents in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow
     this License in all other respects regarding verbatim copying of
     that document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of
     a storage or distribution medium, does not as a whole count as a
     Modified Version of the Document, provided no compilation
     copyright is claimed for the compilation.  Such a compilation is
     called an "aggregate", and this License does not apply to the
     other self-contained works thus compiled with the Document, on
     account of their being thus compiled, if they are not themselves
     derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one
     quarter of the entire aggregate, the Document's Cover Texts may be
     placed on covers that surround only the Document within the
     aggregate.  Otherwise they must appear on covers around the whole
     aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License provided that you also include the
     original English version of this License.  In case of a
     disagreement between the translation and the original English
     version of this License, the original English version will prevail.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

 10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     `http://www.gnu.org/copyleft/'.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If
     the Document does not specify a version number of this License,
     you may choose any version ever published (not as a draft) by the
     Free Software Foundation.

ADDENDUM: How to use this License for your documents
----------------------------------------------------

   To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.1
       or any later version published by the Free Software Foundation;
       with the Invariant Sections being LIST THEIR TITLES, with the
       Front-Cover Texts being LIST, and with the Back-Cover Texts being LIST.
       A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have no Invariant Sections, write "with no Invariant Sections"
instead of saying which ones are invariant.  If you have no Front-Cover
Texts, write "no Front-Cover Texts" instead of "Front-Cover Texts being
LIST"; likewise for Back-Cover Texts.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License, to
permit their use in free software.

Request Index
*************

   Requests appear without the leading control character (normally
either `.' or `'').

Escape Index
************

   Any escape sequence `\X' with X not in the list below emits a
warning, printing glyph X.

Register Index
**************

   The macro package or program a specific register belongs to is
appended in brackets.

   A register name `x' consisting of exactly one character can be
accessed as `\nx'.  A register name `xx' consisting of exactly two
characters can be accessed as `\n(xx'.  Register names `xxx' of any
length can be accessed as `\n[xxx]'.

Macro Index
***********

   The macro package a specific macro belongs to is appended in
brackets.  They appear without the leading control character (normally
`.').

String Index
************

   The macro package or program a specific string belongs to is
appended in brackets.

   A string name `x' consisting of exactly one character can be
accessed as `\*x'.  A string name `xx' consisting of exactly two
characters can be accessed as `\*(xx'.  String names `xxx' of any
length can be accessed as `\*[xxx]'.

Glyph Name Index
****************

   A glyph name `xx' consisting of exactly two characters can be
accessed as `\(xx'.  Glyph names `xxx' of any length can be accessed as
`\[xxx]'.